=== modified file 'HACKING'
--- HACKING	2006-06-20 07:55:43 +0000
+++ HACKING	2006-06-06 22:59:58 +0000
@@ -282,19 +282,6 @@
     command changes it name or signature. Ideally only the tests for a
     given command are affected when a given command is changed.
 
-Doctests
---------
-
-We make selective use of doctests__.  In general they should provide 
-*examples* within the API documentation which can incidentally be tested.  We 
-don't try to test every important case using doctests -- regular Python
-tests are generally a better solution.
-
-Most of these are in ``bzrlib/doc/api``.  More additions are welcome.
-
-  __ http://docs.python.org/lib/module-doctest.html
-
-
 Running tests
 =============
 Currently, bzr selftest is used to invoke tests.
@@ -303,10 +290,6 @@
 
   ./bzr selftest -v blackbox
 
-To skip a particular test (or set of tests), you need to use a negative
-match, like so::
-  ./bzr selftest '^(?!.*blackbox)'  
-
 
 Errors and exceptions
 =====================
@@ -419,4 +402,4 @@
 so, please reply and say so.)
 
 
-:: vim: ft=rst tw=74 ai
+:: vim:tw=74:ai

=== modified file 'Makefile'
--- Makefile	2006-06-20 03:57:11 +0000
+++ Makefile	2006-05-11 02:23:31 +0000
@@ -1,4 +1,4 @@
-all:
+all: 
 
 check:
 	./bzr selftest -v $(tests)
@@ -8,16 +8,7 @@
 check-msgeditor:
 	./bzr --no-plugins selftest -v msgeditor
 
-# Run Python style checker (apt-get install pyflakes)
-pyflakes:
-	pyflakes bzrlib
-
-pyflakes-nounused:
-	# There are many of these warnings at the moment and they're not a
-	# high priority to fix
-	pyflakes bzrlib | grep -v ' imported but unused'
-
-clean:
+clean: 
 	./setup.py clean
 	-find . -name "*.pyc" -o -name "*.pyo" | xargs rm -f
 	rm -rf test????.tmp

=== modified file 'NEWS'
--- NEWS	2006-06-20 07:55:43 +0000
+++ NEWS	2006-06-18 02:21:57 +0000
@@ -74,9 +74,6 @@
     * Fix unnecessary requirement of sign-my-commits that it be run from
       a working directory.  (Martin Pool, Robert Collins)
 
-    * 'bzr push location' will only remember the push location if it succeeds
-      in connecting to the remote location. (#49742, John Arbash Meinel)
-
   INTERNALS:
 
     * Combine the ignore rules into a single regex rather than looping over
@@ -90,10 +87,6 @@
     * bzrlib.delta.compare_trees now iterates in alphabetically sorted order,
       rather than randomly walking the inventories. (John Arbash Meinel)
 
-    * Doctests are now run in temporary directories which are cleaned up when
-      they finish, rather than using special ScratchDir/ScratchBranch objects.
-      (Martin Pool)
-
     * Split ``check`` into separate methods on the branch and on the repository,
       so that it can be specialized in ways that are useful or efficient for
       different formats.  (Martin Pool, Robert Collins)
@@ -111,8 +104,7 @@
       (#4047, #48914, James Henstridge, John Arbash Meinel)
 
     * New command line option '--profile-imports', which will install a custom
-      importer to log time to import modules and regex compilation time to 
-      sys.stderr (John Arbash Meinel)
+      importer to log time to import modules to sys.stderr (John Arbash Meinel)
 
 bzr 0.8.2  2006-05-17
   

=== modified file 'bzr'
--- bzr	2006-06-19 14:40:19 +0000
+++ bzr	2006-06-18 02:05:12 +0000
@@ -50,12 +50,9 @@
 
 
 
-profiling = False
 if '--profile-imports' in sys.argv:
     sys.argv.remove('--profile-imports')
     import profile_imports
-    profile_imports.install()
-    profiling = True
 
 
 try:
@@ -77,10 +74,6 @@
 
 if __name__ == '__main__':
     bzrlib.trace.enable_default_logging()
-    exit_val = bzrlib.commands.main(sys.argv)
-
-    if profiling:
-        profile_imports.log_stack_info(sys.stderr)
-    sys.exit(exit_val)
+    sys.exit(bzrlib.commands.main(sys.argv))
 else:
     pass    # should this give an error? - it can't be used as a lib

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2006-06-20 04:45:30 +0000
+++ bzrlib/__init__.py	2006-06-07 08:02:10 +0000
@@ -88,7 +88,6 @@
     sys.platform = 'darwin'
 else:
     import locale
-# XXX: This probably belongs in osutils instead
 user_encoding = locale.getpreferredencoding() or 'ascii'
 del locale
 

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2006-06-20 04:45:30 +0000
+++ bzrlib/add.py	2006-06-13 12:55:45 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,10 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import errno
-import os
+import sys
 from os.path import dirname
-import sys
 
 import bzrlib.errors as errors
 from bzrlib.inventory import InventoryEntry
@@ -134,6 +132,8 @@
     further dry-run tasks to take place. To restore the original inventory
     call tree.read_working_inventory().
     """
+    import os, errno
+    from bzrlib.errors import BadFileKindError, ForbiddenFileError
     assert isinstance(recurse, bool)
     if action is None:
         action = AddAction()
@@ -154,7 +154,7 @@
         # validate user parameters. Our recursive code avoids adding new files
         # that need such validation 
         if tree.is_control_filename(rf.raw_path):
-            raise errors.ForbiddenControlFileError(filename=rf)
+            raise ForbiddenFileError('cannot add control file %s' % filepath)
         
         abspath = tree.abspath(rf.raw_path)
         kind = bzrlib.osutils.file_kind(abspath)
@@ -163,7 +163,7 @@
             user_dirs.add(rf.raw_path)
         else:
             if not InventoryEntry.versionable_kind(kind):
-                raise errors.BadFileKindError(filename=abspath, kind=kind)
+                raise BadFileKindError("cannot add %s of type %s" % (abspath, kind))
         # ensure the named path is added, so that ignore rules in the later directory
         # walk dont skip it.
         # we dont have a parent ie known yet.: use the relatively slower inventory 

=== modified file 'bzrlib/annotate.py'
--- bzrlib/annotate.py	2006-06-20 03:57:11 +0000
+++ bzrlib/annotate.py	2006-02-22 10:35:05 +0000
@@ -26,8 +26,10 @@
 # e.g. "3:12 Tue", "13 Oct", "Oct 2005", etc.  
 
 import sys
+import os
 import time
 
+import bzrlib.weave
 from bzrlib.config import extract_email_address
 from bzrlib.errors import BzrError
 

=== modified file 'bzrlib/atomicfile.py'
--- bzrlib/atomicfile.py	2006-06-20 03:57:11 +0000
+++ bzrlib/atomicfile.py	2005-12-18 04:08:46 +0000
@@ -14,11 +14,11 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import errno
-import os
+
 
 from warnings import warn
 from bzrlib.osutils import rename
+import errno
 
 class AtomicFile(object):
     """A file that does an atomic-rename to move into place.
@@ -35,7 +35,7 @@
         if mode != 'wb' and mode != 'wt':
             raise ValueError("invalid AtomicFile mode %r" % mode)
 
-        import socket
+        import os, socket
         self.tmpfilename = '%s.%d.%s.tmp' % (filename, os.getpid(),
                                              socket.gethostname())
         self.realfilename = filename
@@ -58,7 +58,8 @@
 
     def commit(self):
         """Close the file and move to final name."""
-
+        import sys, os
+        
         if self.closed:
             raise Exception('%r is already closed' % self)
 
@@ -80,6 +81,7 @@
 
     def abort(self):
         """Discard temporary file without committing changes."""
+        import os
 
         if self.closed:
             raise Exception('%r is already closed' % self)

=== modified file 'bzrlib/benchmarks/__init__.py'
--- bzrlib/benchmarks/__init__.py	2006-06-20 05:32:16 +0000
+++ bzrlib/benchmarks/__init__.py	2006-06-15 18:11:51 +0000
@@ -18,8 +18,8 @@
 """Benchmark test suite for bzr."""
 
 import bzrlib
-from bzrlib.tests.TestUtil import TestLoader
 from bzrlib.bzrdir import BzrDir
+from bzrlib.tests import TestLoader
 from bzrlib.tests.blackbox import ExternalBase
 
 class Benchmark(ExternalBase):

=== modified file 'bzrlib/benchmarks/bench_log.py'
--- bzrlib/benchmarks/bench_log.py	2006-06-17 18:37:30 +0000
+++ bzrlib/benchmarks/bench_log.py	2006-06-11 21:46:37 +0000
@@ -21,63 +21,14 @@
 from bzrlib.benchmarks import Benchmark
 from bzrlib.log import log_formatter, show_log
 from bzrlib.osutils import pathjoin
-from cStringIO import StringIO
+from StringIO import StringIO
 from bzrlib.transform import TreeTransform
 from bzrlib.workingtree import WorkingTree
 
-class LinesDone(Exception):
-    pass
-
-class LineConsumer(object):
-
-    def __init__(self, required_lines):
-        self.required_lines = required_lines
-
-    def write(self, text):
-        self.required_lines -= text.count('\n')
-        if self.required_lines < 0:
-            raise LinesDone()
-        
-
 class LogBenchmark(Benchmark):
 
     def test_log(self):
-        """Run log in a many-commit tree.""" 
+        """Canonicalizing paths should be fast.""" 
         tree = self.make_many_commit_tree()
         lf = log_formatter('long', to_file=StringIO())
         self.time(show_log, tree.branch, lf, direction='reverse')
-
-    def test_log_screenful(self):
-        """Simulate log --long|less"""
-        self.screenful_tester('long')
-
-    def test_log_screenful_line(self):
-        """Simulate log --line|less"""
-        self.screenful_tester('line')
-
-    def test_log_screenful_short(self):
-        """Simulate log --short|less"""
-        self.screenful_tester('short')
-
-    def screenful_tester(self, formatter):
-        """Run show_log, but stop after 25 lines are generated"""
-        tree = self.make_many_commit_tree()
-        def log_screenful():
-            lf = log_formatter(formatter, to_file=LineConsumer(25))
-            try:
-                show_log(tree.branch, lf, direction='reverse')
-            except LinesDone:
-                pass
-            else:
-                raise Exception, "LinesDone not raised"
-        self.time(log_screenful)
-
-    def test_cmd_log(self):
-        """Test execution of the log command.""" 
-        tree = self.make_many_commit_tree()
-        self.time(self.run_bzr, 'log', '-r', '-4..')
-
-    def test_cmd_log_subprocess(self):
-        """Text startup and execution of the log command.""" 
-        tree = self.make_many_commit_tree()
-        self.time(self.run_bzr_subprocess, 'log', '-r', '-4..')

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2006-06-20 07:55:43 +0000
+++ bzrlib/branch.py	2006-06-16 19:55:10 +0000
@@ -17,14 +17,15 @@
 
 from copy import deepcopy
 from cStringIO import StringIO
+import errno
+import os
+import shutil
+import sys
 from unittest import TestSuite
 from warnings import warn
 
 import bzrlib
-from bzrlib import bzrdir, errors, lockdir, osutils, revision, \
-        tree, \
-        ui, \
-        urlutils
+import bzrlib.bzrdir as bzrdir
 from bzrlib.config import TreeConfig
 from bzrlib.decorators import needs_read_lock, needs_write_lock
 import bzrlib.errors as errors
@@ -35,14 +36,31 @@
                            NotBranchError, UninitializableFormat, 
                            UnlistableStore, UnlistableBranch, 
                            )
+import bzrlib.inventory as inventory
+from bzrlib.inventory import Inventory
 from bzrlib.lockable_files import LockableFiles, TransportLock
-from bzrlib.symbol_versioning import (deprecated_function,
-                                      deprecated_method,
-                                      DEPRECATED_PARAMETER,
-                                      deprecated_passed,
-                                      zero_eight,
-                                      )
+from bzrlib.lockdir import LockDir
+from bzrlib.osutils import (isdir, quotefn,
+                            rename, splitpath, sha_file,
+                            file_kind, abspath, normpath, pathjoin,
+                            safe_unicode,
+                            rmtree,
+                            )
+from bzrlib.repository import Repository
+from bzrlib.revision import (
+                             is_ancestor,
+                             NULL_REVISION,
+                             Revision,
+                             )
+from bzrlib.store import copy_all
+from bzrlib.symbol_versioning import *
+from bzrlib.textui import show_status
 from bzrlib.trace import mutter, note
+import bzrlib.transactions as transactions
+from bzrlib.transport import Transport, get_transport
+import bzrlib.ui
+import bzrlib.urlutils as urlutils
+import bzrlib.xml5
 
 
 BZR_BRANCH_FORMAT_4 = "Bazaar-NG branch, format 0.0.4\n"
@@ -199,7 +217,7 @@
         if self.base == from_branch.base:
             return (0, [])
         if pb is None:
-            nested_pb = ui.ui_factory.nested_progress_bar()
+            nested_pb = bzrlib.ui.ui_factory.nested_progress_bar()
             pb = nested_pb
         else:
             nested_pb = None
@@ -213,7 +231,7 @@
                     last_revision = from_history[-1]
                 else:
                     # no history in the source branch
-                    last_revision = revision.NULL_REVISION
+                    last_revision = NULL_REVISION
             return self.repository.fetch(from_branch.repository,
                                          revision_id=last_revision,
                                          pb=nested_pb)
@@ -312,6 +330,36 @@
         
         If self and other have not diverged, return a list of the revisions
         present in other, but missing from self.
+
+        >>> from bzrlib.workingtree import WorkingTree
+        >>> bzrlib.trace.silent = True
+        >>> d1 = bzrdir.ScratchDir()
+        >>> br1 = d1.open_branch()
+        >>> wt1 = d1.open_workingtree()
+        >>> d2 = bzrdir.ScratchDir()
+        >>> br2 = d2.open_branch()
+        >>> wt2 = d2.open_workingtree()
+        >>> br1.missing_revisions(br2)
+        []
+        >>> wt2.commit("lala!", rev_id="REVISION-ID-1")
+        'REVISION-ID-1'
+        >>> br1.missing_revisions(br2)
+        [u'REVISION-ID-1']
+        >>> br2.missing_revisions(br1)
+        []
+        >>> wt1.commit("lala!", rev_id="REVISION-ID-1")
+        'REVISION-ID-1'
+        >>> br1.missing_revisions(br2)
+        []
+        >>> wt2.commit("lala!", rev_id="REVISION-ID-2A")
+        'REVISION-ID-2A'
+        >>> br1.missing_revisions(br2)
+        [u'REVISION-ID-2A']
+        >>> wt1.commit("lala!", rev_id="REVISION-ID-2B")
+        'REVISION-ID-2B'
+        >>> br1.missing_revisions(br2)
+        Traceback (most recent call last):
+        DivergedBranches: These branches have diverged.  Try merge.
         """
         self_history = self.revision_history()
         self_len = len(self_history)
@@ -327,7 +375,7 @@
         else:
             assert isinstance(stop_revision, int)
             if stop_revision > other_len:
-                raise errors.NoSuchRevision(self, stop_revision)
+                raise bzrlib.errors.NoSuchRevision(self, stop_revision)
         return other_history[self_len:stop_revision]
 
     def update_revisions(self, other, stop_revision=None):
@@ -530,8 +578,6 @@
         In particular this checks that revisions given in the revision-history
         do actually match up in the revision graph, and that they're all 
         present in the repository.
-        
-        Callers will typically also want to check the repository.
 
         :return: A BranchCheckResult.
         """
@@ -540,14 +586,14 @@
             try:
                 revision = self.repository.get_revision(revision_id)
             except errors.NoSuchRevision, e:
-                raise errors.BzrCheckError("mainline revision {%s} not in repository"
-                            % revision_id)
+                raise BzrCheckError("mainline revision {%s} not in repository"
+                        % revision_id)
             # In general the first entry on the revision history has no parents.
             # But it's not illegal for it to have parents listed; this can happen
             # in imports from Arch when the parents weren't reachable.
             if mainline_parent_id is not None:
                 if mainline_parent_id not in revision.parent_ids:
-                    raise errors.BzrCheckError("previous revision {%s} not listed among "
+                    raise BzrCheckError("previous revision {%s} not listed among "
                                         "parents of {%s}"
                                         % (mainline_parent_id, revision_id))
             mainline_parent_id = revision_id
@@ -588,7 +634,7 @@
         except NoSuchFile:
             raise NotBranchError(path=transport.base)
         except KeyError:
-            raise errors.UnknownFormatError(format=format_string)
+            raise errors.UnknownFormatError(format_string)
 
     @classmethod
     def get_default_format(klass):
@@ -721,7 +767,7 @@
         utf8_files = [('revision-history', ''),
                       ('branch-name', ''),
                       ]
-        control_files = LockableFiles(branch_transport, 'lock', lockdir.LockDir)
+        control_files = LockableFiles(branch_transport, 'lock', LockDir)
         control_files.create_lock()
         control_files.lock_write()
         control_files.put_utf8('format', self.get_format_string())
@@ -746,7 +792,7 @@
             format = BranchFormat.find_format(a_bzrdir)
             assert format.__class__ == self.__class__
         transport = a_bzrdir.get_branch_transport(None)
-        control_files = LockableFiles(transport, 'lock', lockdir.LockDir)
+        control_files = LockableFiles(transport, 'lock', LockDir)
         return BzrBranch5(_format=self,
                           _control_files=control_files,
                           a_bzrdir=a_bzrdir,
@@ -867,7 +913,7 @@
         self._base = self._transport.base
         self._format = _format
         if _control_files is None:
-            raise ValueError('BzrBranch _control_files is None')
+            raise BzrBadParameterMissing('_control_files')
         self.control_files = _control_files
         if deprecated_passed(init):
             warn("BzrBranch.__init__(..., init=XXX): The init parameter is "
@@ -888,7 +934,11 @@
                  stacklevel=2)
             if (not relax_version_check
                 and not self._format.is_supported()):
-                raise errors.UnsupportedFormatError(format=fmt)
+                raise errors.UnsupportedFormatError(
+                        'sorry, branch format %r not supported' % fmt,
+                        ['use a different bzr version',
+                         'or remove the .bzr directory'
+                         ' and "bzr init" again'])
         if deprecated_passed(transport):
             warn("BzrBranch.__init__(transport=XXX...): The transport "
                  "parameter is deprecated as of bzr 0.8. "
@@ -912,7 +962,7 @@
         # XXX: cache_root seems to be unused, 2006-01-13 mbp
         if hasattr(self, 'cache_root') and self.cache_root is not None:
             try:
-                osutils.rmtree(self.cache_root)
+                rmtree(self.cache_root)
             except:
                 pass
             self.cache_root = None
@@ -961,7 +1011,7 @@
         FIXME: DELETE THIS METHOD when pre 0.8 support is removed.
         """
         if format is None:
-            format = BranchFormat.find_format(self.bzrdir)
+            format = BzrBranchFormat.find_format(self.bzrdir)
         self._format = format
         mutter("got branch format %s", self._format)
 
@@ -1077,7 +1127,7 @@
             # make a new revision history from the graph
             current_rev_id = stop_revision
             new_history = []
-            while current_rev_id not in (None, revision.NULL_REVISION):
+            while current_rev_id not in (None, NULL_REVISION):
                 new_history.append(current_rev_id)
                 current_rev_id_parents = stop_graph[current_rev_id]
                 try:
@@ -1096,7 +1146,7 @@
     @deprecated_method(zero_eight)
     def working_tree(self):
         """Create a Working tree object for this branch."""
-
+        from bzrlib.workingtree import WorkingTree
         from bzrlib.transport.local import LocalTransport
         if (self.base.find('://') != -1 or 
             not isinstance(self._transport, LocalTransport)):
@@ -1123,7 +1173,7 @@
 
     def get_parent(self):
         """See Branch.get_parent."""
-
+        import errno
         _locs = ['parent', 'pull', 'x-pull']
         assert self.base[-1] == '/'
         for l in _locs:
@@ -1366,6 +1416,13 @@
 
 
 @deprecated_function(zero_eight)
+def ScratchBranch(*args, **kwargs):
+    """See bzrlib.bzrdir.ScratchDir."""
+    d = ScratchDir(*args, **kwargs)
+    return d.open_branch()
+
+
+@deprecated_function(zero_eight)
 def is_control_file(*args, **kwargs):
     """See bzrlib.workingtree.is_control_file."""
     return bzrlib.workingtree.is_control_file(*args, **kwargs)

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2006-06-20 05:32:16 +0000
+++ bzrlib/builtins.py	2006-06-16 21:05:03 +0000
@@ -20,26 +20,33 @@
 import codecs
 import errno
 import os
+from shutil import rmtree
 import sys
 
 import bzrlib
-from bzrlib.branch import Branch, BranchReferenceFormat
-from bzrlib import (bundle, branch, bzrdir, errors, osutils, ui, config,
-    repository, log)
+import bzrlib.branch
+from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.bundle import read_bundle_from_url
 from bzrlib.bundle.read_bundle import BundleReader
 from bzrlib.bundle.apply_bundle import install_bundle, merge_bundle
 from bzrlib.commands import Command, display_command
+import bzrlib.errors as errors
 from bzrlib.errors import (BzrError, BzrCheckError, BzrCommandError, 
                            NotBranchError, DivergedBranches, NotConflicted,
                            NoSuchFile, NoWorkingTree, FileInWrongBranch,
                            NotVersionedError, NotABundle)
+from bzrlib.log import show_one_log
 from bzrlib.merge import Merge3Merger
 from bzrlib.option import Option
+import bzrlib.osutils
 from bzrlib.progress import DummyProgress, ProgressPhase
 from bzrlib.revision import common_ancestor
 from bzrlib.revisionspec import RevisionSpec
-from bzrlib.trace import mutter, note, log_error, warning, is_quiet, info
+import bzrlib.trace
+from bzrlib.trace import mutter, note, log_error, warning, is_quiet
 from bzrlib.transport.local import LocalTransport
+import bzrlib.ui
 import bzrlib.urlutils as urlutils
 from bzrlib.workingtree import WorkingTree
 
@@ -88,11 +95,11 @@
         return bzrdir.BzrDirMetaFormat1()
     if typestring == "metaweave":
         format = bzrdir.BzrDirMetaFormat1()
-        format.repository_format = repository.RepositoryFormat7()
+        format.repository_format = bzrlib.repository.RepositoryFormat7()
         return format
     if typestring == "knit":
         format = bzrdir.BzrDirMetaFormat1()
-        format.repository_format = repository.RepositoryFormatKnit1()
+        format.repository_format = bzrlib.repository.RepositoryFormatKnit1()
         return format
     msg = "Unknown bzr format %s. Current formats are: default, knit,\n" \
           "metaweave and weave" % typestring
@@ -409,8 +416,7 @@
 
     If there is no default location set, the first pull will set it.  After
     that, you can omit the location to use the default.  To change the
-    default, use --remember. The value will only be saved if the remote
-    location can be accessed.
+    default, use --remember.
     """
 
     takes_options = ['remember', 'overwrite', 'revision', 'verbose']
@@ -429,7 +435,7 @@
         reader = None
         if location is not None:
             try:
-                reader = bundle.read_bundle_from_url(location)
+                reader = read_bundle_from_url(location)
             except NotABundle:
                 pass # Continue on considering this url a Branch
 
@@ -500,8 +506,7 @@
 
     If there is no default push location set, the first push will set it.
     After that, you can omit the location to use the default.  To change the
-    default, use --remember. The value will only be saved if the remote
-    location can be accessed.
+    default, use --remember.
     """
 
     takes_options = ['remember', 'overwrite', 'verbose',
@@ -525,15 +530,17 @@
             else:
                 display_url = urlutils.unescape_for_display(stored_loc,
                         self.outf.encoding)
-                self.outf.write("Using saved location: %s\n" % display_url)
+                self.outf.write("Using saved location: %s" % display_url)
                 location = stored_loc
 
         transport = get_transport(location)
         location_url = transport.base
+        if br_from.get_push_location() is None or remember:
+            br_from.set_push_location(location_url)
 
         old_rh = []
         try:
-            dir_to = bzrdir.BzrDir.open(location_url)
+            dir_to = bzrlib.bzrdir.BzrDir.open(location_url)
             br_to = dir_to.open_branch()
         except NotBranchError:
             # create a branch.
@@ -565,14 +572,7 @@
                 revision_id=br_from.last_revision())
             br_to = dir_to.open_branch()
             count = len(br_to.revision_history())
-            # We successfully created the target, remember it
-            if br_from.get_push_location() is None or remember:
-                br_from.set_push_location(br_to.base)
         else:
-            # We were able to connect to the remote location, so remember it
-            # we don't need to successfully push because of possible divergence.
-            if br_from.get_push_location() is None or remember:
-                br_from.set_push_location(br_to.base)
             old_rh = br_to.revision_history()
             try:
                 try:
@@ -618,6 +618,7 @@
 
     def run(self, from_location, to_location=None, revision=None, basis=None):
         from bzrlib.transport import get_transport
+        from bzrlib.osutils import rmtree
         if revision is None:
             revision = [None]
         elif len(revision) > 1:
@@ -653,10 +654,10 @@
             to_transport = get_transport(to_location)
             try:
                 to_transport.mkdir('.')
-            except errors.FileExists:
+            except bzrlib.errors.FileExists:
                 raise BzrCommandError('Target directory "%s" already'
                                       ' exists.' % to_location)
-            except errors.NoSuchFile:
+            except bzrlib.errors.NoSuchFile:
                 raise BzrCommandError('Parent of "%s" does not exist.' %
                                       to_location)
             try:
@@ -664,12 +665,12 @@
                 dir = br_from.bzrdir.sprout(to_transport.base,
                         revision_id, basis_dir)
                 branch = dir.open_branch()
-            except errors.NoSuchRevision:
+            except bzrlib.errors.NoSuchRevision:
                 to_transport.delete_tree('.')
                 msg = "The branch %s has no revision %s." % (from_location, revision[0])
                 raise BzrCommandError(msg)
-            except errors.UnlistableBranch:
-                osutils.rmtree(to_location)
+            except bzrlib.errors.UnlistableBranch:
+                rmtree(to_location)
                 msg = "The branch %s cannot be used as a --basis" % (basis,)
                 raise BzrCommandError(msg)
             if name:
@@ -718,7 +719,7 @@
             raise BzrCommandError(
                 'bzr checkout --revision takes exactly 1 revision value')
         if branch_location is None:
-            branch_location = osutils.getcwd()
+            branch_location = bzrlib.osutils.getcwd()
             to_location = branch_location
         source = Branch.open(branch_location)
         if len(revision) == 1 and revision[0] is not None:
@@ -730,8 +731,8 @@
         # if the source and to_location are the same, 
         # and there is no working tree,
         # then reconstitute a branch
-        if (osutils.abspath(to_location) == 
-            osutils.abspath(branch_location)):
+        if (bzrlib.osutils.abspath(to_location) == 
+            bzrlib.osutils.abspath(branch_location)):
             try:
                 source.bzrdir.open_workingtree()
             except errors.NoWorkingTree:
@@ -748,14 +749,14 @@
                                       to_location)
             else:
                 raise
-        old_format = bzrdir.BzrDirFormat.get_default_format()
-        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        old_format = bzrlib.bzrdir.BzrDirFormat.get_default_format()
+        bzrlib.bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
         try:
             if lightweight:
                 checkout = bzrdir.BzrDirMetaFormat1().initialize(to_location)
-                branch.BranchReferenceFormat().initialize(checkout, source)
+                bzrlib.branch.BranchReferenceFormat().initialize(checkout, source)
             else:
-                checkout_branch =  bzrdir.BzrDir.create_branch_convenience(
+                checkout_branch =  bzrlib.bzrdir.BzrDir.create_branch_convenience(
                     to_location, force_new_tree=False)
                 checkout = checkout_branch.bzrdir
                 checkout_branch.bind(source)
@@ -764,7 +765,7 @@
                     checkout_branch.set_revision_history(rh[:rh.index(revision_id) + 1])
             checkout.create_workingtree(revision_id)
         finally:
-            bzrdir.BzrDirFormat.set_default_format(old_format)
+            bzrlib.bzrdir.BzrDirFormat.set_default_format(old_format)
 
 
 class cmd_renames(Command):
@@ -777,11 +778,11 @@
 
     @display_command
     def run(self, dir=u'.'):
-        from bzrlib.tree import find_renames
         tree = WorkingTree.open_containing(dir)[0]
         old_inv = tree.basis_tree().inventory
         new_inv = tree.read_working_inventory()
-        renames = list(find_renames(old_inv, new_inv))
+
+        renames = list(bzrlib.tree.find_renames(old_inv, new_inv))
         renames.sort()
         for old_name, new_name in renames:
             self.outf.write("%s => %s\n" % (old_name, new_name))
@@ -935,42 +936,32 @@
 
     def run(self, branch="."):
         from bzrlib.reconcile import reconcile
-        dir = bzrdir.BzrDir.open(branch)
+        dir = bzrlib.bzrdir.BzrDir.open(branch)
         reconcile(dir)
 
 
 class cmd_revision_history(Command):
-    """Display the list of revision ids on a branch."""
-    takes_args = ['location?']
-
+    """Display list of revision ids on this branch."""
     hidden = True
 
     @display_command
-    def run(self, location="."):
-        branch = Branch.open_containing(location)[0]
-        for revid in branch.revision_history():
-            self.outf.write(revid)
+    def run(self):
+        branch = WorkingTree.open_containing(u'.')[0].branch
+        for patchid in branch.revision_history():
+            self.outf.write(patchid)
             self.outf.write('\n')
 
 
 class cmd_ancestry(Command):
     """List all revisions merged into this branch."""
-    takes_args = ['location?']
-
     hidden = True
 
     @display_command
-    def run(self, location="."):
-        try:
-            wt = WorkingTree.open_containing(location)[0]
-        except errors.NoWorkingTree:
-            b = Branch.open(location)
-            last_revision = b.last_revision()
-        else:
-            b = wt.branch
-            last_revision = wt.last_revision()
-
-        revision_ids = b.repository.get_ancestry(last_revision)
+    def run(self):
+        tree = WorkingTree.open_containing(u'.')[0]
+        b = tree.branch
+        # FIXME. should be tree.last_revision
+        revision_ids = b.repository.get_ancestry(b.last_revision())
         assert revision_ids[0] == None
         revision_ids.pop(0)
         for revision_id in revision_ids:
@@ -1008,6 +999,7 @@
                             type=get_format_type),
                      ]
     def run(self, location=None, format=None):
+        from bzrlib.branch import Branch
         if format is None:
             format = get_format_type('default')
         if location is None:
@@ -1212,7 +1204,7 @@
             if file_id in basis_inv:
                 continue
             path = inv.id2path(file_id)
-            if not os.access(osutils.abspath(path), os.F_OK):
+            if not os.access(bzrlib.osutils.abspath(path), os.F_OK):
                 continue
             self.outf.write(path + '\n')
 
@@ -1327,7 +1319,7 @@
             (rev2, rev1) = (rev1, rev2)
 
         if (log_format == None):
-            default = config.BranchConfig(b).log_format()
+            default = bzrlib.config.BranchConfig(b).log_format()
             log_format = get_log_format(long=long, short=short, line=line, default=default)
         lf = log_formatter(log_format,
                            show_ids=show_ids,
@@ -1370,7 +1362,7 @@
         b = tree.branch
         inv = tree.read_working_inventory()
         file_id = inv.path2id(relpath)
-        for revno, revision_id, what in log.find_touching_revisions(b, file_id):
+        for revno, revision_id, what in bzrlib.log.find_touching_revisions(b, file_id):
             self.outf.write("%6d %s\n" % (revno, what))
 
 
@@ -1432,8 +1424,9 @@
     """List unknown files."""
     @display_command
     def run(self):
+        from bzrlib.osutils import quotefn
         for f in WorkingTree.open_containing(u'.')[0].unknowns():
-            self.outf.write(osutils.quotefn(f) + '\n')
+            self.outf.write(quotefn(f) + '\n')
 
 
 class cmd_ignore(Command):
@@ -1603,7 +1596,7 @@
     hidden = True    
     @display_command
     def run(self):
-        print osutils.local_time_offset()
+        print bzrlib.osutils.local_time_offset()
 
 
 
@@ -1687,7 +1680,7 @@
             message = codecs.open(file, 'rt', bzrlib.user_encoding).read()
 
         if message == "":
-            raise BzrCommandError("empty commit message specified")
+                raise BzrCommandError("empty commit message specified")
         
         if verbose:
             reporter = ReportCommitToLog()
@@ -1786,13 +1779,14 @@
     def run(self, email=False):
         try:
             b = WorkingTree.open_containing(u'.')[0].branch
-            c = config.BranchConfig(b)
+            config = bzrlib.config.BranchConfig(b)
         except NotBranchError:
-            c = config.GlobalConfig()
+            config = bzrlib.config.GlobalConfig()
+        
         if email:
-            print c.user_email()
+            print config.user_email()
         else:
-            print c.username()
+            print config.username()
 
 
 class cmd_nick(Command):
@@ -1878,13 +1872,13 @@
         # we don't want progress meters from the tests to go to the
         # real output; and we don't want log messages cluttering up
         # the real logs.
-        save_ui = ui.ui_factory
-        print '%10s: %s' % ('bzr', osutils.realpath(sys.argv[0]))
+        save_ui = bzrlib.ui.ui_factory
+        print '%10s: %s' % ('bzr', bzrlib.osutils.realpath(sys.argv[0]))
         print '%10s: %s' % ('bzrlib', bzrlib.__path__[0])
         print
-        info('running tests...')
+        bzrlib.trace.info('running tests...')
         try:
-            ui.ui_factory = ui.SilentUIFactory()
+            bzrlib.ui.ui_factory = bzrlib.ui.SilentUIFactory()
             if testspecs_list is not None:
                 pattern = '|'.join(testspecs_list)
             else:
@@ -1905,27 +1899,29 @@
                               test_suite_factory=test_suite_factory,
                               lsprof_timed=lsprof_timed)
             if result:
-                info('tests passed')
+                bzrlib.trace.info('tests passed')
             else:
-                info('tests failed')
+                bzrlib.trace.info('tests failed')
             return int(not result)
         finally:
-            ui.ui_factory = save_ui
+            bzrlib.ui.ui_factory = save_ui
 
 
 def _get_bzr_branch():
     """If bzr is run from a branch, return Branch or None"""
+    import bzrlib.errors
+    from bzrlib.branch import Branch
+    from bzrlib.osutils import abspath
     from os.path import dirname
     
     try:
-        branch = Branch.open(dirname(osutils.abspath(dirname(__file__))))
+        branch = Branch.open(dirname(abspath(dirname(__file__))))
         return branch
-    except errors.BzrError:
+    except bzrlib.errors.BzrError:
         return None
     
 
 def show_version():
-    import bzrlib
     print "bzr (bazaar-ng) %s" % bzrlib.__version__
     # is bzrlib itself in a branch?
     branch = _get_bzr_branch()
@@ -1997,16 +1993,28 @@
         base_rev_id = common_ancestor(last1, last2, source)
 
         print 'merge base is revision %s' % base_rev_id
+        
+        return
+
+        if base_revno is None:
+            raise bzrlib.errors.UnrelatedBranches()
+
+        print ' r%-6d in %s' % (base_revno, branch)
+
+        other_revno = branch2.revision_id_to_revno(base_revid)
+        
+        print ' r%-6d in %s' % (other_revno, other)
+
 
 
 class cmd_merge(Command):
     """Perform a three-way merge.
     
-    The branch is the branch you will merge from.  By default, it will merge
-    the latest revision.  If you specify a revision, that revision will be
-    merged.  If you specify two revisions, the first will be used as a BASE,
-    and the second one as OTHER.  Revision numbers are always relative to the
-    specified branch.
+    The branch is the branch you will merge from.  By default, it will
+    merge the latest revision.  If you specify a revision, that
+    revision will be merged.  If you specify two revisions, the first
+    will be used as a BASE, and the second one as OTHER.  Revision
+    numbers are always relative to the specified branch.
 
     By default, bzr will try to merge in all new work from the other
     branch, automatically determining an appropriate base.  If this
@@ -2021,8 +2029,7 @@
 
     If there is no default branch set, the first merge will set it. After
     that, you can omit the branch to use the default.  To change the
-    default, use --remember. The value will only be saved if the remote
-    location can be accessed.
+    default, use --remember.
 
     Examples:
 
@@ -2059,7 +2066,7 @@
 
         if branch is not None:
             try:
-                reader = bundle.read_bundle_from_url(branch)
+                reader = read_bundle_from_url(branch)
             except NotABundle:
                 pass # Continue on considering this url a Branch
             else:
@@ -2099,7 +2106,7 @@
             interesting_files = [path]
         else:
             interesting_files = None
-        pb = ui.ui_factory.nested_progress_bar()
+        pb = bzrlib.ui.ui_factory.nested_progress_bar()
         try:
             try:
                 conflict_count = merge(other, base, check_clean=(not force),
@@ -2113,7 +2120,7 @@
                 return 1
             else:
                 return 0
-        except errors.AmbiguousBase, e:
+        except bzrlib.errors.AmbiguousBase, e:
             m = ("sorry, bzr can't determine the right merge base yet\n"
                  "candidates are:\n  "
                  + "\n  ".join(e.bases)
@@ -2252,7 +2259,7 @@
             raise BzrCommandError('bzr revert --revision takes exactly 1 argument')
         else:
             rev_id = revision[0].in_history(tree.branch).rev_id
-        pb = ui.ui_factory.nested_progress_bar()
+        pb = bzrlib.ui.ui_factory.nested_progress_bar()
         try:
             tree.revert(file_list, 
                         tree.branch.repository.revision_tree(rev_id),
@@ -2306,6 +2313,7 @@
     takes_args = ['from_branch', 'to_branch']
     def run(self, from_branch, to_branch):
         from bzrlib.fetch import Fetcher
+        from bzrlib.branch import Branch
         from_b = Branch.open(from_branch)
         to_b = Branch.open(to_branch)
         Fetcher(to_b, from_b)
@@ -2334,14 +2342,14 @@
             show_ids=False, verbose=False):
         from bzrlib.missing import find_unmerged, iter_log_data
         from bzrlib.log import log_formatter
-        local_branch = Branch.open_containing(u".")[0]
+        local_branch = bzrlib.branch.Branch.open_containing(u".")[0]
         parent = local_branch.get_parent()
         if other_branch is None:
             other_branch = parent
             if other_branch is None:
                 raise BzrCommandError("No missing location known or specified.")
             print "Using last location: " + local_branch.get_parent()
-        remote_branch = Branch.open(other_branch)
+        remote_branch = bzrlib.branch.Branch.open(other_branch)
         if remote_branch.base == local_branch.base:
             remote_branch = local_branch
         local_branch.lock_read()
@@ -2350,7 +2358,7 @@
             try:
                 local_extra, remote_extra = find_unmerged(local_branch, remote_branch)
                 if (log_format == None):
-                    default = config.BranchConfig(local_branch).log_format()
+                    default = bzrlib.config.BranchConfig(local_branch).log_format()
                     log_format = get_log_format(long=long, short=short, line=line, default=default)
                 lf = log_formatter(log_format, sys.stdout,
                                    show_ids=show_ids,
@@ -2415,16 +2423,11 @@
 
 class cmd_testament(Command):
     """Show testament (signing-form) of a revision."""
-    takes_options = ['revision', 'long', 
-                     Option('strict', help='Produce a strict testament')]
+    takes_options = ['revision', 'long']
     takes_args = ['branch?']
     @display_command
-    def run(self, branch=u'.', revision=None, long=False, strict=False):
-        from bzrlib.testament import Testament, StrictTestament
-        if strict is True:
-            testament_class = StrictTestament
-        else:
-            testament_class = Testament
+    def run(self, branch=u'.', revision=None, long=False):
+        from bzrlib.testament import Testament
         b = WorkingTree.open_containing(branch)[0].branch
         b.lock_read()
         try:
@@ -2432,7 +2435,7 @@
                 rev_id = b.last_revision()
             else:
                 rev_id = revision[0].in_history(b).rev_id
-            t = testament_class.from_revision(b.repository, rev_id)
+            t = Testament.from_revision(b.repository, rev_id)
             if long:
                 sys.stdout.writelines(t.as_text_lines())
             else:
@@ -2490,6 +2493,7 @@
     takes_options = ['revision']
     
     def run(self, revision_id_list=None, revision=None):
+        import bzrlib.config as config
         import bzrlib.gpg as gpg
         if revision_id_list is not None and revision is not None:
             raise BzrCommandError('You can only supply one of revision_id or --revision')
@@ -2557,7 +2561,7 @@
             raise BzrCommandError('Local branch is not bound')
 
 
-class cmd_uncommit(Command):
+class cmd_uncommit(bzrlib.commands.Command):
     """Remove the last committed revision.
 
     --verbose will print out what is being removed.
@@ -2581,6 +2585,7 @@
     def run(self, location=None, 
             dry_run=False, verbose=False,
             revision=None, force=False):
+        from bzrlib.branch import Branch
         from bzrlib.log import log_formatter
         import sys
         from bzrlib.uncommit import uncommit

=== modified file 'bzrlib/bundle/commands.py'
--- bzrlib/bundle/commands.py	2006-06-16 22:29:03 +0000
+++ bzrlib/bundle/commands.py	2006-06-07 16:46:22 +0000
@@ -15,7 +15,6 @@
 from bzrlib.revision import (common_ancestor, MultipleRevisionSources,
                              NULL_REVISION)
 from bzrlib.revisionspec import RevisionSpec
-from bzrlib.trace import note
 
 
 class cmd_send_changeset(Command):
@@ -87,21 +86,16 @@
         from bzrlib import user_encoding
         from bzrlib.bundle.serializer import write_bundle
 
-        target_branch = Branch.open_containing(u'.')[0]
-
         if base is None:
-            base = target_branch.get_parent()
-            if base is None:
-                raise errors.BzrCommandError("No base branch known or"
-                                             " specified.")
-            else:
-                note('Using saved location: %s' % base)
-        base_branch = Branch.open(base)
+            base_branch = None
+        else:
+            base_branch = Branch.open(base)
 
         # We don't want to lock the same branch across
         # 2 different branches
-        if target_branch.base == base_branch.base:
-            base_branch = target_branch 
+        target_branch = Branch.open_containing(u'.')[0]
+        if base_branch is not None and target_branch.base == base_branch.base:
+            base_branch = None
 
         base_revision = None
         if revision is None:

=== modified file 'bzrlib/bundle/read_bundle.py'
--- bzrlib/bundle/read_bundle.py	2006-06-18 19:39:13 +0000
+++ bzrlib/bundle/read_bundle.py	2006-06-15 21:24:47 +0000
@@ -28,7 +28,7 @@
 from bzrlib.inventory import (Inventory, InventoryEntry,
                               InventoryDirectory, InventoryFile,
                               InventoryLink)
-from bzrlib.osutils import sha_file, sha_string, pathjoin
+from bzrlib.osutils import sha_file, sha_string
 from bzrlib.revision import Revision, NULL_REVISION
 from bzrlib.testament import StrictTestament
 from bzrlib.trace import mutter, warning
@@ -718,7 +718,7 @@
             if old_dir is None:
                 old_path = None
             else:
-                old_path = pathjoin(old_dir, basename)
+                old_path = os.path.join(old_dir, basename)
         else:
             old_path = new_path
         #If the new path wasn't in renamed, the old one shouldn't be in
@@ -743,7 +743,7 @@
             if new_dir is None:
                 new_path = None
             else:
-                new_path = pathjoin(new_dir, basename)
+                new_path = os.path.join(new_dir, basename)
         else:
             new_path = old_path
         #If the old path wasn't in renamed, the new one shouldn't be in

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2006-06-20 07:55:43 +0000
+++ bzrlib/bzrdir.py	2006-06-13 15:04:06 +0000
@@ -20,12 +20,9 @@
 directories.
 """
 
-# TODO: remove unittest dependency; put that stuff inside the test suite
-
 from copy import deepcopy
+import os
 from cStringIO import StringIO
-import os
-from stat import S_ISDIR
 from unittest import TestSuite
 
 import bzrlib
@@ -42,6 +39,7 @@
 from bzrlib.store.revision.text import TextRevisionStore
 from bzrlib.store.text import TextStore
 from bzrlib.store.versioned import WeaveStore
+from bzrlib.symbol_versioning import *
 from bzrlib.trace import mutter
 from bzrlib.transactions import WriteTransaction
 from bzrlib.transport import get_transport
@@ -94,7 +92,11 @@
         """
         if not allow_unsupported and not format.is_supported():
             # see open_downlevel to open legacy branches.
-            raise errors.UnsupportedFormatError(format=format)
+            raise errors.UnsupportedFormatError(
+                    'sorry, format %s not supported' % format,
+                    ['use a different bzr version',
+                     'or remove the .bzr directory'
+                     ' and "bzr init" again'])
 
     def clone(self, url, revision_id=None, basis=None, force_new_repo=False):
         """Clone this bzrdir and its contents to url verbatim.
@@ -970,13 +972,11 @@
         """Return the .bzrdir style transport present at URL."""
         try:
             format_string = transport.get(".bzr/branch-format").read()
+            return klass._formats[format_string]
         except errors.NoSuchFile:
             raise errors.NotBranchError(path=transport.base)
-
-        try:
-            return klass._formats[format_string]
         except KeyError:
-            raise errors.UnknownFormatError(format=format_string)
+            raise errors.UnknownFormatError(format_string)
 
     @classmethod
     def get_default_format(klass):
@@ -1376,6 +1376,72 @@
         return result
 
 
+class ScratchDir(BzrDir6):
+    """Special test class: a bzrdir that cleans up itself..
+
+    >>> d = ScratchDir()
+    >>> base = d.transport.base
+    >>> isdir(base)
+    True
+    >>> b.transport.__del__()
+    >>> isdir(base)
+    False
+    """
+
+    def __init__(self, files=[], dirs=[], transport=None):
+        """Make a test branch.
+
+        This creates a temporary directory and runs init-tree in it.
+
+        If any files are listed, they are created in the working copy.
+        """
+        if transport is None:
+            transport = bzrlib.transport.local.ScratchTransport()
+            # local import for scope restriction
+            BzrDirFormat6().initialize(transport.base)
+            super(ScratchDir, self).__init__(transport, BzrDirFormat6())
+            self.create_repository()
+            self.create_branch()
+            self.create_workingtree()
+        else:
+            super(ScratchDir, self).__init__(transport, BzrDirFormat6())
+
+        # BzrBranch creates a clone to .bzr and then forgets about the
+        # original transport. A ScratchTransport() deletes itself and
+        # everything underneath it when it goes away, so we need to
+        # grab a local copy to prevent that from happening
+        self._transport = transport
+
+        for d in dirs:
+            self._transport.mkdir(d)
+            
+        for f in files:
+            self._transport.put(f, 'content of %s' % f)
+
+    def clone(self):
+        """
+        >>> orig = ScratchDir(files=["file1", "file2"])
+        >>> os.listdir(orig.base)
+        [u'.bzr', u'file1', u'file2']
+        >>> clone = orig.clone()
+        >>> if os.name != 'nt':
+        ...   os.path.samefile(orig.base, clone.base)
+        ... else:
+        ...   orig.base == clone.base
+        ...
+        False
+        >>> os.listdir(clone.base)
+        [u'.bzr', u'file1', u'file2']
+        """
+        from shutil import copytree
+        from bzrlib.osutils import mkdtemp
+        base = mkdtemp()
+        os.rmdir(base)
+        copytree(self.base, base, symlinks=True)
+        return ScratchDir(
+            transport=bzrlib.transport.local.ScratchTransport(base))
+
+
 class Converter(object):
     """Converts a disk format object from one format to another."""
 

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2006-06-20 04:45:30 +0000
+++ bzrlib/check.py	2006-06-10 23:16:19 +0000
@@ -32,9 +32,11 @@
 # raising them.  If there's more than one exception it'd be good to see them
 # all.
 
-from bzrlib.errors import BzrCheckError
+from bzrlib.errors import BzrCheckError, NoSuchRevision
+from bzrlib.symbol_versioning import *
+from bzrlib.trace import mutter, note, warning
 import bzrlib.ui
-from bzrlib.trace import note
+
 
 class Check(object):
     """Check a repository"""
@@ -146,6 +148,9 @@
             if inv_sha1 != rev.inventory_sha1:
                 raise BzrCheckError('Inventory sha1 hash doesn\'t match'
                     ' value in revision {%s}' % rev_id)
+        else:
+            self.missing_inventory_sha_cnt += 1
+            mutter("no inventory_sha1 on revision {%s}", rev_id)
         self._check_revision_tree(rev_id)
         self.checked_rev_cnt += 1
 

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2006-06-20 05:32:16 +0000
+++ bzrlib/commands.py	2006-06-10 13:27:24 +0000
@@ -35,16 +35,15 @@
 import codecs
 
 import bzrlib
-import bzrlib.errors as errors
 from bzrlib.errors import (BzrError,
+                           BzrCheckError,
                            BzrCommandError,
-                           BzrCheckError,
+                           BzrOptionError,
                            NotBranchError)
 from bzrlib.option import Option
-import bzrlib.osutils
 from bzrlib.revisionspec import RevisionSpec
-from bzrlib.symbol_versioning import (deprecated_method, zero_eight)
-from bzrlib import trace
+from bzrlib.symbol_versioning import *
+import bzrlib.trace
 from bzrlib.trace import mutter, note, log_error, warning, be_quiet
 
 plugin_cmds = {}
@@ -147,7 +146,7 @@
     if cmd_obj:
         return cmd_obj
 
-    raise BzrCommandError('unknown command "%s"' % cmd_name)
+    raise BzrCommandError("unknown command %r" % cmd_name)
 
 
 class Command(object):
@@ -236,7 +235,17 @@
             self.outf = sys.stdout
             return
 
-        output_encoding = bzrlib.osutils.get_terminal_encoding()
+        output_encoding = getattr(sys.stdout, 'encoding', None)
+        if not output_encoding:
+            input_encoding = getattr(sys.stdin, 'encoding', None)
+            if not input_encoding:
+                output_encoding = bzrlib.user_encoding
+                mutter('encoding stdout as bzrlib.user_encoding %r', output_encoding)
+            else:
+                output_encoding = input_encoding
+                mutter('encoding stdout as sys.stdin encoding %r', output_encoding)
+        else:
+            mutter('encoding stdout as sys.stdout encoding %r', output_encoding)
 
         # use 'replace' so that we don't abort if trying to write out
         # in e.g. the default C locale.
@@ -265,8 +274,8 @@
         allowed_names = self.options().keys()
         for oname in opts:
             if oname not in allowed_names:
-                raise BzrOptionError("option '--%s' is not allowed for"
-                                " command %r" % (oname, self.name()))
+                raise BzrCommandError("option '--%s' is not allowed for"
+                                      " command %r" % (oname, self.name()))
         # mix arguments and options into one dictionary
         cmdargs = _match_argform(self.name(), self.takes_args, args)
         cmdopts = {}
@@ -303,17 +312,6 @@
     def name(self):
         return _unsquish_command_name(self.__class__.__name__)
 
-    def plugin_name(self):
-        """Get the name of the plugin that provides this command.
-
-        :return: The name of the plugin or None if the command is builtin.
-        """
-        mod_parts = self.__module__.split('.')
-        if len(mod_parts) >= 3 and mod_parts[1] == 'plugins':
-            return mod_parts[2]
-        else:
-            return None
-
 
 def parse_spec(spec):
     """
@@ -383,7 +381,9 @@
                     else:
                         optname = a[2:]
                     if optname not in cmd_options:
-                        raise BzrCommandError('unknown option "%s"' % a)
+                        raise BzrOptionError('unknown long option %r for'
+                                             ' command %s' % 
+                                             (a, command.name()))
                 else:
                     shortopt = a[1:]
                     if shortopt in Option.SHORT_OPTIONS:
@@ -398,7 +398,7 @@
                         if shortopt not in Option.SHORT_OPTIONS:
                             # We didn't find the multi-character name, and we
                             # didn't find the single char name
-                            raise BzrCommandError('unknown option "%s"' % a)
+                            raise BzrError('unknown short option %r' % a)
                         optname = Option.SHORT_OPTIONS[shortopt].name
 
                         if a[2:]:
@@ -415,12 +415,15 @@
                                 # This option takes an argument, so pack it
                                 # into the array
                                 optarg = a[2:]
+                
                     if optname not in cmd_options:
-                        raise BzrCommandError('unknown option "%s"' % shortopt)
+                        raise BzrOptionError('unknown short option %r for'
+                                             ' command %s' % 
+                                             (shortopt, command.name()))
                 if optname in opts:
                     # XXX: Do we ever want to support this, e.g. for -r?
                     if proc_aliasarg:
-                        raise BzrCommandError('repeated option %r' % a)
+                        raise BzrError('repeated option %r' % a)
                     elif optname in alias_opts:
                         # Replace what's in the alias with what's in the real
                         # argument
@@ -429,14 +432,14 @@
                         proc_argv.insert(0, a)
                         continue
                     else:
-                        raise BzrCommandError('repeated option %r' % a)
+                        raise BzrError('repeated option %r' % a)
                     
                 option_obj = cmd_options[optname]
                 optargfn = option_obj.type
                 if optargfn:
                     if optarg == None:
                         if not proc_argv:
-                            raise BzrCommandError('option %r needs an argument' % a)
+                            raise BzrError('option %r needs an argument' % a)
                         else:
                             optarg = proc_argv.pop(0)
                     opts[optname] = optargfn(optarg)
@@ -444,7 +447,7 @@
                         alias_opts[optname] = optargfn(optarg)
                 else:
                     if optarg != None:
-                        raise BzrCommandError('option %r takes no argument' % optname)
+                        raise BzrError('option %r takes no argument' % optname)
                     opts[optname] = True
                     if proc_aliasarg:
                         alias_opts[optname] = True
@@ -481,7 +484,7 @@
                 raise BzrCommandError("command %r needs one or more %s"
                         % (cmd, argname.upper()))
             argdict[argname + '_list'] = args[:-1]
-            args[:-1] = []
+            args[:-1] = []                
         else:
             # just a plain arg
             argname = ap
@@ -679,7 +682,10 @@
 def main(argv):
     import bzrlib.ui
     from bzrlib.ui.text import TextUIFactory
+    ## bzrlib.trace.enable_default_logging()
+    bzrlib.trace.log_startup(argv)
     bzrlib.ui.ui_factory = TextUIFactory()
+
     argv = [a.decode(bzrlib.user_encoding) for a in argv[1:]]
     ret = run_bzr_catch_errors(argv)
     mutter("return code %d", ret)
@@ -696,12 +702,19 @@
     except Exception, e:
         # used to handle AssertionError and KeyboardInterrupt
         # specially here, but hopefully they're handled ok by the logger now
-        bzrlib.trace.report_exception(sys.exc_info(), sys.stderr)
-        if os.environ.get('BZR_PDB'):
-            print '**** entering debugger'
-            import pdb
-            pdb.post_mortem(sys.exc_traceback)
-        return 3
+        import errno
+        if (isinstance(e, IOError) 
+            and hasattr(e, 'errno')
+            and e.errno == errno.EPIPE):
+            bzrlib.trace.note('broken pipe')
+            return 3
+        else:
+            bzrlib.trace.log_exception()
+            if os.environ.get('BZR_PDB'):
+                print '**** entering debugger'
+                import pdb
+                pdb.post_mortem(sys.exc_traceback)
+            return 3
 
 if __name__ == '__main__':
     sys.exit(main(sys.argv))

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2006-06-20 05:32:16 +0000
+++ bzrlib/commit.py	2006-06-16 15:25:15 +0000
@@ -67,7 +67,7 @@
 import re
 import sys
 import time
-import warnings
+import pdb
 
 from cStringIO import StringIO
 
@@ -75,6 +75,7 @@
 import bzrlib.config
 import bzrlib.errors as errors
 from bzrlib.errors import (BzrError, PointlessCommit,
+                           HistoryMissing,
                            ConflictsInTree,
                            StrictCommitFailed
                            )
@@ -85,10 +86,7 @@
 from bzrlib.trace import mutter, note, warning
 from bzrlib.xml5 import serializer_v5
 from bzrlib.inventory import Inventory, ROOT_ID, InventoryEntry
-from bzrlib.symbol_versioning import (deprecated_passed,
-        deprecated_function,
-        zero_seven,
-        DEPRECATED_PARAMETER)
+from bzrlib.symbol_versioning import *
 from bzrlib.workingtree import WorkingTree
 
 
@@ -223,7 +221,7 @@
         mutter('preparing to commit')
 
         if deprecated_passed(branch):
-            warnings.warn("Commit.commit (branch, ...): The branch parameter is "
+            warn("Commit.commit (branch, ...): The branch parameter is "
                  "deprecated as of bzr 0.8. Please use working_tree= instead.",
                  DeprecationWarning, stacklevel=2)
             self.branch = branch
@@ -459,8 +457,9 @@
             if not self.branch.repository.has_revision(parent_id):
                 if parent_id == self.branch.last_revision():
                     warning("parent is missing %r", parent_id)
-                    raise BzrCheckError("branch %s is missing revision {%s}"
-                            % (self.branch, parent_id))
+                    raise HistoryMissing(self.branch, 'revision', parent_id)
+                else:
+                    mutter("commit will ghost revision %r", parent_id)
             
     def _remove_deleted(self):
         """Remove deleted files from the working inventories.

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2006-06-20 05:32:16 +0000
+++ bzrlib/config.py	2006-06-16 15:59:24 +0000
@@ -255,7 +255,7 @@
             return self._string_to_signature_policy(policy)
 
     def _get_signing_policy(self):
-        """See Config._get_signing_policy"""
+        """See Config._get_signature_checking."""
         policy = self._get_user_option('create_signatures')
         if policy:
             return self._string_to_signing_policy(policy)
@@ -541,7 +541,7 @@
         if base is None:
             base = os.environ.get('HOME', None)
         if base is None:
-            raise errors.BzrError('You must have one of BZR_HOME, APPDATA, or HOME set')
+            raise BzrError('You must have one of BZR_HOME, APPDATA, or HOME set')
         return pathjoin(base, 'bazaar', '2.0')
     else:
         # cygwin, linux, and darwin all have a $HOME directory

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2006-06-20 05:32:16 +0000
+++ bzrlib/diff.py	2006-06-17 01:18:15 +0000
@@ -27,8 +27,7 @@
 import bzrlib.osutils
 from bzrlib.patiencediff import unified_diff
 import bzrlib.patiencediff
-from bzrlib.symbol_versioning import (deprecated_function,
-        zero_eight)
+from bzrlib.symbol_versioning import *
 from bzrlib.textfile import check_text_lines
 from bzrlib.trace import mutter, warning
 

=== modified file 'bzrlib/doc/api/__init__.py'
--- bzrlib/doc/api/__init__.py	2006-06-06 08:09:09 +0000
+++ bzrlib/doc/api/__init__.py	2005-12-24 02:20:45 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Development Ltd
+# (C) 2005 Canonical Development Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,6 +29,6 @@
     
 def test_suite():
     candidates = os.listdir(os.path.dirname(__file__))
-    scripts = [candidate for candidate in candidates
+    scripts = [candidate for candidate in candidates 
                if candidate.endswith('.txt')]
     return doctest.DocFileSuite(*scripts)

=== modified file 'bzrlib/doc/api/branch.txt'
--- bzrlib/doc/api/branch.txt	2006-06-06 08:09:09 +0000
+++ bzrlib/doc/api/branch.txt	2006-02-01 11:50:27 +0000
@@ -2,36 +2,28 @@
 
 A Branch represents a series of commits and merges carried out by a user.
 
-Make a temporary directory for these tests:
-
-   >>> import tempfile
-   >>> test_dir = tempfile.mkdtemp(prefix='bzrlib_doc_api_branch_txt_')
-
 Branches are created by BzrDir's:
 
+   >>> from bzrlib.bzrdir import ScratchDir
    >>> from bzrlib.branch import Branch
-   >>> from bzrlib.bzrdir import BzrDir
+   >>> dir = ScratchDir()
+   >>> new_branch = dir.create_branch()
 
-   >>> new_branch = BzrDir.create_branch_convenience(test_dir)
 
 Existing Branches can be opened directly:
 
-   >>> transport = new_branch.bzrdir.transport
-   >>> another_instance = Branch.open(transport.clone('..').base)
+   >>> another_instance = Branch.open(dir.transport.clone('..').base)
 
 or via the BzrDir:
 
-   >>> still_the_same_branch = new_branch.bzrdir.open_branch()
+   >>> still_the_same_branch = dir.open_branch()
+
 
 A branch has a history of revisions on it:
 
    >>> new_branch.revision_history()
    []
 
+
 We need to write some more documentation, showing
 push and pull operations. Cloning might also be nice.
-
-And finally, clean up:
-
-   >>> import shutil
-   >>> shutil.rmtree(test_dir)

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2006-06-20 05:32:16 +0000
+++ bzrlib/errors.py	2006-06-17 01:04:57 +0000
@@ -16,18 +16,6 @@
 
 """Exceptions for bzr, and reporting of them.
 
-There are 3 different classes of error:
-
- * KeyboardInterrupt, and OSError with EPIPE - the program terminates 
-   with an appropriate short message
-
- * User errors, indicating a problem caused by the user such as a bad URL.
-   These are printed in a short form.
- 
- * Internal unexpected errors, including most Python builtin errors
-   and some raised from inside bzr.  These are printed with a full 
-   traceback and an invitation to report the bug.
-
 Exceptions are caught at a high level to report errors to the user, and
 might also be caught inside the program.  Therefore it needs to be
 possible to convert them to a meaningful string, and also for them to be
@@ -56,14 +44,13 @@
 Therefore:
 
  * create a new exception class for any class of error that can be
-   usefully distinguished.  If no callers are likely to want to catch
-   one but not another, don't worry about them.
-
- * the __str__ method should generate something useful; BzrError provides
-   a good default implementation
-
-Exception strings should start with a capital letter and should not have a
-final fullstop.
+   usefully distinguished.
+
+ * the printable form of an exception is generated by the base class
+   __str__ method
+
+Exception strings should start with a capital letter and not have a final
+fullstop.
 """
 
 from warnings import warn
@@ -94,9 +81,6 @@
 
 
 class BzrError(StandardError):
-    
-    is_user_error = True
-    
     def __str__(self):
         # XXX: Should we show the exception class in 
         # exceptions that don't provide their own message?  
@@ -135,8 +119,6 @@
 class BzrCheckError(BzrNewError):
     """Internal check failed: %(message)s"""
 
-    is_user_error = False
-
     def __init__(self, message):
         BzrNewError.__init__(self)
         self.message = message
@@ -144,9 +126,6 @@
 
 class InvalidEntryName(BzrNewError):
     """Invalid entry name: %(name)s"""
-
-    is_user_error = False
-
     def __init__(self, name):
         BzrNewError.__init__(self)
         self.name = name
@@ -184,31 +163,25 @@
         self.url = url
 
 
-class BzrCommandError(BzrNewError):
-    """Error from user command"""
-
-    is_user_error = True
-
-    # Error from malformed user command; please avoid raising this as a
-    # generic exception not caused by user input.
+class BzrCommandError(BzrError):
+    # Error from malformed user command
+    # This is being misused as a generic exception
+    # please subclass. RBC 20051030
     #
     # I think it's a waste of effort to differentiate between errors that
     # are not intended to be caught anyway.  UI code need not subclass
     # BzrCommandError, and non-UI code should not throw a subclass of
     # BzrCommandError.  ADHB 20051211
-    def __init__(self, msg):
-        self.msg = msg
-
     def __str__(self):
-        return self.msg
+        return self.args[0]
 
 
 class BzrOptionError(BzrCommandError):
-    """Error in command line options"""
+    """Some missing or otherwise incorrect option was supplied."""
 
     
-class StrictCommitFailed(BzrNewError):
-    """Commit refused because there are unknown files in the tree"""
+class StrictCommitFailed(Exception):
+    """Commit refused because there are unknowns in the tree."""
 
 
 # XXX: Should be unified with TransportError; they seem to represent the
@@ -260,9 +233,6 @@
 
 class PathNotChild(BzrNewError):
     """Path %(path)r is not a child of path %(base)r%(extra)s"""
-
-    is_user_error = False
-
     def __init__(self, path, base, extra=None):
         BzrNewError.__init__(self)
         self.path = path
@@ -310,12 +280,16 @@
         self.path = path
 
 
-class UnsupportedFormatError(BzrNewError):
-    """Unsupported branch format: %(format)s"""
-
-
-class UnknownFormatError(BzrNewError):
-    """Unknown branch format: %(format)r"""
+class UnsupportedFormatError(BzrError):
+    """Specified path is a bzr branch that we recognize but cannot read."""
+    def __str__(self):
+        return 'unsupported branch format: %s' % self.args[0]
+
+
+class UnknownFormatError(BzrError):
+    """Specified path is a bzr branch whose format we do not recognize."""
+    def __str__(self):
+        return 'unknown branch format: %s' % self.args[0]
 
 
 class IncompatibleFormat(BzrNewError):
@@ -359,12 +333,14 @@
         self.paths_as_string = ' '.join([quotefn(p) for p in paths])
 
 
-class BadFileKindError(BzrNewError):
-    """Cannot operate on %(filename)s of unsupported kind %(kind)s"""
-
-
-class ForbiddenControlFileError(BzrNewError):
-    """Cannot operate on %(filename)s because it is a control file"""
+class BadFileKindError(BzrError):
+    """Specified file is of a kind that cannot be added.
+
+    (For example a symlink or device file.)"""
+
+
+class ForbiddenFileError(BzrError):
+    """Cannot operate on a file because it is a control file."""
 
 
 class LockError(BzrNewError):
@@ -402,9 +378,6 @@
 
 class ObjectNotLocked(LockError):
     """%(obj)r is not locked"""
-
-    is_user_error = False
-
     # this can indicate that any particular object is not locked; see also
     # LockNotHeld which means that a particular *lock* object is not held by
     # the caller -- perhaps they should be unified.
@@ -472,14 +445,12 @@
     """Commit refused because there are unknowns in the tree."""
 
 
-class NoSuchRevision(BzrNewError):
-    """Branch %(branch)s has no revision %(revision)s"""
-
-    is_user_error = False
-
+class NoSuchRevision(BzrError):
     def __init__(self, branch, revision):
         self.branch = branch
         self.revision = revision
+        msg = "Branch %s has no revision %s" % (branch, revision)
+        BzrError.__init__(self, msg)
 
 
 class HistoryMissing(BzrError):
@@ -490,28 +461,26 @@
                           % (branch, object_type, object_id))
 
 
-class DivergedBranches(BzrNewError):
-    "These branches have diverged.  Use the merge command to reconcile them."""
-
-    is_user_error = True
+class DivergedBranches(BzrError):
 
     def __init__(self, branch1, branch2):
+        BzrError.__init__(self, "These branches have diverged.  Try merge.")
         self.branch1 = branch1
         self.branch2 = branch2
 
 
-class UnrelatedBranches(BzrNewError):
-    "Branches have no common ancestor, and no merge base revision was specified."
-
-    is_user_error = True
-
-
-class NoCommonAncestor(BzrNewError):
-    "Revisions have no common ancestor: %(revision_a)s %(revision_b)s"
-
+class UnrelatedBranches(BzrCommandError):
+    def __init__(self):
+        msg = "Branches have no common ancestor, and no base revision"\
+            " specified."
+        BzrCommandError.__init__(self, msg)
+
+
+class NoCommonAncestor(BzrError):
     def __init__(self, revision_a, revision_b):
-        self.revision_a = revision_a
-        self.revision_b = revision_b
+        msg = "Revisions have no common ancestor: %s %s." \
+            % (revision_a, revision_b) 
+        BzrError.__init__(self, msg)
 
 
 class NoCommonRoot(BzrError):

=== modified file 'bzrlib/export/tar_exporter.py'
--- bzrlib/export/tar_exporter.py	2006-06-20 03:57:11 +0000
+++ bzrlib/export/tar_exporter.py	2005-12-29 03:26:31 +0000
@@ -1,15 +1,15 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
-#
+# Copyright (C) 2005 Canonical Ltd
+
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
-#
+
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-#
+
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
@@ -20,7 +20,6 @@
 import os
 from bzrlib.trace import mutter
 import tarfile
-from bzrlib import errors, export
 
 
 def tar_exporter(tree, dest, root, compression=None):
@@ -33,8 +32,11 @@
     now = time()
     compression = str(compression or '')
     if root is None:
-        root = export.get_root_name(dest)
-    ball = tarfile.open(dest, 'w:' + compression)
+        root = get_root_name(dest)
+    try:
+        ball = tarfile.open(dest, 'w:' + compression)
+    except tarfile.CompressionError, e:
+        raise BzrError(str(e))
     mutter('export version %r', tree)
     inv = tree.inventory
     for dp, ie in inv.iter_entries():

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2006-06-20 05:32:16 +0000
+++ bzrlib/fetch.py	2006-06-12 01:53:19 +0000
@@ -33,15 +33,13 @@
 
 import bzrlib
 import bzrlib.errors as errors
-from bzrlib.errors import (InstallFailed,
-                           )
+from bzrlib.errors import (InstallFailed, NoSuchRevision,
+                           MissingText)
 from bzrlib.trace import mutter
-from bzrlib.progress import ProgressPhase
+from bzrlib.progress import ProgressBar, ProgressPhase
+from bzrlib.reconcile import RepoReconciler
 from bzrlib.revision import NULL_REVISION
-from bzrlib.symbol_versioning import (deprecated_function,
-        deprecated_method,
-        zero_eight,
-        )
+from bzrlib.symbol_versioning import *
 
 
 # TODO: Avoid repeatedly opening weaves so many times.
@@ -126,9 +124,8 @@
         self.from_control = self.from_repository.control_weaves
         self.count_total = 0
         self.file_ids_names = {}
-        pp = ProgressPhase('Fetch phase', 4, self.pb)
+        pp = ProgressPhase('fetch phase', 4, self.pb)
         try:
-            pp.next_phase()
             revs = self._revids_to_fetch()
             # something to do ?
             if revs:

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2006-06-18 23:19:23 +0000
+++ bzrlib/help.py	2006-05-10 17:48:25 +0000
@@ -85,18 +85,6 @@
     return s
 
 
-def print_command_plugin(cmd_object, outfile, format):
-    """Print the plugin that provides a command object, if any.
-
-    If the cmd_object is provided by a plugin, prints the plugin name to
-    outfile using the provided format string.
-    """
-    plugin_name = cmd_object.plugin_name()
-    if plugin_name is not None:
-        out_str = '(From plugin "%s")' % plugin_name
-        outfile.write(format % out_str)
-
-
 def help_on_command(cmdname, outfile=None):
     from bzrlib.commands import get_cmd_object
 
@@ -119,8 +107,6 @@
 
     print >>outfile
 
-    print_command_plugin(cmd_object, outfile, '%s\n\n')
-
     outfile.write(doc)
     if doc[-1] != '\n':
         outfile.write('\n')
@@ -170,10 +156,6 @@
         if cmd_object.hidden:
             continue
         print >>outfile, command_usage(cmd_object)
-
-        plugin_name = cmd_object.plugin_name()
-        print_command_plugin(cmd_object, outfile, '        %s\n')
-
         cmd_help = cmd_object.help()
         if cmd_help:
             firstline = cmd_help.split('\n', 1)[0]

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2006-06-20 05:32:16 +0000
+++ bzrlib/info.py	2006-06-16 17:10:52 +0000
@@ -24,8 +24,7 @@
                            NoRepositoryPresent, NotLocalUrl)
 from bzrlib.missing import find_unmerged
 import bzrlib.osutils as osutils
-from bzrlib.symbol_versioning import (deprecated_function, 
-        zero_eight)
+from bzrlib.symbol_versioning import *
 
 
 def plural(n, base='', pl=None):

=== modified file 'bzrlib/iterablefile.py'
--- bzrlib/iterablefile.py	2006-06-18 03:45:05 +0000
+++ bzrlib/iterablefile.py	2006-05-25 17:56:25 +0000
@@ -15,6 +15,8 @@
 #    along with this program; if not, write to the Free Software
 #    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+import doctest
+
 class IterableFileBase(object):
     """Create a file-like object from any iterable"""
 
@@ -252,5 +254,4 @@
 
         
 if __name__ == "__main__":
-    import doctest
     doctest.testmod()

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2006-06-20 05:32:16 +0000
+++ bzrlib/knit.py	2006-06-12 01:53:19 +0000
@@ -2,7 +2,6 @@
 # Written by Martin Pool.
 # Modified by Johan Rydberg <jrydberg@gnu.org>
 # Modified by Robert Collins <robert.collins@canonical.com>
-# Modified by Aaron Bentley <aaron.bentley@utoronto.ca>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -68,7 +67,6 @@
 from cStringIO import StringIO
 import difflib
 from itertools import izip, chain
-import operator
 import os
 import sys
 
@@ -77,7 +75,7 @@
 from bzrlib.errors import FileExists, NoSuchFile, KnitError, \
         InvalidRevisionId, KnitCorrupt, KnitHeaderError, \
         RevisionNotPresent, RevisionAlreadyPresent
-from bzrlib.tuned_gzip import GzipFile
+from bzrlib.tuned_gzip import *
 from bzrlib.trace import mutter
 from bzrlib.osutils import contains_whitespace, contains_linebreaks, \
      sha_strings
@@ -267,8 +265,8 @@
     stored and retrieved.
     """
 
-    def __init__(self, relpath, transport, file_mode=None, access_mode=None, 
-                 factory=None, basis_knit=None, delta=True, create=False):
+    def __init__(self, relpath, transport, file_mode=None, access_mode=None, factory=None,
+                 basis_knit=None, delta=True, create=False):
         """Construct a knit at location specified by relpath.
         
         :param create: If not True, only open an existing knit.
@@ -512,34 +510,6 @@
             diff_hunks.append((op[1], op[2], op[4]-op[3], new_content._lines[op[3]:op[4]]))
         return diff_hunks
 
-    def _get_component_versions(self, version_id):
-        basis = self.basis_knit
-        needed_versions = []
-        basis_versions = []
-        cursor = version_id
-
-        while 1:
-            picked_knit = self
-            if basis and basis._index.has_version(cursor):
-                picked_knit = basis
-                basis_versions.append(cursor)
-            method = picked_knit._index.get_method(cursor)
-            needed_versions.append((method, cursor))
-            if method == 'fulltext':
-                break
-            cursor = picked_knit.get_parents(cursor)[0]
-        return needed_versions, basis_versions
-
-    def _get_component_positions(self, version_id):
-        needed_versions, basis_versions = \
-            self._get_component_versions(version_id)
-        assert len(basis_versions) == 0
-        positions = []
-        for method, comp_id in needed_versions:
-            data_pos, data_size = self._index.get_position(comp_id)
-            positions.append((method, comp_id, data_pos, data_size))
-        return positions
-
     def _get_components(self, version_id):
         """Return a list of (version_id, method, data) tuples that
         makes up version specified by version_id of the knit.
@@ -563,17 +533,28 @@
         # basis_revisions is a list of versions that needs to be
         # fetched but exists in the basis knit.
 
-        needed_versions, basis_versions = \
-            self._get_component_versions(version_id)
+        basis = self.basis_knit
+        needed_versions = []
+        basis_versions = []
+        cursor = version_id
+
+        while 1:
+            picked_knit = self
+            if basis and basis._index.has_version(cursor):
+                picked_knit = basis
+                basis_versions.append(cursor)
+            method = picked_knit._index.get_method(cursor)
+            needed_versions.append((method, cursor))
+            if method == 'fulltext':
+                break
+            cursor = picked_knit.get_parents(cursor)[0]
 
         components = {}
         if basis_versions:
-            assert False, "I am broken"
-            basis = self.basis_knit
             records = []
             for comp_id in basis_versions:
                 data_pos, data_size = basis._index.get_data_position(comp_id)
-                records.append((comp_id, data_pos, data_size))
+                records.append((piece_id, data_pos, data_size))
             components.update(basis._data.read_records(records))
 
         records = []
@@ -622,6 +603,7 @@
 
         # digest here is the digest from the last applied component.
         if sha_strings(content.text()) != digest:
+            import pdb;pdb.set_trace()
             raise KnitCorrupt(self.filename, 'sha-1 does not match %s' % version_id)
 
         return content
@@ -735,71 +717,12 @@
 
     def _clone_text(self, new_version_id, old_version_id, parents):
         """See VersionedFile.clone_text()."""
-        # FIXME RBC 20060228 make fast by only inserting an index with null 
-        # delta.
+        # FIXME RBC 20060228 make fast by only inserting an index with null delta.
         self.add_lines(new_version_id, parents, self.get_lines(old_version_id))
 
     def get_lines(self, version_id):
         """See VersionedFile.get_lines()."""
-        return self.get_line_list([version_id])[0]
-
-    def _get_version_components(self, position_map):
-        records = []
-        for version_id, positions in position_map.iteritems():
-            for method, comp_id, position, size in positions:
-                records.append((comp_id, position, size))
-        record_map = self._data.read_records(records)
-
-        component_map = {}
-        for version_id, positions in position_map.iteritems():
-            components = []
-            for method, comp_id, position, size in positions:
-                data, digest = record_map[comp_id]
-                components.append((comp_id, method, data, digest))
-            component_map[version_id] = components
-        return component_map
-
-    def get_text(self, version_id):
-        """See VersionedFile.get_text"""
-        return self.get_texts([version_id])[0]
-
-    def get_texts(self, version_ids):
-        return [''.join(l) for l in self.get_line_list(version_ids)]
-
-    def get_line_list(self, version_ids):
-        """Return the texts of listed versions as a list of strings."""
-        position_map = {}
-        for version_id in version_ids:
-            if not self.has_version(version_id):
-                raise RevisionNotPresent(version_id, self.filename)
-            position_map[version_id] = \
-                self._get_component_positions(version_id)
-
-        version_components = self._get_version_components(position_map).items()
-
-        text_map = {}
-        for version_id, components in version_components:
-            content = None
-            for component_id, method, data, digest in reversed(components):
-                version_idx = self._index.lookup(component_id)
-                if method == 'fulltext':
-                    assert content is None
-                    content = self.factory.parse_fulltext(data, version_idx)
-                elif method == 'line-delta':
-                    delta = self.factory.parse_line_delta(data, version_idx)
-                    content._lines = self._apply_delta(content._lines, delta)
-
-            if 'no-eol' in self._index.get_options(version_id):
-                line = content._lines[-1][1].rstrip('\n')
-                content._lines[-1] = (content._lines[-1][0], line)
-
-            # digest here is the digest from the last applied component.
-            if sha_strings(content.text()) != digest:
-                raise KnitCorrupt(self.filename, 
-                                  'sha-1 does not match %s' % version_id)
-
-            text_map[version_id] = content.text()
-        return [text_map[v] for v in version_ids]
+        return self._get_content(version_id).text()
 
     def iter_lines_added_or_present_in_versions(self, version_ids=None):
         """See VersionedFile.iter_lines_added_or_present_in_versions()."""
@@ -1069,7 +992,7 @@
         # position in _history is the 'official' index for a revision
         # but the values may have come from a newer entry.
         # so - wc -l of a knit index is != the number of unique names
-        # in the knit.
+        # in the weave.
         self._history = []
         pb = bzrlib.ui.ui_factory.nested_progress_bar()
         try:
@@ -1450,14 +1373,12 @@
                 needed_records.append((version_id, pos, size))
 
         if len(needed_records):
-            needed_records.sort(key=operator.itemgetter(1))
             # We take it that the transport optimizes the fetching as good
             # as possible (ie, reads continuous ranges.)
             response = self._transport.readv(self._filename,
                 [(pos, size) for version_id, pos, size in needed_records])
 
-            for (record_id, pos, size), (pos, data) in \
-                izip(iter(needed_records), response):
+            for (record_id, pos, size), (pos, data) in izip(iter(needed_records), response):
                 content, digest = self._parse_record(record_id, data)
                 self._records[record_id] = (digest, content)
     

=== modified file 'bzrlib/lock.py'
--- bzrlib/lock.py	2006-06-20 03:57:11 +0000
+++ bzrlib/lock.py	2006-03-03 07:31:24 +0000
@@ -38,7 +38,7 @@
 import os
 import sys
 
-from bzrlib.trace import mutter
+from bzrlib.trace import mutter, note, warning
 from bzrlib.errors import LockError
 
 class _base_Lock(object):

=== modified file 'bzrlib/lockable_files.py'
--- bzrlib/lockable_files.py	2006-06-20 03:57:11 +0000
+++ bzrlib/lockable_files.py	2006-06-06 12:06:20 +0000
@@ -19,13 +19,11 @@
 #import traceback
 
 import bzrlib
-from bzrlib.decorators import (needs_read_lock,
-        needs_write_lock)
+from bzrlib.decorators import *
 import bzrlib.errors as errors
 from bzrlib.errors import BzrError
 from bzrlib.osutils import file_iterator, safe_unicode
-from bzrlib.symbol_versioning import (deprecated_method, 
-        zero_eight)
+from bzrlib.symbol_versioning import *
 from bzrlib.trace import mutter, note
 import bzrlib.transactions as transactions
 import bzrlib.urlutils as urlutils

=== modified file 'bzrlib/lockdir.py'
--- bzrlib/lockdir.py	2006-06-20 03:57:11 +0000
+++ bzrlib/lockdir.py	2006-06-10 00:21:11 +0000
@@ -96,6 +96,7 @@
 
 import os
 import time
+from warnings import warn
 from StringIO import StringIO
 
 import bzrlib.config
@@ -105,6 +106,7 @@
         LockBreakMismatch,
         LockBroken,
         LockContention,
+        LockError,
         LockNotHeld,
         NoSuchFile,
         PathError,

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2006-06-20 05:32:16 +0000
+++ bzrlib/log.py	2006-06-16 19:55:10 +0000
@@ -49,9 +49,8 @@
 all the changes since the previous revision that touched hello.c.
 """
 
+
 # TODO: option to show delta summaries for merged-in revisions
-
-from itertools import izip
 import re
 
 from bzrlib.delta import compare_trees
@@ -233,22 +232,12 @@
     for index, rev_id in cut_revs:
         rev_nos[rev_id] = index
 
-    def iter_revisions():
-        revision_ids = [r for s, r, m, e in merge_sorted_revisions]
-        num = 9
-        while revision_ids:
-            revisions = branch.repository.get_revisions(revision_ids[:num])
-            for revision in revisions:
-                yield revision
-            revision_ids  = revision_ids[num:]
-            num = int(num * 1.5)
-            
-        revisions = branch.repository.get_revisions()
-        for revision in revisions:
-            yield revision
+    revisions = branch.repository.get_revisions([r for s, r, m, e in
+                                                 merge_sorted_revisions])
+
     # now we just print all the revisions
     for ((sequence, rev_id, merge_depth, end_of_merge), rev) in \
-        izip(merge_sorted_revisions, iter_revisions()):
+        zip(merge_sorted_revisions, revisions):
 
         if searchRE:
             if not searchRE.search(rev.message):
@@ -272,6 +261,88 @@
             lf.show_merge(rev, merge_depth)
 
 
+def deltas_for_log_dummy(branch, which_revs):
+    """Return all the revisions without intermediate deltas.
+
+    Useful for log commands that won't need the delta information.
+    """
+    
+    for revno, revision_id in which_revs:
+        yield revno, branch.get_revision(revision_id), None
+
+
+def deltas_for_log_reverse(branch, which_revs):
+    """Compute deltas for display in latest-to-earliest order.
+
+    branch
+        Branch to traverse
+
+    which_revs
+        Sequence of (revno, revision_id) for the subset of history to examine
+
+    returns 
+        Sequence of (revno, rev, delta)
+
+    The delta is from the given revision to the next one in the
+    sequence, which makes sense if the log is being displayed from
+    newest to oldest.
+    """
+    last_revno = last_revision_id = last_tree = None
+    for revno, revision_id in which_revs:
+        this_tree = branch.revision_tree(revision_id)
+        this_revision = branch.get_revision(revision_id)
+        
+        if last_revno:
+            yield last_revno, last_revision, compare_trees(this_tree, last_tree, False)
+
+        this_tree = EmptyTree(branch.get_root_id())
+
+        last_revno = revno
+        last_revision = this_revision
+        last_tree = this_tree
+
+    if last_revno:
+        if last_revno == 1:
+            this_tree = EmptyTree(branch.get_root_id())
+        else:
+            this_revno = last_revno - 1
+            this_revision_id = branch.revision_history()[this_revno]
+            this_tree = branch.revision_tree(this_revision_id)
+        yield last_revno, last_revision, compare_trees(this_tree, last_tree, False)
+
+
+def deltas_for_log_forward(branch, which_revs):
+    """Compute deltas for display in forward log.
+
+    Given a sequence of (revno, revision_id) pairs, return
+    (revno, rev, delta).
+
+    The delta is from the given revision to the next one in the
+    sequence, which makes sense if the log is being displayed from
+    newest to oldest.
+    """
+    last_revno = last_revision_id = last_tree = None
+    prev_tree = EmptyTree(branch.get_root_id())
+
+    for revno, revision_id in which_revs:
+        this_tree = branch.revision_tree(revision_id)
+        this_revision = branch.get_revision(revision_id)
+
+        if not last_revno:
+            if revno == 1:
+                last_tree = EmptyTree(branch.get_root_id())
+            else:
+                last_revno = revno - 1
+                last_revision_id = branch.revision_history()[last_revno]
+                last_tree = branch.revision_tree(last_revision_id)
+
+        yield revno, this_revision, compare_trees(last_tree, this_tree, False)
+
+        last_revno = revno
+        last_revision = this_revision
+        last_tree = this_tree
+
+
 class LogFormatter(object):
     """Abstract class to display log messages."""
 

=== modified file 'bzrlib/lsprof.py'
--- bzrlib/lsprof.py	2006-06-20 03:57:11 +0000
+++ bzrlib/lsprof.py	2005-12-08 07:10:37 +0000
@@ -4,7 +4,7 @@
 # instead of just the Stats object
 
 import sys
-from _lsprof import Profiler, profiler_entry
+from _lsprof import Profiler, profiler_entry, profiler_subentry
 
 __all__ = ['profile', 'Stats']
 

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2006-06-20 03:57:11 +0000
+++ bzrlib/merge.py	2006-06-10 00:21:11 +0000
@@ -1,15 +1,15 @@
 # Copyright (C) 2005, 2006 Canonical Ltd
-#
+
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
-#
+
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-#
+
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
@@ -18,8 +18,8 @@
 import os
 import errno
 from tempfile import mkdtemp
-import warnings
 
+import bzrlib
 from bzrlib.branch import Branch
 from bzrlib.conflicts import ConflictList, Conflict
 from bzrlib.delta import compare_trees
@@ -41,12 +41,13 @@
 from bzrlib.osutils import rename, pathjoin, rmtree
 from progress import DummyProgress, ProgressPhase
 from bzrlib.revision import common_ancestor, is_ancestor, NULL_REVISION
+from bzrlib.symbol_versioning import *
 from bzrlib.textfile import check_text_lines
 from bzrlib.trace import mutter, warning, note
 from bzrlib.transform import (TreeTransform, resolve_conflicts, cook_conflicts,
                               FinalPaths, create_by_entry, unique_add)
 from bzrlib.versionedfile import WeaveMerge
-from bzrlib import ui
+import bzrlib.ui
 
 # TODO: Report back as changes are merged in
 
@@ -119,7 +120,7 @@
             changes = compare_trees(self.other_tree, other_basis_tree)
             if changes.has_changed():
                 raise WorkingTreeNotRevision(self.this_tree)
-            other_rev_id = self.other_basis
+            other_rev_id = other_basis
             self.other_tree = other_basis_tree
 
     def file_revisions(self, file_id):
@@ -367,7 +368,7 @@
         self.tt = TreeTransform(working_tree, self.pb)
         try:
             self.pp.next_phase()
-            child_pb = ui.ui_factory.nested_progress_bar()
+            child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
             try:
                 for num, file_id in enumerate(all_ids):
                     child_pb.update('Preparing file merge', num, len(all_ids))
@@ -378,7 +379,7 @@
                 child_pb.finished()
                 
             self.pp.next_phase()
-            child_pb = ui.ui_factory.nested_progress_bar()
+            child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
             try:
                 fs_conflicts = resolve_conflicts(self.tt, child_pb)
             finally:
@@ -895,7 +896,7 @@
                      branch.get_revision_tree(base_revision))'
         """
     if this_tree is None:
-        warnings.warn("bzrlib.merge.merge_inner requires a this_tree parameter as of "
+        warn("bzrlib.merge.merge_inner requires a this_tree parameter as of "
              "bzrlib version 0.8.",
              DeprecationWarning,
              stacklevel=2)

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2006-06-20 05:32:16 +0000
+++ bzrlib/msgeditor.py	2006-06-06 12:06:20 +0000
@@ -26,7 +26,6 @@
 import bzrlib
 import bzrlib.config as config
 from bzrlib.errors import BzrError
-from bzrlib.trace import warning, mutter
 
 
 def _get_editor():
@@ -57,7 +56,6 @@
     for e in _get_editor():
         edargs = e.split(' ')
         try:
-            ## mutter("trying editor: %r", (edargs +[filename]))
             x = call(edargs + [filename])
         except OSError, e:
            # We're searching for an editor, so catch safe errors and continue
@@ -144,7 +142,7 @@
             try:
                 os.unlink(msgfilename)
             except IOError, e:
-                warning("failed to unlink %s: %s; ignored", msgfilename, e)
+                mutter("failed to unlink %s: %s; ignored", msgfilename, e)
 
 
 def make_commit_message_template(working_tree, specific_files):

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2006-06-20 03:57:11 +0000
+++ bzrlib/option.py	2006-06-10 00:21:11 +0000
@@ -19,7 +19,8 @@
 
 import re
 
-from bzrlib.trace import warning
+import bzrlib.commands
+from bzrlib.trace import warning, mutter
 from bzrlib.revisionspec import RevisionSpec
 from bzrlib.errors import BzrCommandError
 

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2006-06-20 05:32:16 +0000
+++ bzrlib/osutils.py	2006-06-16 15:59:24 +0000
@@ -18,14 +18,8 @@
 
 from cStringIO import StringIO
 import errno
-from ntpath import (abspath as _nt_abspath,
-                    join as _nt_join,
-                    normpath as _nt_normpath,
-                    realpath as _nt_realpath,
-                    )
 import os
 from os import listdir
-import posixpath
 import re
 import sha
 import shutil
@@ -39,6 +33,11 @@
 import types
 import tempfile
 import unicodedata
+from ntpath import (abspath as _nt_abspath,
+                    join as _nt_join,
+                    normpath as _nt_normpath,
+                    realpath as _nt_realpath,
+                    )
 
 import bzrlib
 from bzrlib.errors import (BzrError,
@@ -47,9 +46,9 @@
                            PathNotChild,
                            IllegalPath,
                            )
-from bzrlib.symbol_versioning import (deprecated_function, 
-        zero_nine)
+from bzrlib.symbol_versioning import *
 from bzrlib.trace import mutter
+import bzrlib.win32console
 
 
 def make_readonly(filename):
@@ -204,25 +203,24 @@
 # string.
 _fs_enc = sys.getfilesystemencoding()
 def _posix_abspath(path):
-    # jam 20060426 rather than encoding to fsencoding
-    # copy posixpath.abspath, but use os.getcwdu instead
-    if not posixpath.isabs(path):
-        path = posixpath.join(getcwd(), path)
-    return posixpath.normpath(path)
+    return os.path.abspath(path.encode(_fs_enc)).decode(_fs_enc)
+    # jam 20060426 This is another possibility which mimics 
+    # os.path.abspath, only uses unicode characters instead
+    # if not os.path.isabs(path):
+    #     return os.path.join(os.getcwdu(), path)
+    # return path
 
 
 def _posix_realpath(path):
-    return posixpath.realpath(path.encode(_fs_enc)).decode(_fs_enc)
+    return os.path.realpath(path.encode(_fs_enc)).decode(_fs_enc)
 
 
 def _win32_abspath(path):
-    # Real _nt_abspath doesn't have a problem with a unicode cwd
-    return _nt_abspath(unicode(path)).replace('\\', '/')
+    return _nt_abspath(path.encode(_fs_enc)).decode(_fs_enc).replace('\\', '/')
 
 
 def _win32_realpath(path):
-    # Real _nt_realpath doesn't have a problem with a unicode cwd
-    return _nt_realpath(unicode(path)).replace('\\', '/')
+    return _nt_realpath(path.encode(_fs_enc)).decode(_fs_enc).replace('\\', '/')
 
 
 def _win32_pathjoin(*args):
@@ -230,7 +228,7 @@
 
 
 def _win32_normpath(path):
-    return _nt_normpath(unicode(path)).replace('\\', '/')
+    return _nt_normpath(path).replace('\\', '/')
 
 
 def _win32_getcwd():
@@ -290,33 +288,6 @@
         return shutil.rmtree(path, ignore_errors, onerror)
 
 
-def get_terminal_encoding():
-    """Find the best encoding for printing to the screen.
-
-    This attempts to check both sys.stdout and sys.stdin to see
-    what encoding they are in, and if that fails it falls back to
-    bzrlib.user_encoding.
-    The problem is that on Windows, locale.getpreferredencoding()
-    is not the same encoding as that used by the console:
-    http://mail.python.org/pipermail/python-list/2003-May/162357.html
-
-    On my standard US Windows XP, the preferred encoding is
-    cp1252, but the console is cp437
-    """
-    output_encoding = getattr(sys.stdout, 'encoding', None)
-    if not output_encoding:
-        input_encoding = getattr(sys.stdin, 'encoding', None)
-        if not input_encoding:
-            output_encoding = bzrlib.user_encoding
-            mutter('encoding stdout as bzrlib.user_encoding %r', output_encoding)
-        else:
-            output_encoding = input_encoding
-            mutter('encoding stdout as sys.stdin encoding %r', output_encoding)
-    else:
-        mutter('encoding stdout as sys.stdout encoding %r', output_encoding)
-    return output_encoding
-
-
 def normalizepath(f):
     if hasattr(os.path, 'realpath'):
         F = realpath

=== modified file 'bzrlib/patiencediff.py'
--- bzrlib/patiencediff.py	2006-06-20 03:57:11 +0000
+++ bzrlib/patiencediff.py	2006-05-29 00:50:34 +0000
@@ -17,6 +17,7 @@
 
 
 from bisect import bisect
+from copy import copy
 import difflib
 import os
 import sys

=== modified file 'bzrlib/plugin.py'
--- bzrlib/plugin.py	2006-06-04 21:22:51 +0000
+++ bzrlib/plugin.py	2006-02-13 01:28:03 +0000
@@ -46,7 +46,7 @@
 
 import bzrlib
 from bzrlib.config import config_dir
-from bzrlib.trace import log_error, mutter, warning, \
+from bzrlib.trace import log_error, mutter, log_exception, warning, \
         log_exception_quietly
 from bzrlib.errors import BzrError
 from bzrlib import plugins

=== modified file 'bzrlib/reconcile.py'
--- bzrlib/reconcile.py	2006-06-20 03:57:11 +0000
+++ bzrlib/reconcile.py	2006-06-12 01:53:19 +0000
@@ -20,9 +20,12 @@
 __all__ = ['reconcile', 'Reconciler', 'RepoReconciler', 'KnitReconciler']
 
 
-from bzrlib import ui
+import bzrlib.branch
+import bzrlib.errors as errors
+import bzrlib.progress
 from bzrlib.trace import mutter
 from bzrlib.tsort import TopoSorter
+import bzrlib.ui as ui
 
 
 def reconcile(dir, other=None):

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2006-06-20 05:32:16 +0000
+++ bzrlib/repository.py	2006-06-16 19:55:10 +0000
@@ -21,9 +21,11 @@
 import time
 from unittest import TestSuite
 
-from bzrlib import bzrdir, check, delta, gpg, errors, xml5, ui, transactions, osutils
+import bzrlib.bzrdir as bzrdir
 from bzrlib.decorators import needs_read_lock, needs_write_lock
+import bzrlib.errors as errors
 from bzrlib.errors import InvalidRevisionId
+import bzrlib.gpg as gpg
 from bzrlib.graph import Graph
 from bzrlib.inter import InterObject
 from bzrlib.inventory import Inventory
@@ -35,15 +37,16 @@
 from bzrlib.revision import NULL_REVISION, Revision
 from bzrlib.store.versioned import VersionedFileStore, WeaveStore
 from bzrlib.store.text import TextStore
-from bzrlib.symbol_versioning import (deprecated_method,
-        zero_nine, 
-        )
+from bzrlib.symbol_versioning import *
 from bzrlib.trace import mutter, note
 from bzrlib.tree import RevisionTree, EmptyTree
 from bzrlib.tsort import topo_sort
 from bzrlib.testament import Testament
 from bzrlib.tree import EmptyTree
+from bzrlib.delta import compare_trees
+import bzrlib.ui
 from bzrlib.weave import WeaveFile
+import bzrlib.xml5
 
 
 class Repository(object):
@@ -70,11 +73,11 @@
         assert inv.revision_id is None or inv.revision_id == revid, \
             "Mismatch between inventory revision" \
             " id and insertion revid (%r, %r)" % (inv.revision_id, revid)
-        inv_text = xml5.serializer_v5.write_inventory_to_string(inv)
-        inv_sha1 = osutils.sha_string(inv_text)
+        inv_text = bzrlib.xml5.serializer_v5.write_inventory_to_string(inv)
+        inv_sha1 = bzrlib.osutils.sha_string(inv_text)
         inv_vf = self.control_weaves.get_weave('inventory',
                                                self.get_transaction())
-        self._inventory_add_lines(inv_vf, revid, parents, osutils.split_lines(inv_text))
+        self._inventory_add_lines(inv_vf, revid, parents, bzrlib.osutils.split_lines(inv_text))
         return inv_sha1
 
     def _inventory_add_lines(self, inv_vf, revid, parents, lines):
@@ -117,6 +120,7 @@
         """Return all the possible revisions that we could find."""
         return self.get_inventory_weave().versions()
 
+    @deprecated_method(zero_nine)
     def all_revision_ids(self):
         """Returns a list of all the revision ids in the repository. 
 
@@ -223,7 +227,7 @@
         For instance, if the repository is at URL/.bzr/repository,
         Repository.open(URL) -> a Repository instance.
         """
-        control = bzrdir.BzrDir.open(base)
+        control = bzrlib.bzrdir.BzrDir.open(base)
         return control.open_repository()
 
     def copy_content_into(self, destination, revision_id=None, basis=None):
@@ -274,9 +278,9 @@
             result = a_bzrdir.create_repository()
         # FIXME RBC 20060209 split out the repository type to avoid this check ?
         elif isinstance(a_bzrdir._format,
-                      (bzrdir.BzrDirFormat4,
-                       bzrdir.BzrDirFormat5,
-                       bzrdir.BzrDirFormat6)):
+                      (bzrlib.bzrdir.BzrDirFormat4,
+                       bzrlib.bzrdir.BzrDirFormat5,
+                       bzrlib.bzrdir.BzrDirFormat6)):
             result = a_bzrdir.open_repository()
         else:
             result = self._format.initialize(a_bzrdir, shared=self.is_shared())
@@ -343,7 +347,7 @@
             old_tree = EmptyTree()
         else:
             old_tree = self.revision_tree(revision.parent_ids[0])
-        return delta.compare_trees(old_tree, new_tree)
+        return compare_trees(old_tree, new_tree)
 
     def _check_revision_parents(self, revision, inventory):
         """Private to Repository and Fetch.
@@ -427,7 +431,7 @@
         :param revision_id: The expected revision id of the inventory.
         :param xml: A serialised inventory.
         """
-        return xml5.serializer_v5.read_inventory_from_string(xml)
+        return bzrlib.xml5.serializer_v5.read_inventory_from_string(xml)
 
     @needs_read_lock
     def get_inventory_xml(self, revision_id):
@@ -437,7 +441,7 @@
             iw = self.get_inventory_weave()
             return iw.get_text(revision_id)
         except IndexError:
-            raise errors.HistoryMissing(self, 'inventory', revision_id)
+            raise bzrlib.errors.HistoryMissing(self, 'inventory', revision_id)
 
     @needs_read_lock
     def get_inventory_sha1(self, revision_id):
@@ -639,7 +643,7 @@
         return self._check(revision_ids)
 
     def _check(self, revision_ids):
-        result = check.Check(self)
+        result = bzrlib.check.Check(self)
         result.check()
         return result
 
@@ -916,9 +920,8 @@
         reconciler.reconcile()
         return reconciler
     
-    def revision_parents(self, revision_id):
-        return self._get_revision_vf().get_parents(revision_id)
-
+    def revision_parents(self, revid):
+        return self._get_revision_vf().get_parents(rev_id)
 
 class RepositoryFormat(object):
     """A repository format.
@@ -960,7 +963,7 @@
         except errors.NoSuchFile:
             raise errors.NoRepositoryPresent(a_bzrdir)
         except KeyError:
-            raise errors.UnknownFormatError(format=format_string)
+            raise errors.UnknownFormatError(format_string)
 
     def _get_control_store(self, repo_transport, control_files):
         """Return the control store for this repository."""
@@ -1087,7 +1090,7 @@
         
         # Create an empty weave
         sio = StringIO()
-        write_weave_v5(Weave(), sio)
+        bzrlib.weavefile.write_weave_v5(Weave(), sio)
         empty_weave = sio.getvalue()
 
         mutter('creating repository in %s.', a_bzrdir.transport.base)
@@ -1153,7 +1156,7 @@
 
     def __init__(self):
         super(RepositoryFormat4, self).__init__()
-        self._matchingbzrdir = bzrdir.BzrDirFormat4()
+        self._matchingbzrdir = bzrlib.bzrdir.BzrDirFormat4()
 
     def get_format_description(self):
         """See RepositoryFormat.get_format_description()."""
@@ -1202,7 +1205,7 @@
 
     def __init__(self):
         super(RepositoryFormat5, self).__init__()
-        self._matchingbzrdir = bzrdir.BzrDirFormat5()
+        self._matchingbzrdir = bzrlib.bzrdir.BzrDirFormat5()
 
     def get_format_description(self):
         """See RepositoryFormat.get_format_description()."""
@@ -1232,7 +1235,7 @@
 
     def __init__(self):
         super(RepositoryFormat6, self).__init__()
-        self._matchingbzrdir = bzrdir.BzrDirFormat6()
+        self._matchingbzrdir = bzrlib.bzrdir.BzrDirFormat6()
 
     def get_format_description(self):
         """See RepositoryFormat.get_format_description()."""
@@ -1256,7 +1259,7 @@
 
     def __init__(self):
         super(MetaDirRepositoryFormat, self).__init__()
-        self._matchingbzrdir = bzrdir.BzrDirMetaFormat1()
+        self._matchingbzrdir = bzrlib.bzrdir.BzrDirMetaFormat1()
 
     def _create_control_files(self, a_bzrdir):
         """Create the required files and the initial control_files object."""
@@ -1337,7 +1340,7 @@
 
         # Create an empty weave
         sio = StringIO()
-        write_weave_v5(Weave(), sio)
+        bzrlib.weavefile.write_weave_v5(Weave(), sio)
         empty_weave = sio.getvalue()
 
         mutter('creating repository in %s.', a_bzrdir.transport.base)
@@ -1448,7 +1451,7 @@
         repo_transport = a_bzrdir.get_repository_transport(None)
         control_files = LockableFiles(repo_transport, 'lock', LockDir)
         control_store = self._get_control_store(repo_transport, control_files)
-        transaction = transactions.WriteTransaction()
+        transaction = bzrlib.transactions.WriteTransaction()
         # trigger a write of the inventory store.
         control_store.get_weave_or_empty('inventory', transaction)
         _revision_store = self._get_revision_store(repo_transport, control_files)
@@ -1657,7 +1660,7 @@
                 pass
             # FIXME do not peek!
             if self.source.control_files._transport.listable():
-                pb = ui.ui_factory.nested_progress_bar()
+                pb = bzrlib.ui.ui_factory.nested_progress_bar()
                 try:
                     self.target.weave_store.copy_all_ids(
                         self.source.weave_store,
@@ -2086,7 +2089,7 @@
             # TODO: Rather than invoking sha_strings here, _add_text_to_weave
             # should return the SHA1 and size
             self._add_text_to_weave(file_id, new_lines, file_parents.keys())
-            return osutils.sha_strings(new_lines), \
+            return bzrlib.osutils.sha_strings(new_lines), \
                 sum(map(len, new_lines))
 
     def modified_link(self, file_id, file_parents, link_target):

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2006-06-20 03:57:11 +0000
+++ bzrlib/revision.py	2006-06-13 13:24:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical
+# (C) 2005 Canonical
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,13 +18,12 @@
 # perhaps show them in log -v and allow them as options to the commit command.
 
 
+import bzrlib.errors
 import bzrlib.errors as errors
 from bzrlib.graph import node_distances, select_farthest, all_descendants, Graph
 from bzrlib.osutils import contains_whitespace
 from bzrlib.progress import DummyProgress
-from bzrlib.symbol_versioning import (deprecated_function,
-        zero_eight,
-        )
+from bzrlib.symbol_versioning import *
 
 NULL_REVISION="null:"
 
@@ -131,7 +130,7 @@
                 yield ancestor, distance
             try:
                 revision = revision_source.get_revision(ancestor)
-            except errors.NoSuchRevision, e:
+            except bzrlib.errors.NoSuchRevision, e:
                 if e.revision == revision_id:
                     raise 
                 else:
@@ -221,7 +220,7 @@
     root_b, ancestors_b, descendants_b = revision_graph(
         revision_b, revision_source)
     if root != root_b:
-        raise errors.NoCommonRoot(revision_a, revision_b)
+        raise bzrlib.errors.NoCommonRoot(revision_a, revision_b)
     common = set()
     for node, node_anc in ancestors_b.iteritems():
         if node in ancestors:
@@ -274,15 +273,15 @@
                 
             root = NULL_REVISION
             common.add(NULL_REVISION)
-        except errors.NoCommonRoot:
-            raise errors.NoCommonAncestor(revision_a, revision_b)
+        except bzrlib.errors.NoCommonRoot:
+            raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
             
         pb.update('Picking ancestor', 2, 3)
         distances = node_distances (descendants, ancestors, root)
         pb.update('Picking ancestor', 3, 2)
         farthest = select_farthest(distances, common)
         if farthest is None or farthest == NULL_REVISION:
-            raise errors.NoCommonAncestor(revision_a, revision_b)
+            raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
     finally:
         pb.clear()
     return farthest
@@ -307,7 +306,7 @@
         for source in self._revision_sources:
             try:
                 return source.get_revision(revision_id)
-            except errors.NoSuchRevision, e:
+            except bzrlib.errors.NoSuchRevision, e:
                 pass
         raise e
 
@@ -420,14 +419,14 @@
     """
     root, ancestors, descendants = revision_graph(rev_id, rev_source)
     if len(descendants) == 0:
-        raise errors.NoSuchRevision(rev_source, rev_id)
+        raise NoSuchRevision(rev_source, rev_id)
     if ancestor_id not in descendants:
         rev_source.get_revision(ancestor_id)
-        raise errors.NotAncestor(rev_id, ancestor_id)
+        raise bzrlib.errors.NotAncestor(rev_id, ancestor_id)
     root_descendants = all_descendants(descendants, ancestor_id)
     root_descendants.add(ancestor_id)
     if rev_id not in root_descendants:
-        raise errors.NotAncestor(rev_id, ancestor_id)
+        raise bzrlib.errors.NotAncestor(rev_id, ancestor_id)
     distances = node_distances(descendants, ancestors, ancestor_id,
                                root_descendants=root_descendants)
 

=== modified file 'bzrlib/sign_my_commits.py'
--- bzrlib/sign_my_commits.py	2006-06-20 03:57:11 +0000
+++ bzrlib/sign_my_commits.py	2006-06-10 23:16:19 +0000
@@ -17,9 +17,10 @@
 """Command which looks for unsigned commits by the current user, and signs them.
 """
 
-from bzrlib import config, gpg
 from bzrlib.commands import Command
-from bzrlib.bzrdir import BzrDir
+import bzrlib.config
+import bzrlib.errors as errors
+import bzrlib.gpg
 from bzrlib.option import Option
 
 
@@ -43,16 +44,18 @@
 
     def run(self, location=None, committer=None, dry_run=False):
         if location is None:
-            bzrdir = BzrDir.open_containing('.')[0]
+            bzrdir = bzrlib.bzrdir.BzrDir.open_containing('.')[0]
         else:
             # Passed in locations should be exact
-            bzrdir = BzrDir.open(location)
+            bzrdir = bzrlib.bzrdir.BzrDir.open(location)
         branch = bzrdir.open_branch()
         repo = branch.repository
-        branch_config = config.BranchConfig(branch)
+        config = bzrlib.config.BranchConfig(branch)
+
         if committer is None:
-            committer = branch_config.username()
-        gpg_strategy = gpg.GPGStrategy(branch_config)
+            committer = config.username()
+
+        gpg_strategy = bzrlib.gpg.GPGStrategy(config)
 
         count = 0
         repo.lock_write()

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2006-06-20 05:32:16 +0000
+++ bzrlib/status.py	2006-06-16 10:18:34 +0000
@@ -18,12 +18,10 @@
 
 from bzrlib.delta import compare_trees
 from bzrlib.diff import _raise_if_nonexistent
-import bzrlib.errors as errors
+from bzrlib.errors import NoSuchRevision
 from bzrlib.log import line_log
 from bzrlib.osutils import is_inside_any
-from bzrlib.symbol_versioning import (deprecated_function,
-        zero_eight,
-        )
+from bzrlib.symbol_versioning import *
 
 # TODO: when showing single-line logs, truncate to the width of the terminal
 # if known, but only if really going to the terminal (not into a file)
@@ -119,15 +117,15 @@
             try:
                 rev_id = revision[0].in_history(wt.branch).rev_id
                 old = wt.branch.repository.revision_tree(rev_id)
-            except errors.NoSuchRevision, e:
-                raise errors.BzrCommandError(str(e))
+            except NoSuchRevision, e:
+                raise BzrCommandError(str(e))
             if (len(revision) > 1) and (revision[1].spec is not None):
                 try:
                     rev_id = revision[1].in_history(wt.branch).rev_id
                     new = wt.branch.repository.revision_tree(rev_id)
                     new_is_working_tree = False
-                except errors.NoSuchRevision, e:
-                    raise errors.BzrCommandError(str(e))
+                except NoSuchRevision, e:
+                    raise BzrCommandError(str(e))
             else:
                 new = wt
         _raise_if_nonexistent(specific_files, old, new)
@@ -177,8 +175,8 @@
                 mm_revision = branch.repository.get_revision(mmerge)
                 print >> to_file, '   ', line_log(mm_revision, 75)
                 ignore.add(mmerge)
-        except errors.NoSuchRevision:
-            print >> to_file, ' ', merge
+        except NoSuchRevision:
+            print >> to_file, ' ', merge 
         
 def list_paths(header, paths, specific_files, to_file):
     done_header = False

=== modified file 'bzrlib/store/__init__.py'
--- bzrlib/store/__init__.py	2006-06-20 03:57:11 +0000
+++ bzrlib/store/__init__.py	2006-06-09 09:04:53 +0000
@@ -32,7 +32,7 @@
 import bzrlib
 import bzrlib.errors as errors
 from bzrlib.errors import BzrError, UnlistableStore, TransportNotPossible
-from bzrlib.symbol_versioning import (deprecated_function, zero_eight)
+from bzrlib.symbol_versioning import *
 from bzrlib.trace import mutter
 from bzrlib.transport import Transport
 from bzrlib.transport.local import LocalTransport

=== modified file 'bzrlib/store/revision/knit.py'
--- bzrlib/store/revision/knit.py	2006-06-20 05:32:16 +0000
+++ bzrlib/store/revision/knit.py	2006-06-10 14:22:39 +0000
@@ -96,9 +96,11 @@
         texts = []
         vf = self.get_revision_file(transaction)
         try:
-            return vf.get_texts(revision_ids)
-        except (errors.RevisionNotPresent), e:
-            raise errors.NoSuchRevision(self, e.revision_id)
+            for revision_id in revision_ids:
+                texts.append(vf.get_text(revision_id))
+        except (errors.RevisionNotPresent):
+            raise errors.NoSuchRevision(self, revision_id)
+        return texts
 
     def _get_revision_xml(self, revision_id, transaction):
         try:
@@ -132,5 +134,5 @@
 
     def total_size(self, transaction):
         """ See RevisionStore.total_size()."""
-        return (len(self.all_revision_ids(transaction)),
+        return (len(self.all_revision_ids(transaction)), 
             self.versioned_file_store.total_size()[1])

=== modified file 'bzrlib/store/text.py'
--- bzrlib/store/text.py	2006-06-20 07:55:43 +0000
+++ bzrlib/store/text.py	2006-04-04 10:20:54 +0000
@@ -120,3 +120,7 @@
             from cStringIO import StringIO
             sio = StringIO(f.read())
             return gzip.GzipFile(mode='rb', fileobj=sio)
+
+
+def ScratchTextStore():
+    return TextStore(ScratchTransport())

=== modified file 'bzrlib/store/versioned/__init__.py'
--- bzrlib/store/versioned/__init__.py	2006-06-20 03:57:11 +0000
+++ bzrlib/store/versioned/__init__.py	2006-05-23 04:29:35 +0000
@@ -22,15 +22,13 @@
 import os
 from cStringIO import StringIO
 import urllib
-from warnings import warn
 
-from bzrlib import errors
 from bzrlib.weavefile import read_weave, write_weave_v5
 from bzrlib.weave import WeaveFile, Weave
 from bzrlib.store import TransportStore
 from bzrlib.atomicfile import AtomicFile
-from bzrlib.symbol_versioning import (deprecated_method,
-        zero_eight)
+from bzrlib.errors import NoSuchFile, FileExists
+from bzrlib.symbol_versioning import *
 from bzrlib.trace import mutter
 import bzrlib.ui
 
@@ -114,7 +112,7 @@
         fn = self.filename(file_id)
         try:
             return self._transport.put(fn, f, mode=self._file_mode)
-        except errors.NoSuchFile:
+        except NoSuchFile:
             if not self._prefixed:
                 raise
             self._transport.mkdir(os.path.dirname(fn), mode=self._dir_mode)
@@ -175,7 +173,7 @@
             # for the common case.
             weave = self._versionedfile_class(_filename, self._transport, self._file_mode, create=True,
                                               **self._versionedfile_kwargs)
-        except errors.NoSuchFile:
+        except NoSuchFile:
             if not self._prefixed:
                 # unexpected error - NoSuchFile is expected to be raised on a
                 # missing dir only and that only occurs when we are prefixed.
@@ -196,7 +194,7 @@
         _filename = self.filename(file_id)
         try:
             return self.get_weave(file_id, transaction, _filename=_filename)
-        except errors.NoSuchFile:
+        except NoSuchFile:
             weave = self._make_new_versionedfile(file_id, transaction,
                 known_missing=True, _filename=_filename)
             transaction.map.add_weave(file_id, weave)
@@ -257,7 +255,7 @@
             warn("Please pass to_transaction into "
                  "versioned_store.copy_all_ids.", stacklevel=2)
         if not store_from.listable():
-            raise errors.UnlistableStore(store_from)
+            raise UnlistableStore(store_from)
         ids = []
         for count, file_id in enumerate(store_from):
             if pb:

=== modified file 'bzrlib/tests/EncodingAdapter.py'
--- bzrlib/tests/EncodingAdapter.py	2006-06-11 03:09:28 +0000
+++ bzrlib/tests/EncodingAdapter.py	2006-06-07 16:05:27 +0000
@@ -25,15 +25,6 @@
 # prefix for micro (1/1000000)
 _mu = u'\xb5'
 
-# greek letter omega, not to be confused with
-# the Ohm sign, u'\u2126'. Though they are probably identical
-# cp437 can handle the first, but not the second
-_omega = u'\u03a9'
-
-# smallest error possible, epsilon
-# cp437 handles u03b5, but not u2208 the 'element of' operator
-_epsilon = u'\u03b5'
-
 # Swedish?
 _erik = u'Erik B\xe5gfors'
 
@@ -48,8 +39,8 @@
 
 # Russian, 'Alexander' in russian
 _alexander = u'\u0410\u043b\u0435\u043a\u0441\u0430\u043d\u0434\u0440'
-# The word 'test' in Russian
-_russian_test = u'\u0422\u0435\u0441\u0442'
+# No idea if this means anything, but we need another string
+_alex = u'\u0410\u043b\u0435\u043a'
 
 # Kanji
 # It is a kanji sequence for nihonjin, or Japanese in English.
@@ -109,15 +100,8 @@
                   , 'directory':_something}),
         ('cp1251', 0, {'committer':_alexander
                   , 'message':u'Testing ' + _mu
-                  , 'filename':_russian_test
-                  , 'directory':_russian_test + 'dir'}),
-# The iso-8859-1 tests run on a default windows cp437 installation
-# and it takes a long time to run an extra permutation of the tests
-# But just in case we want to add this back in:
-#        ('cp437', 0, {'committer':_erik
-#                  , 'message':u'Testing ' + _mu
-#                  , 'filename':'file_' + _omega
-#                  , 'directory':_epsilon + '_dir'}),
+                  , 'filename':_alex
+                  , 'directory':_alex + 'dir'}),
     ]
 
     def adapt(self, test):

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2006-06-20 07:55:43 +0000
+++ bzrlib/tests/__init__.py	2006-06-16 21:05:03 +0000
@@ -29,7 +29,6 @@
 import codecs
 from cStringIO import StringIO
 import difflib
-import doctest
 import errno
 import logging
 import os
@@ -70,11 +69,7 @@
 from bzrlib.transport.local import LocalRelpathServer
 from bzrlib.transport.readonly import ReadonlyServer
 from bzrlib.trace import mutter
-from bzrlib.tests import TestUtil
-from bzrlib.tests.TestUtil import (
-                          TestSuite,
-                          TestLoader,
-                          )
+from bzrlib.tests.TestUtil import TestLoader, TestSuite
 from bzrlib.tests.treeshape import build_tree_contents
 import bzrlib.urlutils as urlutils
 from bzrlib.workingtree import WorkingTree, WorkingTreeFormat2
@@ -339,16 +334,8 @@
                 # If LANG=C we probably have created some bogus paths
                 # which rmtree(unicode) will fail to delete
                 # so make sure we are using rmtree(str) to delete everything
-                # except on win32, where rmtree(str) will fail
-                # since it doesn't have the property of byte-stream paths
-                # (they are either ascii or mbcs)
-                if sys.platform == 'win32':
-                    # make sure we are using the unicode win32 api
-                    test_root = unicode(test_root)
-                else:
-                    test_root = test_root.encode(
-                        sys.getfilesystemencoding())
-                osutils.rmtree(test_root)
+                osutils.rmtree(test_root.encode(
+                    sys.getfilesystemencoding()))
         else:
             if self.pb is not None:
                 self.pb.note("Failed tests working directories are in '%s'\n",
@@ -689,6 +676,7 @@
         self.log('run bzr: %r', argv)
         # FIXME: don't call into logging here
         handler = logging.StreamHandler(stderr)
+        handler.setFormatter(bzrlib.trace.QuietFormatter())
         handler.setLevel(logging.INFO)
         logger = logging.getLogger('')
         logger.addHandler(handler)
@@ -1141,7 +1129,7 @@
 
 
 def filter_suite_by_re(suite, pattern):
-    result = TestUtil.TestSuite()
+    result = TestSuite()
     filter_re = re.compile(pattern)
     for test in iter_suite_tests(suite):
         if filter_re.search(test.id()):
@@ -1202,7 +1190,11 @@
     This function can be replaced if you need to change the default test
     suite on a global basis, but it is not encouraged.
     """
-    testmod_names = [
+    from doctest import DocTestSuite
+
+    global MODULES_TO_DOCTEST
+
+    testmod_names = [ \
                    'bzrlib.tests.test_ancestry',
                    'bzrlib.tests.test_api',
                    'bzrlib.tests.test_bad_files',
@@ -1282,7 +1274,8 @@
         'bzrlib.tests.test_transport_implementations',
         'bzrlib.tests.test_read_bundle',
         ]
-    suite = TestUtil.TestSuite()
+
+    suite = TestSuite()
     loader = TestUtil.TestLoader()
     from bzrlib.transport import TransportTestProviderAdapter
     adapter = TransportTestProviderAdapter()
@@ -1292,8 +1285,8 @@
         suite.addTest(package.test_suite())
     for m in MODULES_TO_TEST:
         suite.addTest(loader.loadTestsFromModule(m))
-    for m in MODULES_TO_DOCTEST:
-        suite.addTest(doctest.DocTestSuite(m))
+    for m in (MODULES_TO_DOCTEST):
+        suite.addTest(DocTestSuite(m))
     for name, plugin in bzrlib.plugin.all_plugins().items():
         if getattr(plugin, 'test_suite', None) is not None:
             suite.addTest(plugin.test_suite())

=== modified file 'bzrlib/tests/blackbox/__init__.py'
--- bzrlib/tests/blackbox/__init__.py	2006-06-20 03:30:14 +0000
+++ bzrlib/tests/blackbox/__init__.py	2006-06-06 16:16:09 +0000
@@ -46,14 +46,12 @@
                      'bzrlib.tests.blackbox.test_branch',
                      'bzrlib.tests.blackbox.test_break_lock',
                      'bzrlib.tests.blackbox.test_bound_branches',
-                     'bzrlib.tests.blackbox.test_bundle',
                      'bzrlib.tests.blackbox.test_cat',
                      'bzrlib.tests.blackbox.test_checkout',
                      'bzrlib.tests.blackbox.test_command_encoding',
                      'bzrlib.tests.blackbox.test_commit',
                      'bzrlib.tests.blackbox.test_conflicts',
                      'bzrlib.tests.blackbox.test_diff',
-                     'bzrlib.tests.blackbox.test_exceptions',
                      'bzrlib.tests.blackbox.test_export',
                      'bzrlib.tests.blackbox.test_find_merge_base',
                      'bzrlib.tests.blackbox.test_help',
@@ -72,7 +70,6 @@
                      'bzrlib.tests.blackbox.test_re_sign',
                      'bzrlib.tests.blackbox.test_revert',
                      'bzrlib.tests.blackbox.test_revno',
-                     'bzrlib.tests.blackbox.test_revision_history',
                      'bzrlib.tests.blackbox.test_revision_info',
                      'bzrlib.tests.blackbox.test_selftest',
                      'bzrlib.tests.blackbox.test_shared_repository',

=== modified file 'bzrlib/tests/blackbox/test_aliases.py'
--- bzrlib/tests/blackbox/test_aliases.py	2006-06-15 05:36:34 +0000
+++ bzrlib/tests/blackbox/test_aliases.py	2006-03-12 20:42:58 +0000
@@ -57,9 +57,9 @@
 
         # If --no-aliases breaks all of bzr, we also get retcode=3
         # So we need to catch the output as well
-        self.assertEquals(bzr_catch_error('--no-aliases', 'c', 'a',
-                                          retcode=None),
-                          'bzr: ERROR: unknown command "c"\n')
+        self.assertEquals(bzr_catch_error('--no-aliases', 'c', 'a', 
+                                          retcode=None), 
+                          "bzr: ERROR: unknown command 'c'\n")
 
         bzr('c', '-r1', '-r2', retcode=3)
         bzr('c1', '-r1', '-r2', retcode=3)

=== modified file 'bzrlib/tests/blackbox/test_ancestry.py'
--- bzrlib/tests/blackbox/test_ancestry.py	2006-05-31 08:44:29 +0000
+++ bzrlib/tests/blackbox/test_ancestry.py	2006-05-16 03:02:08 +0000
@@ -19,12 +19,12 @@
 from bzrlib.builtins import merge
 from bzrlib.tests import TestCaseWithTransport
 from bzrlib.workingtree import WorkingTree
-from bzrlib.branch import Branch
 
 
 class TestAncestry(TestCaseWithTransport):
 
-    def _build_branches(self):
+    def test_ancestry(self):
+        """Tests 'ancestry' command"""
         a_wt = self.make_branch_and_tree('A')
         open('A/foo', 'wb').write('1111\n')
         a_wt.add('foo')
@@ -37,65 +37,13 @@
         a_wt.commit('modified A/foo',rev_id='A2')
         merge(['B',-1],['B',1],this_dir='A')
         a_wt.commit('merged B into A',rev_id='A3')
-
-    def _check_ancestry(self, location='', result=None):
-        out = self.capture('ancestry ' + location)
-        if result is None:
-            result = "A1\nB1\nA2\nA3\n"
-        self.assertEqualDiff(out, result)
-
-    def test_ancestry(self):
-        """Tests 'ancestry' command"""
-        self._build_branches()
         os.chdir('A')
-        self._check_ancestry()
-
-    def test_ancestry_with_location(self):
-        """Tests 'ancestry' command with a specified location."""
-        self._build_branches()
-        self._check_ancestry('A')
-
-    def test_ancestry_with_repo_branch(self):
-        """Tests 'ancestry' command with a location that is a
-        repository branch."""
-        self._build_branches()
-        self.run_bzr('init-repo', 'repo')
-        self.run_bzr('branch', 'A', 'repo/A')
-        self._check_ancestry('repo/A')
-
-    def test_ancestry_with_checkout(self):
-        """Tests 'ancestry' command with a location that is a
-        checkout of a repository branch."""
-        self._build_branches()
-        self.run_bzr('init-repo', 'repo')
-        self.run_bzr('branch', 'A', 'repo/A')
-        self.run_bzr('checkout', 'repo/A', 'A-checkout')
-        self._check_ancestry('A-checkout')
-
-    def test_ancestry_with_lightweight_checkout(self):
-        """Tests 'ancestry' command with a location that is a
-        lightweight checkout of a repository branch."""
-        self._build_branches()
-        self.run_bzr('init-repo', 'repo')
-        self.run_bzr('branch', 'A', 'repo/A')
-        self.run_bzr('checkout', '--lightweight', 'repo/A', 'A-checkout')
-        self._check_ancestry('A-checkout')
-
-    def test_ancestry_with_truncated_checkout(self):
-        """Tests 'ancestry' command with a location that is a
-        checkout of a repository branch with a shortened revision history."""
-        self._build_branches()
-        self.run_bzr('init-repo', 'repo')
-        self.run_bzr('branch', 'A', 'repo/A')
-        self.run_bzr('checkout', '-r', '2', 'repo/A', 'A-checkout')
-        self._check_ancestry('A-checkout', "A1\nA2\n")
-
-    def test_ancestry_with_truncated_lightweight_checkout(self):
-        """Tests 'ancestry' command with a location that is a lightweight
-        checkout of a repository branch with a shortened revision history."""
-        self._build_branches()
-        self.run_bzr('init-repo', 'repo')
-        self.run_bzr('branch', 'A', 'repo/A')
-        self.run_bzr('checkout', '-r', '2', '--lightweight',
-                'repo/A', 'A-checkout')
-        self._check_ancestry('A-checkout', "A1\nA2\n")
+        out, err = self.run_bzr('ancestry')
+        self.assertEquals(err, '')
+        self.assertEqualDiff(out,
+"""A1
+B1
+A2
+A3
+""")
+

=== modified file 'bzrlib/tests/blackbox/test_annotate.py'
--- bzrlib/tests/blackbox/test_annotate.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/blackbox/test_annotate.py	2006-05-05 01:29:34 +0000
@@ -28,6 +28,7 @@
 import os
 import shutil
 import sys
+import os
 
 from bzrlib.branch import Branch
 from bzrlib.errors import BzrCommandError

=== modified file 'bzrlib/tests/blackbox/test_branch.py'
--- bzrlib/tests/blackbox/test_branch.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/blackbox/test_branch.py	2006-05-24 16:21:15 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 by Canonical Ltd
+# Copyright (C) 2005,2006 by Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,7 +19,8 @@
 
 import os
 
-from bzrlib import branch, bzrdir
+import bzrlib.branch
+import bzrlib.bzrdir
 from bzrlib.repository import RepositoryFormatKnit1
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.workingtree import WorkingTree
@@ -43,7 +44,7 @@
         self.example_branch()
         os.chdir('..')
         self.runbzr('branch a b')
-        b = branch.Branch.open('b')
+        b = bzrlib.branch.Branch.open('b')
         self.assertEqual('b\n', b.control_files.get_utf8('branch-name').read())
         self.runbzr('branch a c -r 1')
         os.chdir('b')
@@ -65,14 +66,14 @@
         self.assertFalse(source.branch.repository.has_revision('2'))
         dir = source.bzrdir
         self.runbzr('branch source target --basis commit_tree')
-        target = bzrdir.BzrDir.open('target')
+        target = bzrlib.bzrdir.BzrDir.open('target')
         self.assertEqual('2', target.open_branch().last_revision())
         self.assertEqual('2', target.open_workingtree().last_revision())
         self.assertTrue(target.open_branch().repository.has_revision('2'))
 
     def test_branch_only_copies_history(self):
         # Knit branches should only push the history for the current revision.
-        format = bzrdir.BzrDirMetaFormat1()
+        format = bzrlib.bzrdir.BzrDirMetaFormat1()
         format.repository_format = RepositoryFormatKnit1()
         shared_repo = self.make_repository('repo', format=format, shared=True)
         shared_repo.set_make_working_trees(True)

=== removed file 'bzrlib/tests/blackbox/test_bundle.py'
--- bzrlib/tests/blackbox/test_bundle.py	2006-06-16 22:29:03 +0000
+++ bzrlib/tests/blackbox/test_bundle.py	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-# Copyright (C) 2006 by Canonical Ltd
-# Authors: Aaron Bentley
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-import os
-from StringIO import StringIO
-
-from bzrlib.bundle.read_bundle import BundleReader
-from bzrlib.bzrdir import BzrDir
-from bzrlib.tests import TestCaseInTempDir
-
-
-class TestBundle(TestCaseInTempDir):
-
-    def test_uses_parent(self):
-        """Parent location is used as a basis by default"""
-        
-        parent_tree = BzrDir.create_standalone_workingtree('parent')
-        parent_tree.commit('initial commit', rev_id='revision1')
-        os.chdir('parent')
-        errmsg = self.run_bzr('bundle', retcode=3)[1]
-        self.assertContainsRe(errmsg, 'No base branch known or specified')
-        branch_tree = parent_tree.bzrdir.sprout('../branch').open_workingtree()
-        branch_tree.commit('next commit', rev_id='revision2')
-        branch_tree.commit('last commit', rev_id='revision3')
-        os.chdir('../branch')
-        br = BundleReader(StringIO(self.run_bzr('bundle')[0]))
-        self.assertEqual(br.info.revisions[0].revision_id, 'revision3')
-        self.assertEqual(len(br.info.revisions), 2)
-        self.assertEqual(br.info.revisions[1].revision_id, 'revision2')

=== removed file 'bzrlib/tests/blackbox/test_exceptions.py'
--- bzrlib/tests/blackbox/test_exceptions.py	2006-06-15 05:49:38 +0000
+++ bzrlib/tests/blackbox/test_exceptions.py	1970-01-01 00:00:00 +0000
@@ -1,37 +0,0 @@
-# Copyright (C) 2006 by Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for display of exceptions."""
-
-import os
-import sys
-
-from bzrlib.tests import TestCaseInTempDir, TestCase
-from bzrlib.errors import NotBranchError
-
-class TestExceptionReporting(TestCase):
-
-    def test_report_exception(self):
-        """When an error occurs, display bug report details to stderr"""
-        out, err = self.run_bzr("assert-fail", retcode=3)
-        self.assertContainsRe(err,
-                r'bzr: ERROR: exceptions\.AssertionError: always fails\n')
-        self.assertContainsRe(err, r'please send this report to')
-
-    # TODO: assert-fail doesn't need to always be present; we could just
-    # register (and unregister) it from tests that want to touch it.
-    #
-    # TODO: Some kind of test for the feature of invoking pdb

=== modified file 'bzrlib/tests/blackbox/test_init.py'
--- bzrlib/tests/blackbox/test_init.py	2006-06-15 05:36:34 +0000
+++ bzrlib/tests/blackbox/test_init.py	2006-05-05 01:29:34 +0000
@@ -70,9 +70,9 @@
         
         out, err = self.run_bzr('init', 'subdir2/nothere', retcode=3)
         self.assertEqual('', out)
-        self.assertContainsRe(err,
-            r'^bzr: ERROR: .*'
-            '\[Errno 2\] No such file or directory: ')
+        self.failUnless(err.startswith(
+            'bzr: ERROR: exceptions.OSError: '
+            '[Errno 2] No such file or directory: '))
         
         os.mkdir('subdir2')
         out, err = self.run_bzr('init', 'subdir2')

=== modified file 'bzrlib/tests/blackbox/test_logformats.py'
--- bzrlib/tests/blackbox/test_logformats.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/blackbox/test_logformats.py	2006-03-12 20:42:58 +0000
@@ -14,7 +14,7 @@
         return self.run_bzr(*args, **kwargs)[0]
 
     def test_log_default_format(self):
-        self.setup_config()
+        setup_config()
 
         self.bzr('init')
         open('a', 'wb').write('foo\n')
@@ -42,7 +42,7 @@
         self.assertEquals(7, len(self.bzr('log', '--log-format', 'short').split('\n')))
 
     def test_missing_default_format(self):
-        self.setup_config()
+        setup_config()
 
         os.mkdir('a')
         os.chdir('a')
@@ -69,7 +69,7 @@
         os.chdir('..')
 
     def test_missing_format_arg(self):
-        self.setup_config()
+        setup_config()
 
         os.mkdir('a')
         os.chdir('a')
@@ -96,7 +96,7 @@
         os.chdir('..')
 
 
-    def setup_config(self):
+def setup_config():
         if os.path.isfile(config_filename()):
                 # Something is wrong in environment, 
                 # we risk overwriting users config 
@@ -108,3 +108,4 @@
                 "log_format=line\n")
 
         open(config_filename(),'wb').write(CONFIG)
+

=== modified file 'bzrlib/tests/blackbox/test_non_ascii.py'
--- bzrlib/tests/blackbox/test_non_ascii.py	2006-06-11 02:57:43 +0000
+++ bzrlib/tests/blackbox/test_non_ascii.py	2006-06-07 16:05:27 +0000
@@ -21,7 +21,6 @@
 import os
 
 import bzrlib
-import bzrlib.osutils as osutils
 from bzrlib.tests import TestCaseInTempDir, TestSkipped
 from bzrlib.trace import mutter, note
 import bzrlib.urlutils as urlutils
@@ -53,7 +52,6 @@
         bzr = self.run_bzr
 
         fs_enc = sys.getfilesystemencoding()
-        terminal_enc = osutils.get_terminal_encoding()
         fname = self.info['filename']
         dir_name = self.info['directory']
         for thing in [fname, dir_name]:
@@ -61,16 +59,8 @@
                 thing.encode(fs_enc)
             except UnicodeEncodeError:
                 raise TestSkipped(('Unable to represent path %r'
-                                   ' in filesystem encoding "%s"')
+                                   ' in filesystem encoding %s')
                                     % (thing, fs_enc))
-            try:
-                thing.encode(terminal_enc)
-            except UnicodeEncodeError:
-                raise TestSkipped(('Unable to represent path %r'
-                                   ' in terminal encoding "%s"'
-                                   ' (even though it is valid in'
-                                   ' filesystem encoding "%s")')
-                                   % (thing, terminal_enc, fs_enc))
 
         bzr('init')
         open('a', 'wb').write('foo\n')
@@ -218,7 +208,7 @@
         open('a', 'ab').write('more text\n')
         bzr('commit', '-m', 'mod a')
 
-        pwd = osutils.getcwd()
+        pwd = os.getcwdu()
 
         os.chdir(u'../' + dirname2)
         txt = bzr('pull')

=== modified file 'bzrlib/tests/blackbox/test_pull.py'
--- bzrlib/tests/blackbox/test_pull.py	2006-06-20 03:30:14 +0000
+++ bzrlib/tests/blackbox/test_pull.py	2006-06-15 22:51:05 +0000
@@ -247,7 +247,7 @@
         tree_b.commit('commit d')
         out = self.runbzr('pull ../branch_a', retcode=3)
         self.assertEquals(out,
-                ('','bzr: ERROR: These branches have diverged.  Use the merge command to reconcile them.\n'))
+                ('','bzr: ERROR: These branches have diverged.  Try merge.\n'))
         self.assertEquals(branch_b.get_parent(), parent)
         # test implicit --remember after resolving previous failure
         uncommit(branch=branch_b, tree=tree_b)

=== modified file 'bzrlib/tests/blackbox/test_push.py'
--- bzrlib/tests/blackbox/test_push.py	2006-06-17 00:49:34 +0000
+++ bzrlib/tests/blackbox/test_push.py	2006-05-21 13:58:58 +0000
@@ -27,7 +27,6 @@
 from bzrlib.repository import RepositoryFormatKnit1
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.uncommit import uncommit
-from bzrlib.urlutils import local_path_from_url
 from bzrlib.workingtree import WorkingTree
 
 
@@ -53,43 +52,28 @@
         tree_b.commit('commit c')
         # initial push location must be empty
         self.assertEqual(None, branch_b.get_push_location())
-
         # test push for failure without push location set
         os.chdir('branch_a')
         out = self.runbzr('push', retcode=3)
         self.assertEquals(out,
                 ('','bzr: ERROR: No push location known or specified.\n'))
-
-        # test not remembered if cannot actually push
-        self.run_bzr('push', '../path/which/doesnt/exist', retcode=3)
-        out = self.run_bzr('push', retcode=3)
-        self.assertEquals(
-                ('', 'bzr: ERROR: No push location known or specified.\n'),
-                out)
-
         # test implicit --remember when no push location set, push fails
-        out = self.run_bzr('push', '../branch_b', retcode=3)
+        out = self.runbzr('push ../branch_b', retcode=3)
         self.assertEquals(out,
                 ('','bzr: ERROR: These branches have diverged.  '
                     'Try a merge then push with overwrite.\n'))
         self.assertEquals(abspath(branch_a.get_push_location()),
                           abspath(branch_b.bzrdir.root_transport.base))
-
         # test implicit --remember after resolving previous failure
         uncommit(branch=branch_b, tree=tree_b)
         transport.delete('branch_b/c')
-        out = self.run_bzr('push')
-        path = branch_a.get_push_location()
-        self.assertEquals(('Using saved location: %s\n' 
-                           % (local_path_from_url(path),)
-                          , 'All changes applied successfully.\n'
-                            '1 revision(s) pushed.\n'), out)
-        self.assertEqual(path,
-                         branch_b.bzrdir.root_transport.base)
+        self.runbzr('push')
+        self.assertEquals(abspath(branch_a.get_push_location()),
+                          abspath(branch_b.bzrdir.root_transport.base))
         # test explicit --remember
-        self.run_bzr('push', '../branch_c', '--remember')
-        self.assertEquals(branch_a.get_push_location(),
-                          branch_c.bzrdir.root_transport.base)
+        self.runbzr('push ../branch_c --remember')
+        self.assertEquals(abspath(branch_a.get_push_location()),
+                          abspath(branch_c.bzrdir.root_transport.base))
     
     def test_push_without_tree(self):
         # bzr push from a branch that does not have a checkout should work.

=== removed file 'bzrlib/tests/blackbox/test_revision_history.py'
--- bzrlib/tests/blackbox/test_revision_history.py	2006-05-30 15:03:34 +0000
+++ bzrlib/tests/blackbox/test_revision_history.py	1970-01-01 00:00:00 +0000
@@ -1,75 +0,0 @@
-# Copyright (C) 2006, Michael Ellerman
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-from bzrlib.tests import TestCaseWithTransport
-from bzrlib.branch import Branch
-
-
-class TestRevisionHistory(TestCaseWithTransport):
-
-    def _build_branch(self):
-        # setup a standalone branch with three commits
-        tree = self.make_branch_and_tree('test')
-        open('test/foo', 'wb').write('1111\n')
-        tree.add('foo')
-        tree.commit('added foo',rev_id='revision_1')
-        open('test/foo', 'wb').write('2222\n')
-        tree.commit('updated foo',rev_id='revision_2')
-        open('test/foo', 'wb').write('3333\n')
-        tree.commit('updated foo again',rev_id='revision_3')
-        return tree
-
-    def _check_revision_history(self, location=''):
-        rh = self.capture('revision-history ' + location)
-        self.assertEqual(rh, 'revision_1\nrevision_2\nrevision_3\n')
-
-    def test_revision_history(self):
-        """Tests 'revision_history' command"""
-        self._build_branch()
-        os.chdir('test')
-        self._check_revision_history()
-
-    def test_revision_history_with_location(self):
-        """Tests 'revision_history' command with a specified location."""
-        self._build_branch()
-        self._check_revision_history('test')
-
-    def test_revision_history_with_repo_branch(self):
-        """Tests 'revision_history' command with a location that is a
-        repository branch."""
-        self._build_branch()
-        self.run_bzr('init-repo', 'repo')
-        self.run_bzr('branch', 'test', 'repo/test')
-        self._check_revision_history('repo/test')
-
-    def test_revision_history_with_checkout(self):
-        """Tests 'revision_history' command with a location that is a
-        checkout of a repository branch."""
-        self._build_branch()
-        self.run_bzr('init-repo', 'repo')
-        self.run_bzr('branch', 'test', 'repo/test')
-        self.run_bzr('checkout', 'repo/test', 'test-checkout')
-        self._check_revision_history('test-checkout')
-
-    def test_revision_history_with_lightweight_checkout(self):
-        """Tests 'revision_history' command with a location that is a
-        lightweight checkout of a repository branch."""
-        self._build_branch()
-        self.run_bzr('init-repo', 'repo')
-        self.run_bzr('branch', 'test', 'repo/test')
-        self.run_bzr('checkout', '--lightweight', 'repo/test', 'test-checkout')
-        self._check_revision_history('test-checkout')

=== modified file 'bzrlib/tests/branch_implementations/test_branch.py'
--- bzrlib/tests/branch_implementations/test_branch.py	2006-06-20 07:55:43 +0000
+++ bzrlib/tests/branch_implementations/test_branch.py	2006-06-17 19:01:15 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# (C) 2005, 2006 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,19 +19,24 @@
 import os
 import sys
 
-from bzrlib import branch, bzrdir, errors, gpg, transactions, repository
+import bzrlib.branch
+import bzrlib.bzrdir as bzrdir
 from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
+from bzrlib.commit import commit
 from bzrlib.delta import TreeDelta
+import bzrlib.errors as errors
 from bzrlib.errors import (FileExists,
                            NoSuchRevision,
                            NoSuchFile,
                            UninitializableFormat,
                            NotBranchError,
                            )
+import bzrlib.gpg
 from bzrlib.osutils import getcwd
 from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
 from bzrlib.tests.bzrdir_implementations.test_bzrdir import TestCaseWithBzrDir
 from bzrlib.trace import mutter
+import bzrlib.transactions as transactions
 from bzrlib.transport import get_transport
 from bzrlib.transport.http import HttpServer
 from bzrlib.transport.memory import MemoryServer
@@ -239,7 +244,7 @@
         branch = wt.branch
         wt.commit("base", allow_pointless=True, rev_id='A')
         from bzrlib.testament import Testament
-        strategy = gpg.LoopbackGPGStrategy(None)
+        strategy = bzrlib.gpg.LoopbackGPGStrategy(None)
         branch.repository.sign_revision('A', strategy)
         self.assertEqual(Testament.from_revision(branch.repository, 
                          'A').as_short_text(),
@@ -249,7 +254,7 @@
         wt = self.make_branch_and_tree('.')
         branch = wt.branch
         branch.repository.store_revision_signature(
-            gpg.LoopbackGPGStrategy(None), 'FOO', 'A')
+            bzrlib.gpg.LoopbackGPGStrategy(None), 'FOO', 'A')
         self.assertRaises(errors.NoSuchRevision,
                           branch.repository.has_signature_for_revision_id,
                           'A')
@@ -261,7 +266,7 @@
         wt = self.make_branch_and_tree('source')
         wt.commit('A', allow_pointless=True, rev_id='A')
         wt.branch.repository.sign_revision('A',
-            gpg.LoopbackGPGStrategy(None))
+            bzrlib.gpg.LoopbackGPGStrategy(None))
         #FIXME: clone should work to urls,
         # wt.clone should work to disks.
         self.build_tree(['target/'])
@@ -319,7 +324,7 @@
             return
         self.assertEqual(repo.bzrdir.root_transport.base,
                          child_branch.repository.bzrdir.root_transport.base)
-        child_branch = branch.Branch.open(self.get_url('child'))
+        child_branch = bzrlib.branch.Branch.open(self.get_url('child'))
         self.assertEqual(repo.bzrdir.root_transport.base,
                          child_branch.repository.bzrdir.root_transport.base)
 
@@ -338,7 +343,7 @@
 
     def test_get_commit_builder(self):
         self.assertIsInstance(self.make_branch(".").get_commit_builder([]), 
-            repository.CommitBuilder)
+            bzrlib.repository.CommitBuilder)
 
 
 class ChrootedTests(TestCaseWithBranch):
@@ -365,6 +370,24 @@
         branch, relpath = Branch.open_containing(self.get_readonly_url('g/p/q'))
         self.assertEqual('g/p/q', relpath)
         
+# TODO: rewrite this as a regular unittest, without relying on the displayed output        
+#         >>> from bzrlib.commit import commit
+#         >>> bzrlib.trace.silent = True
+#         >>> br1 = ScratchBranch(files=['foo', 'bar'])
+#         >>> br1.working_tree().add('foo')
+#         >>> br1.working_tree().add('bar')
+#         >>> commit(br1, "lala!", rev_id="REVISION-ID-1", verbose=False)
+#         >>> br2 = ScratchBranch()
+#         >>> br2.update_revisions(br1)
+#         Added 2 texts.
+#         Added 1 inventories.
+#         Added 1 revisions.
+#         >>> br2.revision_history()
+#         [u'REVISION-ID-1']
+#         >>> br2.update_revisions(br1)
+#         Added 0 revisions.
+#         >>> br1.text_store.total_size() == br2.text_store.total_size()
+#         True
 
 class InstrumentedTransaction(object):
 
@@ -521,7 +544,7 @@
         t = get_transport(self.get_url())
         readonly_t = get_transport(self.get_readonly_url())
         made_branch = self.make_branch('.')
-        self.failUnless(isinstance(made_branch, branch.Branch))
+        self.failUnless(isinstance(made_branch, bzrlib.branch.Branch))
 
         # find it via bzrdir opening:
         opened_control = bzrdir.BzrDir.open(readonly_t.base)
@@ -532,7 +555,7 @@
                         self.branch_format.__class__))
 
         # find it via Branch.open
-        opened_branch = branch.Branch.open(readonly_t.base)
+        opened_branch = bzrlib.branch.Branch.open(readonly_t.base)
         self.failUnless(isinstance(opened_branch, made_branch.__class__))
         self.assertEqual(made_branch._format.__class__,
                          opened_branch._format.__class__)
@@ -542,4 +565,4 @@
         except NotImplementedError:
             return
         self.assertEqual(self.branch_format,
-                         branch.BranchFormat.find_format(opened_control))
+                         bzrlib.branch.BranchFormat.find_format(opened_control))

=== modified file 'bzrlib/tests/bzrdir_implementations/test_bzrdir.py'
--- bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2006-05-17 04:09:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# (C) 2005, 2006 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,13 +18,14 @@
 
 from cStringIO import StringIO
 import os
-from stat import S_ISDIR
+from stat import *
 import sys
 
 import bzrlib.branch
 import bzrlib.bzrdir as bzrdir
 from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
 from bzrlib.check import check
+from bzrlib.commit import commit
 import bzrlib.errors as errors
 from bzrlib.errors import (FileExists,
                            NoSuchRevision,

=== modified file 'bzrlib/tests/repository_implementations/test_repository.py'
--- bzrlib/tests/repository_implementations/test_repository.py	2006-06-20 05:32:16 +0000
+++ bzrlib/tests/repository_implementations/test_repository.py	2006-06-16 19:55:10 +0000
@@ -21,15 +21,18 @@
 import sys
 
 import bzrlib
-from bzrlib import bzrdir, errors, repository
+import bzrlib.bzrdir as bzrdir
 from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
+from bzrlib.commit import commit
 from bzrlib.delta import TreeDelta
+import bzrlib.errors as errors
 from bzrlib.errors import (FileExists,
                            NoSuchRevision,
                            NoSuchFile,
                            UninitializableFormat,
                            NotBranchError,
                            )
+import bzrlib.repository as repository
 from bzrlib.revision import NULL_REVISION
 from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
 from bzrlib.tests.bzrdir_implementations.test_bzrdir import TestCaseWithBzrDir

=== modified file 'bzrlib/tests/test_commit_merge.py'
--- bzrlib/tests/test_commit_merge.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/test_commit_merge.py	2006-02-20 09:50:27 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 by Canonical Ltd
+# Copyright (C) 2005 by Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,8 +20,9 @@
 
 from bzrlib.tests import TestCaseWithTransport
 from bzrlib.branch import Branch
-from bzrlib.errors import PointlessCommit, BzrError
+from bzrlib.errors import PointlessCommit, BzrError, PointlessCommit
 from bzrlib.tests.test_revision import make_branches
+from bzrlib.check import check
 
 
 class TestCommitMerge(TestCaseWithTransport):
@@ -92,7 +93,5 @@
         self.assertEquals(inv['ecks-id'].revision, 'x@u-0-1')
         self.assertEquals(inv['why-id'].revision, 'y@u-0-1')
 
-        bx.check()
-        by.check()
-        bx.repository.check([bx.last_revision()])
-        by.repository.check([by.last_revision()])
+        check(bx, False)
+        check(by, False)

=== modified file 'bzrlib/tests/test_conflicts.py'
--- bzrlib/tests/test_conflicts.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/test_conflicts.py	2006-04-18 22:41:16 +0000
@@ -17,13 +17,9 @@
 
 import os
 
-from bzrlib import bzrdir
 from bzrlib.tests import TestCaseWithTransport, TestCase
 from bzrlib.branch import Branch
-from bzrlib.conflicts import (MissingParent, ContentsConflict, TextConflict,
-        PathConflict, DuplicateID, DuplicateEntry, ParentLoop, UnversionedParent,
-        ConflictList, 
-        restore)
+from bzrlib.conflicts import *
 from bzrlib.errors import NotConflicted
 
 
@@ -50,7 +46,7 @@
     def test_conflicts(self):
         """Conflicts are detected properly"""
         tree = self.make_branch_and_tree('.',
-            format=bzrdir.BzrDirFormat6())
+            format=bzrlib.bzrdir.BzrDirFormat6())
         b = tree.branch
         file('hello', 'w').write('hello world4')
         file('hello.THIS', 'w').write('hello world2')

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2006-06-15 05:36:34 +0000
+++ bzrlib/tests/test_errors.py	2006-02-26 07:54:02 +0000
@@ -27,8 +27,8 @@
     def test_no_repo(self):
         dir = bzrdir.BzrDir.create(self.get_url())
         error = errors.NoRepositoryPresent(dir)
-        self.assertNotEqual(-1, str(error).find((dir.transport.clone('..').base)))
-        self.assertEqual(-1, str(error).find((dir.transport.base)))
+        self.assertNotEqual(-1, str(error).find(repr(dir.transport.clone('..').base)))
+        self.assertEqual(-1, str(error).find(repr(dir.transport.base)))
 
     def test_up_to_date(self):
         error = errors.UpToDateFormat(bzrdir.BzrDirFormat4())

=== modified file 'bzrlib/tests/test_merge.py'
--- bzrlib/tests/test_merge.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/test_merge.py	2006-04-09 06:19:54 +0000
@@ -1,24 +1,9 @@
-# Copyright (C) 2005, 2006 by Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
 import os
 from StringIO import StringIO
 
 from bzrlib.branch import Branch
 from bzrlib.builtins import merge
+from bzrlib.commit import commit
 from bzrlib.errors import UnrelatedBranches, NoCommits, BzrCommandError
 from bzrlib.merge import transform_tree, merge_inner
 from bzrlib.osutils import pathjoin

=== modified file 'bzrlib/tests/test_merge_core.py'
--- bzrlib/tests/test_merge_core.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/test_merge_core.py	2006-05-05 01:15:53 +0000
@@ -124,6 +124,12 @@
     def change_perms_tree(self, id, tree, mode):
         os.chmod(tree.full_path(id), mode)
 
+    def merge_changeset(self, merge_factory):
+        conflict_handler = changeset.ExceptionConflictHandler()
+        return make_merge_changeset(self.cset, self.this, self.base,
+                                    self.other, conflict_handler,
+                                    merge_factory)
+
     def apply_inv_change(self, inventory_change, orig_inventory):
         orig_inventory_by_path = {}
         for file_id, path in orig_inventory.iteritems():
@@ -162,6 +168,14 @@
             new_inventory[file_id] = path
         return new_inventory
 
+    def apply_changeset(self, cset, conflict_handler=None):
+        inventory_change = changeset.apply_changeset(cset,
+                                                     self.this.inventory_dict,
+                                                     self.this.dir,
+                                                     conflict_handler)
+        self.this.inventory_dict =  self.apply_inv_change(inventory_change, 
+                                                     self.this.inventory_dict)
+
     def cleanup(self):
         rmtree(self.dir)
 

=== modified file 'bzrlib/tests/test_msgeditor.py'
--- bzrlib/tests/test_msgeditor.py	2006-06-10 13:58:01 +0000
+++ bzrlib/tests/test_msgeditor.py	2006-06-06 16:16:09 +0000
@@ -102,7 +102,7 @@
             f = file('fed.bat', 'w')
             f.write("""\
 @echo off
-"%s" fed.py %%1
+%s fed.py %%1
 """ % sys.executable)
             f.close()
             os.environ['BZR_EDITOR'] = 'fed.bat'
@@ -123,7 +123,7 @@
         working_tree = self.make_uncommitted_tree()
 
         if sys.platform == 'win32':
-            os.environ['BZR_EDITOR'] = 'cmd.exe /c del'
+            os.environ['BZR_EDITOR'] = 'del'
         else:
             os.environ['BZR_EDITOR'] = 'rm'
 

=== modified file 'bzrlib/tests/test_options.py'
--- bzrlib/tests/test_options.py	2006-06-20 03:30:14 +0000
+++ bzrlib/tests/test_options.py	2006-06-16 15:40:20 +0000
@@ -44,7 +44,7 @@
 
     def test_unknown_short_opt(self):
         out, err = self.run_bzr_captured(['help', '-r'], retcode=3)
-        self.assertContainsRe(err, r'unknown option')
+        self.assertContainsRe(err, r'unknown short option')
 
 
 #     >>> parse_args('log -r 500'.split())

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2006-06-18 18:56:23 +0000
+++ bzrlib/tests/test_osutils.py	2006-06-16 16:17:40 +0000
@@ -25,12 +25,7 @@
 import bzrlib
 from bzrlib.errors import BzrBadParameterNotUnicode, InvalidURL
 import bzrlib.osutils as osutils
-from bzrlib.tests import (
-        StringIOWrapper,
-        TestCase, 
-        TestCaseInTempDir, 
-        TestSkipped,
-        )
+from bzrlib.tests import TestCaseInTempDir, TestCase, TestSkipped
 
 
 class TestOSUtils(TestCaseInTempDir):
@@ -347,42 +342,3 @@
         self.assertEqual(
             dir_sorted_paths,
             sorted(original_paths, cmp=osutils.compare_paths_prefix_order))
-
-
-class TestTerminalEncoding(TestCase):
-    """Test the auto-detection of proper terminal encoding."""
-
-    def setUp(self):
-        self._stdout = sys.stdout
-        self._stderr = sys.stderr
-        self._stdin = sys.stdin
-        self._user_encoding = bzrlib.user_encoding
-
-        self.addCleanup(self._reset)
-
-        sys.stdout = StringIOWrapper()
-        sys.stdout.encoding = 'stdout_encoding'
-        sys.stderr = StringIOWrapper()
-        sys.stderr.encoding = 'stderr_encoding'
-        sys.stdin = StringIOWrapper()
-        sys.stdin.encoding = 'stdin_encoding'
-        bzrlib.user_encoding = 'user_encoding'
-
-    def _reset(self):
-        sys.stdout = self._stdout
-        sys.stderr = self._stderr
-        sys.stdin = self._stdin
-        bzrlib.user_encoding = self._user_encoding
-
-    def test_get_terminal_encoding(self):
-        # first preference is stdout encoding
-        self.assertEqual('stdout_encoding', osutils.get_terminal_encoding())
-
-        sys.stdout.encoding = None
-        # if sys.stdout is None, fall back to sys.stdin
-        self.assertEqual('stdin_encoding', osutils.get_terminal_encoding())
-
-        sys.stdin.encoding = None
-        # and in the worst case, use bzrlib.user_encoding
-        self.assertEqual('user_encoding', osutils.get_terminal_encoding())
-

=== modified file 'bzrlib/tests/test_plugins.py'
--- bzrlib/tests/test_plugins.py	2006-06-18 23:19:23 +0000
+++ bzrlib/tests/test_plugins.py	2005-12-16 03:43:14 +0000
@@ -22,12 +22,9 @@
 # comments.
 
 import os
-from StringIO import StringIO
 
 import bzrlib.plugin
 import bzrlib.plugins
-import bzrlib.commands
-import bzrlib.help
 from bzrlib.tests import TestCaseInTempDir
 from bzrlib.osutils import pathjoin, abspath
 
@@ -140,57 +137,3 @@
             if getattr(bzrlib.plugins, 'plugin', None):
                 del bzrlib.plugins.plugin
         self.failIf(getattr(bzrlib.plugins, 'plugin', None))
-
-
-class TestPluginHelp(TestCaseInTempDir):
-
-    def split_help_commands(self):
-        help = {}
-        current = None
-        for line in self.capture('help commands').splitlines():
-            if line.startswith('bzr '):
-                current = line.split()[1]
-            help[current] = help.get(current, '') + line
-
-        return help
-
-    def test_plugin_help_builtins_unaffected(self):
-        # Check we don't get false positives
-        help_commands = self.split_help_commands()
-        for cmd_name in bzrlib.commands.builtin_command_names():
-            if cmd_name in bzrlib.commands.plugin_command_names():
-                continue
-            help = StringIO()
-            try:
-                bzrlib.help.help_on_command(cmd_name, help)
-            except NotImplementedError:
-                # some commands have no help
-                pass
-            else:
-                help.seek(0)
-                self.assertNotContainsRe(help.read(), 'From plugin "[^"]*"')
-
-            if help in help_commands.keys():
-                # some commands are hidden
-                help = help_commands[cmd_name]
-                self.assertNotContainsRe(help, 'From plugin "[^"]*"')
-
-    def test_plugin_help_shows_plugin(self):
-        # Create a test plugin
-        os.mkdir('plugin_test')
-        f = open(pathjoin('plugin_test', 'myplug.py'), 'w')
-        f.write(PLUGIN_TEXT)
-        f.close()
-
-        try:
-            # Check its help
-            bzrlib.plugin.load_from_dirs(['plugin_test'])
-            bzrlib.commands.register_command( bzrlib.plugins.myplug.cmd_myplug)
-            help = self.capture('help myplug')
-            self.assertContainsRe(help, 'From plugin "myplug"')
-            help = self.split_help_commands()['myplug']
-            self.assertContainsRe(help, 'From plugin "myplug"')
-        finally:
-            # remove the plugin 'plugin'
-            if getattr(bzrlib.plugins, 'plugin', None):
-                del bzrlib.plugins.plugin

=== modified file 'bzrlib/tests/test_progress.py'
--- bzrlib/tests/test_progress.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/test_progress.py	2006-03-08 19:51:44 +0000
@@ -16,12 +16,7 @@
 
 from StringIO import StringIO
 
-from bzrlib.progress import (
-        DummyProgress, ChildProgress,
-        TTYProgressBar,
-        DotsProgressBar,
-        ProgressBarStack,
-        )
+from bzrlib.progress import *
 from bzrlib.tests import TestCase
 
 class FakeStack:

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/test_repository.py	2006-06-05 17:19:03 +0000
@@ -22,7 +22,7 @@
 also see this file.
 """
 
-from stat import S_ISDIR
+from stat import *
 from StringIO import StringIO
 
 import bzrlib

=== modified file 'bzrlib/tests/test_revision.py'
--- bzrlib/tests/test_revision.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/test_revision.py	2006-06-06 12:06:20 +0000
@@ -20,6 +20,7 @@
 
 from bzrlib.branch import Branch
 from bzrlib.errors import NoSuchRevision
+from bzrlib.commit import commit
 from bzrlib.graph import Graph
 from bzrlib.revision import (find_present_ancestors, combined_graph,
                              common_ancestor,
@@ -146,6 +147,7 @@
 class TestIntermediateRevisions(TestCaseWithTransport):
 
     def setUp(self):
+        from bzrlib.commit import commit
         TestCaseWithTransport.setUp(self)
         self.br1, self.br2 = make_branches(self)
         wt1 = self.br1.bzrdir.open_workingtree()

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/test_selftest.py	2006-06-12 01:12:14 +0000
@@ -35,7 +35,6 @@
                           )
 from bzrlib.tests.TestUtil import _load_module_by_name
 import bzrlib.errors as errors
-from bzrlib.trace import note
 
 
 class SelftestTests(TestCase):

=== modified file 'bzrlib/tests/test_source.py'
--- bzrlib/tests/test_source.py	2006-06-20 05:32:16 +0000
+++ bzrlib/tests/test_source.py	2006-03-05 02:20:07 +0000
@@ -72,4 +72,4 @@
         # written. Note that this is an exact equality so that when the number
         # drops, it is not given a buffer but rather this test updated
         # immediately.
-        self.assertEqual(2, occurences)
+        self.assertEqual(4, occurences)

=== modified file 'bzrlib/tests/test_textfile.py'
--- bzrlib/tests/test_textfile.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/test_textfile.py	2006-04-19 02:16:05 +0000
@@ -18,7 +18,7 @@
 
 from bzrlib.errors import BinaryFile
 from bzrlib.tests import TestCase, TestCaseInTempDir
-from bzrlib.textfile import text_file, check_text_lines, check_text_path
+from bzrlib.textfile import *
 
 
 class TextFile(TestCase):

=== modified file 'bzrlib/tests/test_trace.py'
--- bzrlib/tests/test_trace.py	2006-06-20 03:30:14 +0000
+++ bzrlib/tests/test_trace.py	2005-12-27 22:56:50 +0000
@@ -1,4 +1,5 @@
-# Copyright (C) 2005, 2006 by Canonical Ltd
+# Copyright (C) 2005 by Canonical Ltd
+#   Authors: Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,64 +19,47 @@
 
 """Tests for trace library"""
 
-import errno
 import os
 import sys
-from StringIO import StringIO
 
 from bzrlib.tests import TestCaseInTempDir, TestCase
-from bzrlib.trace import mutter, report_exception
-from bzrlib.errors import NotBranchError
-
-
-def _format_exception():
-    """Format an exception as it would normally be displayed to the user"""
-    buf = StringIO()
-    report_exception(sys.exc_info(), buf)
-    return buf.getvalue()
-
+from bzrlib.trace import format_exception_short, mutter
+from bzrlib.errors import NotBranchError, BzrError, BzrNewError
 
 class TestTrace(TestCase):
-
     def test_format_sys_exception(self):
+        """Short formatting of exceptions"""
         try:
             raise NotImplementedError, "time travel"
         except NotImplementedError:
             pass
-        err = _format_exception()
-        self.assertEqualDiff(err.splitlines()[0],
-                'bzr: ERROR: exceptions.NotImplementedError: time travel')
-        self.assertContainsRe(err,
-                r'File.*test_trace.py')
-
-    def test_format_interrupt_exception(self):
-        try:
-            raise KeyboardInterrupt()
-        except KeyboardInterrupt:
-            # XXX: Some risk that a *real* keyboard interrupt won't be seen
-            pass
-        msg = _format_exception()
-        self.assertTrue(len(msg) > 0)
-        self.assertEqualDiff(msg, 'bzr: interrupted\n')
-
-    def test_format_os_error(self):
-        try:
-            file('nosuchfile22222')
-        except (OSError, IOError):
-            pass
-        msg = _format_exception()
-        self.assertContainsRe(msg, r'^bzr: ERROR: \[Errno .*\] No such file.*nosuchfile')
-
+        error_lines = format_exception_short(sys.exc_info()).splitlines()
+        self.assertEqualDiff(error_lines[0], 
+                'exceptions.NotImplementedError: time travel')
+        self.assertContainsRe(error_lines[1], 
+                r'^  at .*trace\.py line \d+$')  
+        self.assertContainsRe(error_lines[2], 
+                r'^  in test_format_sys_exception$')
 
     def test_format_exception(self):
-        """Short formatting of bzr exceptions"""
+        """Short formatting of exceptions"""
         try:
             raise NotBranchError, 'wibble'
         except NotBranchError:
             pass
-        msg = _format_exception()
-        self.assertTrue(len(msg) > 0)
-        self.assertEqualDiff(msg, 'bzr: ERROR: Not a branch: wibble\n')
+        msg = format_exception_short(sys.exc_info())
+        self.assertEqualDiff(msg, 'Not a branch: wibble')
+
+    def test_format_old_exception(self):
+        # format a class that doesn't descend from BzrNewError; 
+        # remove this test when everything is unified there
+        self.assertFalse(issubclass(BzrError, BzrNewError))
+        try:
+            raise BzrError('some old error')
+        except BzrError:
+            pass
+        msg = format_exception_short(sys.exc_info())
+        self.assertEqualDiff(msg, 'some old error')
 
     def test_trace_unicode(self):
         """Write Unicode to trace log"""
@@ -83,15 +67,6 @@
         self.assertContainsRe('the unicode character',
                 self._get_log())
 
-    def test_report_broken_pipe(self):
-        try:
-            raise IOError(errno.EPIPE, 'broken pipe foofofo')
-        except IOError, e:
-            msg = _format_exception()
-            self.assertEquals(msg, "bzr: broken pipe\n")
-        else:
-            self.fail("expected error not raised")
-
     def test_mutter_never_fails(self):
         # Even if the decode/encode stage fails, mutter should not
         # raise an exception
@@ -106,3 +81,4 @@
         self.assertContainsRe(log, 'Writing a greek mu')
         self.assertContainsRe(log, 'UnicodeError')
         self.assertContainsRe(log, "'But fails in an ascii string")
+

=== modified file 'bzrlib/tests/test_transport_implementations.py'
--- bzrlib/tests/test_transport_implementations.py	2006-06-18 18:56:23 +0000
+++ bzrlib/tests/test_transport_implementations.py	2006-06-12 14:39:27 +0000
@@ -922,7 +922,7 @@
                 ]
 
         try:
-            self.build_tree(files, transport=t, line_endings='binary')
+            self.build_tree(files, transport=t)
         except UnicodeError:
             raise TestSkipped("cannot handle unicode paths in current encoding")
 

=== modified file 'bzrlib/tests/test_tuned_gzip.py'
--- bzrlib/tests/test_tuned_gzip.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/test_tuned_gzip.py	2006-04-20 04:52:19 +0000
@@ -25,7 +25,7 @@
 import zlib
 
 
-from bzrlib import tuned_gzip
+from bzrlib.tuned_gzip import *
 
 
 class FakeDecompress(object):
@@ -74,7 +74,7 @@
         # read more bytes if there is less than 8 bytes (the 
         # gzip trailer) unread.
         stream = StringIO('\0\0\0\0\0\0\0\0')
-        myfile = tuned_gzip.GzipFile(fileobj=stream)
+        myfile = GzipFile(fileobj=stream)
         # disable the _new_member check, we are microtesting.
         myfile._new_member = False
         myfile.crc = zlib.crc32('')

=== modified file 'bzrlib/tests/test_urlutils.py'
--- bzrlib/tests/test_urlutils.py	2006-06-18 18:56:23 +0000
+++ bzrlib/tests/test_urlutils.py	2006-06-15 21:54:28 +0000
@@ -91,9 +91,7 @@
         norm_file('uni/%25C2%25B5', u'uni/%C2%B5')
         norm_file('uni/%20b', u'uni/ b')
         # All the crazy characters get escaped in local paths => file:/// urls
-        # The ' ' character must not be at the end, because on win32
-        # it gets stripped off by ntpath.abspath
-        norm_file('%27%20%3B/%3F%3A%40%26%3D%2B%24%2C%23', "' ;/?:@&=+$,#")
+        norm_file('%27%3B/%3F%3A%40%26%3D%2B%24%2C%23%20', "';/?:@&=+$,# ")
 
     def test_normalize_url_hybrid(self):
         # Anything with a scheme:// should be treated as a hybrid url
@@ -256,31 +254,23 @@
 
     def test_win32_local_path_to_url(self):
         to_url = urlutils._win32_local_path_to_url
-        self.assertEqual('file:///c:/path/to/foo',
+        self.assertEqual('file:///C:/path/to/foo',
             to_url('C:/path/to/foo'))
-        # BOGUS: on win32, ntpath.abspath will strip trailing
-        #       whitespace, so this will always fail
-        #       Though under linux, it fakes abspath support
-        #       and thus will succeed
-        # self.assertEqual('file:///C:/path/to/foo%20',
-        #     to_url('C:/path/to/foo '))
-        self.assertEqual('file:///c:/path/to/f%20oo',
-            to_url('C:/path/to/f oo'))
 
         try:
             result = to_url(u'd:/path/to/r\xe4ksm\xf6rg\xe5s')
         except UnicodeError:
             raise TestSkipped("local encoding cannot handle unicode")
 
-        self.assertEqual('file:///d:/path/to/r%C3%A4ksm%C3%B6rg%C3%A5s', result)
+        self.assertEqual('file:///D:/path/to/r%C3%A4ksm%C3%B6rg%C3%A5s', result)
 
     def test_win32_local_path_from_url(self):
         from_url = urlutils._win32_local_path_from_url
-        self.assertEqual('c:/path/to/foo',
+        self.assertEqual('C:/path/to/foo',
             from_url('file:///C|/path/to/foo'))
-        self.assertEqual(u'd:/path/to/r\xe4ksm\xf6rg\xe5s',
+        self.assertEqual(u'D:/path/to/r\xe4ksm\xf6rg\xe5s',
             from_url('file:///d|/path/to/r%C3%A4ksm%C3%B6rg%C3%A5s'))
-        self.assertEqual(u'd:/path/to/r\xe4ksm\xf6rg\xe5s',
+        self.assertEqual(u'D:/path/to/r\xe4ksm\xf6rg\xe5s',
             from_url('file:///d:/path/to/r%c3%a4ksm%c3%b6rg%c3%a5s'))
 
         self.assertRaises(InvalidURL, from_url, '/path/to/foo')
@@ -380,8 +370,8 @@
 
         test('http://foo', 'http://foo')
         if sys.platform == 'win32':
-            test('c:/foo/path', 'file:///C|/foo/path')
-            test('c:/foo/path', 'file:///C:/foo/path')
+            test('C:/foo/path', 'file:///C|/foo/path')
+            test('C:/foo/path', 'file:///C:/foo/path')
         else:
             test('/foo/path', 'file:///foo/path')
 

=== modified file 'bzrlib/tests/test_whitebox.py'
--- bzrlib/tests/test_whitebox.py	2006-06-20 07:55:43 +0000
+++ bzrlib/tests/test_whitebox.py	2006-05-05 01:15:53 +0000
@@ -1,24 +1,8 @@
-# Copyright (C) 2005, 2006 by Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
 import os
 import unittest
 
 from bzrlib.tests import TestCaseWithTransport, TestCase
-from bzrlib.branch import Branch
+from bzrlib.branch import ScratchBranch, Branch
 from bzrlib.errors import PathNotChild
 from bzrlib.osutils import relpath, pathjoin, abspath, realpath
 

=== modified file 'bzrlib/tests/test_workingtree.py'
--- bzrlib/tests/test_workingtree.py	2006-06-20 05:32:16 +0000
+++ bzrlib/tests/test_workingtree.py	2006-05-19 06:00:00 +0000
@@ -20,14 +20,17 @@
 
 import bzrlib
 from bzrlib.branch import Branch
-from bzrlib import bzrdir, conflicts, errors, workingtree
+import bzrlib.bzrdir as bzrdir
 from bzrlib.bzrdir import BzrDir
+from bzrlib.conflicts import *
+import bzrlib.errors as errors
 from bzrlib.errors import NotBranchError, NotVersionedError
 from bzrlib.lockdir import LockDir
 from bzrlib.osutils import pathjoin, getcwd, has_symlinks
 from bzrlib.tests import TestCaseWithTransport, TestSkipped
 from bzrlib.trace import mutter
 from bzrlib.transport import get_transport
+import bzrlib.workingtree as workingtree
 from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
                                 WorkingTree)
 
@@ -216,20 +219,20 @@
         self.assertRaises(errors.UnsupportedOperation, tree.set_conflicts,
                           None)
         file('lala.BASE', 'wb').write('labase')
-        expected = conflicts.ContentsConflict('lala')
+        expected = ContentsConflict('lala')
         self.assertEqual(list(tree.conflicts()), [expected])
         file('lala', 'wb').write('la')
         tree.add('lala', 'lala-id')
-        expected = conflicts.ContentsConflict('lala', file_id='lala-id')
+        expected = ContentsConflict('lala', file_id='lala-id')
         self.assertEqual(list(tree.conflicts()), [expected])
         file('lala.THIS', 'wb').write('lathis')
         file('lala.OTHER', 'wb').write('laother')
         # When "text conflict"s happen, stem, THIS and OTHER are text
-        expected = conflicts.TextConflict('lala', file_id='lala-id')
+        expected = TextConflict('lala', file_id='lala-id')
         self.assertEqual(list(tree.conflicts()), [expected])
         os.unlink('lala.OTHER')
         os.mkdir('lala.OTHER')
-        expected = conflicts.ContentsConflict('lala', file_id='lala-id')
+        expected = ContentsConflict('lala', file_id='lala-id')
         self.assertEqual(list(tree.conflicts()), [expected])
 
 

=== modified file 'bzrlib/tests/treeshape.py'
--- bzrlib/tests/treeshape.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/treeshape.py	2005-12-01 17:25:16 +0000
@@ -65,7 +65,7 @@
         filenames.sort()
         for fn in filenames:
             fullpath = pathjoin(dirpath, fn)
-            assert not (fullpath[-1] in '@/')
+            self.assertFalse(fullpath[-1] in '@/')
             info = os.lstat(fullpath)
             if stat.S_ISLNK(info.st_mode):
                 yield (fullpath + '@', os.readlink(fullpath))

=== modified file 'bzrlib/tests/workingtree_implementations/test_commit.py'
--- bzrlib/tests/workingtree_implementations/test_commit.py	2006-06-20 05:32:16 +0000
+++ bzrlib/tests/workingtree_implementations/test_commit.py	2006-06-15 17:26:25 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# (C) 2005,2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -18,13 +18,20 @@
 from cStringIO import StringIO
 import os
 
-from bzrlib import branch, bzrdir, errors, ui, workingtree
+import bzrlib
+import bzrlib.branch
+from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.bzrdir import BzrDir
+import bzrlib.errors as errors
 from bzrlib.errors import (NotBranchError, NotVersionedError, 
                            UnsupportedOperation)
 from bzrlib.osutils import pathjoin, getcwd, has_symlinks
 from bzrlib.tests import TestSkipped, TestCase
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 from bzrlib.trace import mutter
+import bzrlib.ui as ui
+import bzrlib.workingtree as workingtree
 from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
                                 WorkingTree)
 

=== modified file 'bzrlib/tests/workingtree_implementations/test_is_control_filename.py'
--- bzrlib/tests/workingtree_implementations/test_is_control_filename.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/workingtree_implementations/test_is_control_filename.py	2006-02-16 02:53:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# (C) 2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -15,10 +15,24 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+from cStringIO import StringIO
 import os
 
+import bzrlib
+import bzrlib.branch
+from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.bzrdir import BzrDir
+import bzrlib.errors as errors
+from bzrlib.errors import NotBranchError, NotVersionedError
 from bzrlib.osutils import basename
+from bzrlib.tests import TestSkipped
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
+from bzrlib.trace import mutter
+from bzrlib.transport import get_transport
+import bzrlib.workingtree as workingtree
+from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
+                                WorkingTree)
 
 
 class TestIsControlFilename(TestCaseWithWorkingTree):

=== modified file 'bzrlib/tests/workingtree_implementations/test_pull.py'
--- bzrlib/tests/workingtree_implementations/test_pull.py	2006-06-20 03:57:11 +0000
+++ bzrlib/tests/workingtree_implementations/test_pull.py	2006-02-22 05:45:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# (C) 2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -18,13 +18,21 @@
 from cStringIO import StringIO
 import os
 
-from bzrlib import errors
+import bzrlib
+import bzrlib.branch
+from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.bzrdir import BzrDir
+import bzrlib.errors as errors
 from bzrlib.errors import NotBranchError, NotVersionedError
 from bzrlib.osutils import basename
 from bzrlib.tests import TestSkipped
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 from bzrlib.trace import mutter
 from bzrlib.transport import get_transport
+import bzrlib.workingtree as workingtree
+from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
+                                WorkingTree)
 
 
 class TestPull(TestCaseWithWorkingTree):

=== modified file 'bzrlib/tests/workingtree_implementations/test_workingtree.py'
--- bzrlib/tests/workingtree_implementations/test_workingtree.py	2006-06-20 07:55:43 +0000
+++ bzrlib/tests/workingtree_implementations/test_workingtree.py	2006-06-06 12:06:20 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# (C) 2005,2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -19,16 +19,22 @@
 import os
 
 import bzrlib
-from bzrlib import branch, bzrdir, errors, urlutils, workingtree
+import bzrlib.branch
+from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.bzrdir import BzrDir
+import bzrlib.errors as errors
 from bzrlib.errors import (NotBranchError, NotVersionedError, 
                            UnsupportedOperation)
 from bzrlib.osutils import pathjoin, getcwd, has_symlinks
 from bzrlib.tests import TestSkipped
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 from bzrlib.trace import mutter
+import bzrlib.urlutils as urlutils
+import bzrlib.workingtree as workingtree
 from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
                                 WorkingTree)
-from bzrlib.conflicts import ConflictList
+
 
 class TestWorkingTree(TestCaseWithWorkingTree):
 
@@ -145,22 +151,10 @@
         tree.revert(['hello.txt'])
         self.failUnlessExists('hello.txt')
 
-    def test_unknowns_by_default_patterns(self):
-        """Backup files are ignored by default"""
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['hello.txt',
-                         'hello.txt.~1~'])
-        self.assertEquals(list(tree.unknowns()),
-                          ['hello.txt'])
-
-    def test_versioned_files_not_unknown(self):
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['hello.txt',
-                         'hello.txt.~1~'])
-        tree.add('hello.txt')
-        self.assertEquals(list(tree.unknowns()),
-                          [])
-        tree.remove('hello.txt')
+    def test_unknowns(self):
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['hello.txt',
+                         'hello.txt.~1~'])
         self.assertEquals(list(tree.unknowns()),
                           ['hello.txt'])
 
@@ -181,7 +175,7 @@
     def test_initialize(self):
         # initialize should create a working tree and branch in an existing dir
         t = self.make_branch_and_tree('.')
-        b = branch.Branch.open('.')
+        b = Branch.open('.')
         self.assertEqual(t.branch.base, b.base)
         t2 = WorkingTree.open('.')
         self.assertEqual(t.basedir, t2.basedir)
@@ -394,7 +388,7 @@
         # current format
         self.build_tree(['checkout/', 'tree/file'])
         checkout = bzrdir.BzrDirMetaFormat1().initialize('checkout')
-        branch.BranchReferenceFormat().initialize(checkout, main_branch)
+        bzrlib.branch.BranchReferenceFormat().initialize(checkout, main_branch)
         old_tree = self.workingtree_format.initialize(checkout)
         # now commit to 'tree'
         wt.add('file')
@@ -425,7 +419,7 @@
         # current format
         self.build_tree(['checkout/', 'tree/file'])
         checkout = bzrdir.BzrDirMetaFormat1().initialize('checkout')
-        branch.BranchReferenceFormat().initialize(checkout, main_branch)
+        bzrlib.branch.BranchReferenceFormat().initialize(checkout, main_branch)
         old_tree = self.workingtree_format.initialize(checkout)
         # now commit to 'tree'
         wt.add('file')
@@ -532,7 +526,7 @@
         tree.add('blo')
         tree.commit("blah", allow_pointless=False)
         base = tree.basis_tree()
-        bzrdir.BzrDir.open("mine").sprout("other")
+        BzrDir.open("mine").sprout("other")
         file('other/bloo', 'wb').write('two')
         othertree = WorkingTree.open('other')
         othertree.commit('blah', allow_pointless=False)
@@ -546,6 +540,7 @@
         self.assertEqual(len(tree.conflicts()), 1)
 
     def test_clear_merge_conflicts(self):
+        from bzrlib.conflicts import ConflictList
         tree = self.make_merge_conflicts()
         self.assertEqual(len(tree.conflicts()), 1)
         try:

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2006-06-20 05:32:16 +0000
+++ bzrlib/trace.py	2006-06-10 00:21:11 +0000
@@ -1,18 +1,4 @@
-# Copyright (C) 2005, 2006 by Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+# Copyright (C) 2005, Canonical Ltd
 
 """Messages and logging for bazaar-ng.
 
@@ -46,21 +32,21 @@
 form.
 """
 
+# TODO: in debug mode, stderr should get full tracebacks and also
+# debug messages.  (Is this really needed?)
+
 # FIXME: Unfortunately it turns out that python's logging module
 # is quite expensive, even when the message is not printed by any handlers.
 # We should perhaps change back to just simply doing it here.
 
 
-import errno
+import sys
 import os
-import sys
 import logging
 
 import bzrlib
 from bzrlib.errors import BzrError, BzrNewError
-from bzrlib.symbol_versioning import (deprecated_function,
-        zero_nine,
-        )
+
 
 _file_handler = None
 _stderr_handler = None
@@ -70,6 +56,25 @@
 _bzr_log_file = None
 
 
+class QuietFormatter(logging.Formatter):
+    """Formatter that suppresses the details of errors.
+
+    This is used by default on stderr so as not to scare the user.
+    """
+    # At first I tried overriding FormatException to suppress the
+    # exception details, but that has global effect: no loggers
+    # can get the exception details is we suppress them here.
+
+    def format(self, record):
+        if record.levelno >= logging.WARNING:
+            s = 'bzr: ' + record.levelname + ': '
+        else:
+            s = ''
+        s += record.getMessage()
+        if record.exc_info:
+            s += '\n' + format_exception_short(record.exc_info)
+        return s
+        
 # configure convenient aliases for output routines
 
 _bzr_logger = logging.getLogger('bzr')
@@ -130,7 +135,7 @@
     # information if something goes wrong.  In a future version this
     # file will be removed on successful completion.
     global _file_handler, _bzr_log_file
-    import codecs
+    import stat, codecs
 
     trace_fname = os.path.join(os.path.expanduser(tracefilename))
     _rollover_trace_maybe(trace_fname)
@@ -152,7 +157,15 @@
         warning("failed to open trace file: %s" % (e))
 
 
-@deprecated_function(zero_nine)
+def log_startup(argv):
+    debug('\n\nbzr %s invoked on python %s (%s)',
+          bzrlib.__version__,
+          '.'.join(map(str, sys.version_info)),
+          sys.platform)
+    debug('  arguments: %r', argv)
+    debug('  working dir: %r', os.getcwdu())
+
+
 def log_exception(msg=None):
     """Log the last exception to stderr and the trace file.
 
@@ -183,6 +196,7 @@
     # FIXME: if this is run twice, things get confused
     global _stderr_handler, _file_handler, _trace_file, _bzr_log_file
     _stderr_handler = logging.StreamHandler()
+    _stderr_handler.setFormatter(QuietFormatter())
     logging.getLogger('').addHandler(_stderr_handler)
     _stderr_handler.setLevel(logging.INFO)
     if not _file_handler:
@@ -190,7 +204,8 @@
     _trace_file = _bzr_log_file
     if _file_handler:
         _file_handler.setLevel(logging.DEBUG)
-    _bzr_logger.setLevel(logging.DEBUG)
+    _bzr_logger.setLevel(logging.DEBUG) 
+
 
 
 def be_quiet(quiet=True):
@@ -253,40 +268,32 @@
         enable_default_logging()
 
 
-def report_exception(exc_info, err_file):
-    exc_type, exc_object, exc_tb = exc_info
-    if (isinstance(exc_object, IOError)
-        and getattr(exc_object, 'errno', None) == errno.EPIPE):
-        print >>err_file, "bzr: broken pipe"
-    elif isinstance(exc_object, KeyboardInterrupt):
-        print >>err_file, "bzr: interrupted"
-    elif getattr(exc_object, 'is_user_error', False):
-        report_user_error(exc_info, err_file)
-    elif isinstance(exc_object, (OSError, IOError)):
-        # Might be nice to catch all of these and show them as something more
-        # specific, but there are too many cases at the moment.
-        report_user_error(exc_info, err_file)
-    else:
-        report_bug(exc_info, err_file)
-
-
-# TODO: Should these be specially encoding the output?
-def report_user_error(exc_info, err_file):
-    print >>err_file, "bzr: ERROR:", str(exc_info[1])
-
-
-def report_bug(exc_info, err_file):
-    """Report an exception that probably indicates a bug in bzr"""
-    import traceback
-    exc_type, exc_object, exc_tb = exc_info
-    print >>err_file, "bzr: ERROR: %s: %s" % (exc_type, exc_object)
-    print >>err_file
-    traceback.print_exception(exc_type, exc_object, exc_tb, file=err_file)
-    print >>err_file
-    print >>err_file, 'bzr %s on python %s (%s)' % \
-                       (bzrlib.__version__,
-                        '.'.join(map(str, sys.version_info)),
-                        sys.platform)
-    print >>err_file, 'arguments: %r' % sys.argv
-    print >>err_file
-    print >>err_file, "** please send this report to bazaar-ng@lists.ubuntu.com"
+def format_exception_short(exc_info):
+    """Make a short string form of an exception.
+
+    This is used for display to stderr.  It specially handles exception
+    classes without useful string methods.
+
+    The result has no trailing newline.
+
+    exc_info - typically an exception from sys.exc_info()
+    """
+    exc_type, exc_object, exc_tb = exc_info
+    try:
+        if exc_type is None:
+            return '(no exception)'
+        if isinstance(exc_object, (BzrError, BzrNewError)):
+            return str(exc_object)
+        else:
+            import traceback
+            tb = traceback.extract_tb(exc_tb)
+            msg = '%s: %s' % (exc_type, exc_object)
+            if msg[-1] == '\n':
+                msg = msg[:-1]
+            if tb:
+                msg += '\n  at %s line %d\n  in %s' % (tb[-1][:3])
+            return msg
+    except Exception, formatting_exc:
+        # XXX: is this really better than just letting it run up?
+        return '(error formatting exception of type %s: %s)' \
+                % (exc_type, formatting_exc)

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2006-06-20 03:57:11 +0000
+++ bzrlib/transform.py	2006-06-13 12:55:45 +0000
@@ -539,9 +539,9 @@
         if child_id is None:
             return lexists(self._tree.abspath(childpath))
         else:
-            if self.final_parent(child_id) != parent_id:
+            if tt.final_parent(child_id) != parent_id:
                 return False
-            if child_id in self._removed_contents:
+            if child_id in tt._removed_contents:
                 # XXX What about dangling file-ids?
                 return False
             else:

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2006-06-20 05:32:16 +0000
+++ bzrlib/transport/__init__.py	2006-06-09 09:04:53 +0000
@@ -30,21 +30,18 @@
 from collections import deque
 from copy import deepcopy
 import re
-from stat import S_ISDIR
+from stat import *
 import sys
 from unittest import TestSuite
 import urllib
 import urlparse
-import warnings
 
 import bzrlib
 import bzrlib.errors as errors
 from bzrlib.errors import DependencyNotPresent
 import bzrlib.osutils as osutils
 from bzrlib.osutils import pumpfile
-from bzrlib.symbol_versioning import (deprecated_passed, deprecated_method, deprecated_function, 
-        DEPRECATED_PARAMETER,
-        zero_eight)
+from bzrlib.symbol_versioning import *
 from bzrlib.trace import mutter, warning
 import bzrlib.urlutils as urlutils
 
@@ -66,7 +63,7 @@
     # working, etc.
     global _protocol_handlers
     if deprecated_passed(override):
-        warnings.warn("register_transport(override) is deprecated")
+        warn("register_transport(override) is deprecated")
     _protocol_handlers.setdefault(prefix, []).insert(0, klass)
 
 
@@ -706,7 +703,7 @@
             raise errors.InvalidURL(base, error_str % m.group('proto'))
         # This doesn't look like a protocol, consider it a local path
         new_base = urlutils.local_path_to_url(base)
-        mutter('converting os path %r => url %s', base, new_base)
+        mutter('converting os path %r => url %s' , base, new_base)
         return new_base
 
     # Catch any URLs which are passing Unicode rather than ASCII

=== modified file 'bzrlib/transport/fakenfs.py'
--- bzrlib/transport/fakenfs.py	2006-06-20 03:57:11 +0000
+++ bzrlib/transport/fakenfs.py	2006-04-02 22:42:19 +0000
@@ -22,7 +22,7 @@
 To get a fake nfs transport use get_transport('fakenfs+' + real_url)
 """
 
-from stat import S_ISDIR
+from stat import *
 
 import bzrlib.errors as errors
 from bzrlib.transport.decorator import TransportDecorator, DecoratorServer

=== modified file 'bzrlib/transport/ftp.py'
--- bzrlib/transport/ftp.py	2006-06-20 03:57:11 +0000
+++ bzrlib/transport/ftp.py	2006-05-22 05:32:51 +0000
@@ -670,7 +670,7 @@
             *why* it cannot make a directory.
             """
             if len (line) != 2:
-                self.command_not_understood(''.join(line))
+                self.command_not_understood (string.join (line))
             else:
                 path = line[1]
                 try:

=== modified file 'bzrlib/transport/http/__init__.py'
--- bzrlib/transport/http/__init__.py	2006-06-11 03:40:17 +0000
+++ bzrlib/transport/http/__init__.py	2006-04-25 20:18:04 +0000
@@ -19,13 +19,11 @@
 There are separate implementation modules for each http client implementation.
 """
 
+import errno
+import os
 from collections import deque
 from cStringIO import StringIO
-import errno
-import os
-import posixpath
 import re
-import sys
 import urlparse
 import urllib
 from warnings import warn
@@ -400,34 +398,6 @@
         method = getattr(self, mname)
         method()
 
-    if sys.platform == 'win32':
-        # On win32 you cannot access non-ascii filenames without
-        # decoding them into unicode first.
-        # However, under Linux, you can access bytestream paths
-        # without any problems. If this function was always active
-        # it would probably break tests when LANG=C was set
-        def translate_path(self, path):
-            """Translate a /-separated PATH to the local filename syntax.
-
-            For bzr, all url paths are considered to be utf8 paths.
-            On Linux, you can access these paths directly over the bytestream
-            request, but on win32, you must decode them, and access them
-            as Unicode files.
-            """
-            # abandon query parameters
-            path = urlparse.urlparse(path)[2]
-            path = posixpath.normpath(urllib.unquote(path))
-            path = path.decode('utf-8')
-            words = path.split('/')
-            words = filter(None, words)
-            path = os.getcwdu()
-            for word in words:
-                drive, word = os.path.splitdrive(word)
-                head, word = os.path.split(word)
-                if word in (os.curdir, os.pardir): continue
-                path = os.path.join(path, word)
-            return path
-
 
 class TestingHTTPServer(BaseHTTPServer.HTTPServer):
     def __init__(self, server_address, RequestHandlerClass, test_case):

=== modified file 'bzrlib/transport/http/_urllib.py'
--- bzrlib/transport/http/_urllib.py	2006-06-20 03:57:11 +0000
+++ bzrlib/transport/http/_urllib.py	2006-04-06 05:28:00 +0000
@@ -14,7 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import errno
 import urllib, urllib2
 
 import bzrlib  # for the version

=== modified file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2006-06-20 07:55:43 +0000
+++ bzrlib/transport/local.py	2006-06-09 09:57:44 +0000
@@ -51,7 +51,6 @@
             base = base + '/'
         super(LocalTransport, self).__init__(base)
         self._local_base = urlutils.local_path_from_url(base)
-        ## mutter("_local_base: %r => %r", base, self._local_base)
 
     def should_cache(self):
         return False
@@ -315,6 +314,23 @@
             return True
 
 
+class ScratchTransport(LocalTransport):
+    """A transport that works in a temporary dir and cleans up after itself.
+    
+    The dir only exists for the lifetime of the Python object.
+    Obviously you should not put anything precious in it.
+    """
+
+    def __init__(self, base=None):
+        if base is None:
+            base = tempfile.mkdtemp()
+        super(ScratchTransport, self).__init__(base)
+
+    def __del__(self):
+        rmtree(self.base, ignore_errors=True)
+        mutter("%r destroyed" % self)
+
+
 class LocalRelpathServer(Server):
     """A pretend server for local transports, using relpaths."""
 

=== modified file 'bzrlib/transport/memory.py'
--- bzrlib/transport/memory.py	2006-06-20 03:57:11 +0000
+++ bzrlib/transport/memory.py	2006-05-02 20:46:11 +0000
@@ -24,9 +24,8 @@
 import os
 import errno
 import re
-from stat import S_IFREG, S_IFDIR
+from stat import *
 from cStringIO import StringIO
-import warnings
 
 from bzrlib.errors import TransportError, NoSuchFile, FileExists, LockError
 from bzrlib.trace import mutter
@@ -261,7 +260,7 @@
     def __del__(self):
         # Should this warn, or actually try to cleanup?
         if self.transport:
-            warnings.warn("MemoryLock %r not explicitly unlocked" % (self.path,))
+            warn("MemoryLock %r not explicitly unlocked" % (self.path,))
             self.unlock()
 
     def unlock(self):

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2006-06-18 15:53:41 +0000
+++ bzrlib/transport/sftp.py	2006-06-12 14:39:27 +0000
@@ -22,7 +22,6 @@
 import os
 import random
 import re
-import select
 import stat
 import subprocess
 import sys
@@ -303,7 +302,6 @@
             # What specific errors should we catch here?
             pass
 
-
 class SFTPTransport (Transport):
     """
     Transport implementation for SFTP access.
@@ -889,9 +887,9 @@
 nvuQES5C9BMHjF39LZiGH1iLQy7FgdHyoP+eodI7
 -----END RSA PRIVATE KEY-----
 """
-
-
-class SocketListener(threading.Thread):
+    
+
+class SingleListener(threading.Thread):
 
     def __init__(self, callback):
         threading.Thread.__init__(self)
@@ -901,39 +899,25 @@
         self._socket.bind(('localhost', 0))
         self._socket.listen(1)
         self.port = self._socket.getsockname()[1]
-        self._stop_event = threading.Event()
+        self.stop_event = threading.Event()
+
+    def run(self):
+        s, _ = self._socket.accept()
+        # now close the listen socket
+        self._socket.close()
+        try:
+            self._callback(s, self.stop_event)
+        except socket.error:
+            pass #Ignore socket errors
+        except Exception, x:
+            # probably a failed test
+            warning('Exception from within unit test server thread: %r' % x)
 
     def stop(self):
-        # called from outside this thread
-        self._stop_event.set()
+        self.stop_event.set()
         # use a timeout here, because if the test fails, the server thread may
         # never notice the stop_event.
         self.join(5.0)
-        self._socket.close()
-
-    def run(self):
-        while True:
-            readable, writable_unused, exception_unused = \
-                select.select([self._socket], [], [], 0.1)
-            if self._stop_event.isSet():
-                return
-            if len(readable) == 0:
-                continue
-            try:
-                s, addr_unused = self._socket.accept()
-                # because the loopback socket is inline, and transports are
-                # never explicitly closed, best to launch a new thread.
-                threading.Thread(target=self._callback, args=(s,)).start()
-            except socket.error, x:
-                sys.excepthook(*sys.exc_info())
-                warning('Socket error during accept() within unit test server'
-                        ' thread: %r' % x)
-            except Exception, x:
-                # probably a failed test; unit test thread will log the
-                # failure/error
-                sys.excepthook(*sys.exc_info())
-                warning('Exception from within unit test server thread: %r' % 
-                        x)
 
 
 class SFTPServer(Server):
@@ -957,12 +941,10 @@
         """StubServer uses this to log when a new server is created."""
         self.logs.append(message)
 
-    def _run_server(self, s):
+    def _run_server(self, s, stop_event):
         ssh_server = paramiko.Transport(s)
         key_file = os.path.join(self._homedir, 'test_rsa.key')
-        f = open(key_file, 'w')
-        f.write(STUB_SERVER_KEY)
-        f.close()
+        file(key_file, 'w').write(STUB_SERVER_KEY)
         host_key = paramiko.RSAKey.from_private_key_file(key_file)
         ssh_server.add_server_key(host_key)
         server = StubServer(self)
@@ -972,6 +954,7 @@
         event = threading.Event()
         ssh_server.start_server(event, server)
         event.wait(5.0)
+        stop_event.wait(30.0)
     
     def setUp(self):
         global _ssh_vendor
@@ -982,7 +965,7 @@
             self._server_homedir = self._homedir
         self._root = '/'
         # FIXME WINDOWS: _root should be _server_homedir[0]:/
-        self._listener = SocketListener(self._run_server)
+        self._listener = SingleListener(self._run_server)
         self._listener.setDaemon(True)
         self._listener.start()
 
@@ -1015,7 +998,7 @@
         super(SFTPServerWithoutSSH, self).__init__()
         self._vendor = 'loopback'
 
-    def _run_server(self, sock):
+    def _run_server(self, sock, stop_event):
         class FakeChannel(object):
             def get_transport(self):
                 return self

=== modified file 'bzrlib/ui/__init__.py'
--- bzrlib/ui/__init__.py	2006-06-20 03:57:11 +0000
+++ bzrlib/ui/__init__.py	2006-05-04 08:39:32 +0000
@@ -31,7 +31,7 @@
 import sys
 
 import bzrlib.progress
-from bzrlib.symbol_versioning import (deprecated_method, zero_eight)
+from bzrlib.symbol_versioning import *
 
 
 class UIFactory(object):

=== modified file 'bzrlib/ui/text.py'
--- bzrlib/ui/text.py	2006-06-20 03:57:11 +0000
+++ bzrlib/ui/text.py	2006-05-09 01:57:17 +0000
@@ -23,8 +23,7 @@
 import sys
 
 import bzrlib.progress
-from bzrlib.symbol_versioning import (deprecated_method, 
-        zero_eight)
+from bzrlib.symbol_versioning import *
 from bzrlib.ui import CLIUIFactory
 
 

=== modified file 'bzrlib/uncommit.py'
--- bzrlib/uncommit.py	2006-06-20 03:57:11 +0000
+++ bzrlib/uncommit.py	2006-05-23 05:26:46 +0000
@@ -18,6 +18,7 @@
 """
 
 import os
+import bzrlib
 from bzrlib.errors import BoundBranchOutOfDate
 
 def test_remove(filename):
@@ -34,6 +35,7 @@
     :param verbose: Print each step as you do it
     :param revno: Remove back to this revision
     """
+    from bzrlib.atomicfile import AtomicFile
     unlockable = []
     try:
         if tree is not None:

=== modified file 'bzrlib/urlutils.py'
--- bzrlib/urlutils.py	2006-06-18 18:56:23 +0000
+++ bzrlib/urlutils.py	2006-06-15 21:07:12 +0000
@@ -19,7 +19,7 @@
 """A collection of function for handling URL operations."""
 
 import os
-from posixpath import split as _posix_split, normpath as _posix_normpath
+from posixpath import split as _posix_split
 import re
 import sys
 import urllib
@@ -165,48 +165,41 @@
     """
     # importing directly from posixpath allows us to test this 
     # on non-posix platforms
-    return 'file://' + escape(_posix_normpath(
-        bzrlib.osutils._posix_abspath(path)))
+    from posixpath import normpath
+    return 'file://' + escape(normpath(bzrlib.osutils._posix_abspath(path)))
 
 
 def _win32_local_path_from_url(url):
-    """Convert a url like file:///C:/path/to/foo into C:/path/to/foo"""
+    """Convert a url like file:///C|/path/to/foo into C:/path/to/foo"""
     if not url.startswith('file:///'):
         raise errors.InvalidURL(url, 'local urls must start with file:///')
     # We strip off all 3 slashes
     win32_url = url[len('file:///'):]
-    if (win32_url[0] not in ('abcdefghijklmnopqrstuvwxyz'
-                             'ABCDEFGHIJKLMNOPQRSTUVWXYZ')
+    if (win32_url[0] not in 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'
         or win32_url[1] not in  '|:'
         or win32_url[2] != '/'):
-        raise errors.InvalidURL(url, 'Win32 file urls start with'
-                ' file:///x:/, where x is a valid drive letter')
-    # Preferentially using .lower() because os.getcwd() returns
-    # paths with lowercase drive letters, and that helps
-    # bzrlib.osutils.relpath() work correctly
-    return win32_url[0].lower() + u':' + unescape(win32_url[2:])
+        raise errors.InvalidURL(url, 'Win32 file urls start with file:///X|/, where X is a valid drive letter')
+    # TODO: jam 20060426, we could .upper() or .lower() the drive letter
+    #       for better consistency.
+    return win32_url[0].upper() + u':' + unescape(win32_url[2:])
 
 
 def _win32_local_path_to_url(path):
-    """Convert a local path like ./foo into a URL like file:///C:/path/to/foo
+    """Convert a local path like ./foo into a URL like file:///C|/path/to/foo
 
     This also handles transforming escaping unicode characters, etc.
     """
     # importing directly from ntpath allows us to test this 
-    # on non-win32 platform
-    # FIXME: It turns out that on nt, ntpath.abspath uses nt._getfullpathname
-    #       which actually strips trailing space characters.
-    #       The worst part is that under linux ntpath.abspath has different
-    #       semantics, since 'nt' is not an available module.
+    # on non-win32 platforms
     win32_path = bzrlib.osutils._nt_normpath(
         bzrlib.osutils._win32_abspath(path)).replace('\\', '/')
-    return 'file:///' + win32_path[0].lower() + ':' + escape(win32_path[2:])
+    return 'file:///' + win32_path[0].upper() + ':' + escape(win32_path[2:])
 
 
 local_path_to_url = _posix_local_path_to_url
 local_path_from_url = _posix_local_path_from_url
 MIN_ABS_FILEURL_LENGTH = len('file:///')
-WIN32_MIN_ABS_FILEURL_LENGTH = len('file:///C:/')
+WIN32_MIN_ABS_FILEURL_LENGTH = len('file:///C|/')
 
 if sys.platform == 'win32':
     local_path_to_url = _win32_local_path_to_url
@@ -383,7 +376,7 @@
         file:///foo/      => file:///foo
         # This is unique on win32 platforms, and is the only URL
         # format which does it differently.
-        file:///c|/       => file:///c:/
+        file:///C|/       => file:///C|/
     """
     if not url.endswith('/'):
         # Nothing to do

=== modified file 'bzrlib/versionedfile.py'
--- bzrlib/versionedfile.py	2006-06-20 05:32:16 +0000
+++ bzrlib/versionedfile.py	2006-06-12 01:53:19 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 by Canonical Ltd
+# Copyright (C) 2005 by Canonical Ltd
 #
 # Authors:
 #   Johan Rydberg <jrydberg@gnu.org>
@@ -26,14 +26,11 @@
 
 import bzrlib.errors as errors
 from bzrlib.inter import InterObject
+from bzrlib.symbol_versioning import *
 from bzrlib.textmerge import TextMerge
 from bzrlib.transport.memory import MemoryTransport
 from bzrlib.tsort import topo_sort
 from bzrlib import ui
-from bzrlib.symbol_versioning import (deprecated_function,
-        deprecated_method,
-        zero_eight,
-        )
 
 
 class VersionedFile(object):
@@ -255,14 +252,6 @@
         return ''.join(self.get_lines(version_id))
     get_string = get_text
 
-    def get_texts(self, version_ids):
-        """Return the texts of listed versions as a list of strings.
-
-        Raises RevisionNotPresent if version is not present in
-        file history.
-        """
-        return [''.join(self.get_lines(v)) for v in version_ids]
-
     def get_lines(self, version_id):
         """Return version contents as a sequence of lines.
 

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2006-06-20 03:57:11 +0000
+++ bzrlib/weave.py	2006-06-10 00:21:11 +0000
@@ -73,7 +73,6 @@
 import os
 import sha
 import time
-import warnings
 
 from bzrlib.trace import mutter
 from bzrlib.errors import (WeaveError, WeaveFormatError, WeaveParentMismatch,
@@ -85,10 +84,7 @@
 import bzrlib.errors as errors
 from bzrlib.osutils import sha_strings
 import bzrlib.patiencediff
-from bzrlib.symbol_versioning import (deprecated_method,
-        deprecated_function,
-        zero_eight,
-        )
+from bzrlib.symbol_versioning import *
 from bzrlib.tsort import topo_sort
 from bzrlib.versionedfile import VersionedFile, InterVersionedFile
 from bzrlib.weavefile import _read_weave_v5, write_weave_v5
@@ -639,7 +635,7 @@
 
     def annotate(self, version_id):
         if isinstance(version_id, int):
-            warnings.warn('Weave.annotate(int) is deprecated. Please use version names'
+            warn('Weave.annotate(int) is deprecated. Please use version names'
                  ' in all circumstances as of 0.8',
                  DeprecationWarning,
                  stacklevel=2
@@ -1243,7 +1239,7 @@
     from bzrlib.weavefile import read_weave
 
     wf = file(weave_file, 'rb')
-    w = read_weave(wf)
+    w = read_weave(wf, WeaveVersionedFile)
     # FIXME: doesn't work on pipes
     weave_size = wf.tell()
 
@@ -1423,9 +1419,47 @@
         raise ValueError('unknown command %r' % cmd)
     
 
+
+def profile_main(argv):
+    import tempfile, hotshot, hotshot.stats
+
+    prof_f = tempfile.NamedTemporaryFile()
+
+    prof = hotshot.Profile(prof_f.name)
+
+    ret = prof.runcall(main, argv)
+    prof.close()
+
+    stats = hotshot.stats.load(prof_f.name)
+    #stats.strip_dirs()
+    stats.sort_stats('cumulative')
+    ## XXX: Might like to write to stderr or the trace file instead but
+    ## print_stats seems hardcoded to stdout
+    stats.print_stats(20)
+            
+    return ret
+
+
+def lsprofile_main(argv): 
+    from bzrlib.lsprof import profile
+    ret,stats = profile(main, argv)
+    stats.sort()
+    stats.pprint()
+    return ret
+
+
 if __name__ == '__main__':
     import sys
-    sys.exit(main(sys.argv))
+    if '--profile' in sys.argv:
+        args = sys.argv[:]
+        args.remove('--profile')
+        sys.exit(profile_main(args))
+    elif '--lsprof' in sys.argv:
+        args = sys.argv[:]
+        args.remove('--lsprof')
+        sys.exit(lsprofile_main(args))
+    else:
+        sys.exit(main(sys.argv))
 
 
 class InterWeave(InterVersionedFile):

=== modified file 'bzrlib/weave_commands.py'
--- bzrlib/weave_commands.py	2006-06-20 03:57:11 +0000
+++ bzrlib/weave_commands.py	2006-03-24 11:12:04 +0000
@@ -23,7 +23,7 @@
 import sys
 
 from bzrlib.commands import Command
-from bzrlib.trace import warning
+from bzrlib.trace import mutter, warning
 
 class cmd_weave_list(Command):
     """List the revision ids present in a weave, in alphabetical order"""
@@ -64,7 +64,7 @@
     takes_args = ['weave_file', 'revision_a', 'revision_b']
 
     def run(self, weave_file, revision_a, revision_b):
-        from bzrlib.weavefile import read_weave
+        from bzrlib.weavefile import read_weave, write_weave
         w = read_weave(file(weave_file, 'rb'))
         for state, line in w.plan_merge(revision_a, revision_b):
             # make sure to print every line with a newline, even if it doesn't
@@ -84,7 +84,7 @@
     takes_args = ['weave_file', 'revision_a', 'revision_b']
 
     def run(self, weave_file, revision_a, revision_b):
-        from bzrlib.weavefile import read_weave
+        from bzrlib.weavefile import read_weave, write_weave
         w = read_weave(file(weave_file, 'rb'))
         p = w.plan_merge(revision_a, revision_b)
         sys.stdout.writelines(w.weave_merge(p))

=== modified file 'bzrlib/win32console.py'
--- bzrlib/win32console.py	2006-06-20 03:57:11 +0000
+++ bzrlib/win32console.py	2006-05-09 07:16:38 +0000
@@ -7,12 +7,10 @@
 
 import struct
 
-# We can cope without it; use a separate variable to help pyflakes
 try:
    import ctypes
-   has_ctypes = True
 except ImportError:
-    has_ctypes = False
+   ctypes = None
 
 
 WIN32_STDIN_HANDLE = -10
@@ -29,7 +27,7 @@
 
    Dependencies: ctypes should be installed.
    """
-   if not has_ctypes:
+   if ctypes is None:
        # no ctypes is found
        return (defaultx, defaulty)
 

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2006-06-20 07:55:43 +0000
+++ bzrlib/workingtree.py	2006-06-16 15:25:15 +0000
@@ -49,9 +49,10 @@
 import re
 import stat
 from time import time
-import warnings
 
 from bzrlib.atomicfile import AtomicFile
+from bzrlib.branch import (Branch,
+                           quotefn)
 from bzrlib.conflicts import Conflict, ConflictList, CONFLICT_SUFFIXES
 import bzrlib.bzrdir as bzrdir
 from bzrlib.decorators import needs_read_lock, needs_write_lock
@@ -59,6 +60,7 @@
 from bzrlib.errors import (BzrCheckError,
                            BzrError,
                            ConflictFormatError,
+                           DivergedBranches,
                            WeaveRevisionNotPresent,
                            NotBranchError,
                            NoSuchFile,
@@ -90,13 +92,7 @@
 from bzrlib.progress import DummyProgress, ProgressPhase
 from bzrlib.revision import NULL_REVISION
 from bzrlib.rio import RioReader, rio_file, Stanza
-from bzrlib.symbol_versioning import (deprecated_passed,
-        deprecated_method,
-        deprecated_function,
-        DEPRECATED_PARAMETER,
-        zero_eight,
-        )
-
+from bzrlib.symbol_versioning import *
 from bzrlib.textui import show_status
 import bzrlib.tree
 from bzrlib.transform import build_tree
@@ -235,7 +231,7 @@
         self.bzrdir = _bzrdir
         if not _internal:
             # not created via open etc.
-            warnings.warn("WorkingTree() is deprecated as of bzr version 0.8. "
+            warn("WorkingTree() is deprecated as of bzr version 0.8. "
                  "Please use bzrdir.open_workingtree or WorkingTree.open().",
                  DeprecationWarning,
                  stacklevel=2)
@@ -255,7 +251,7 @@
         mutter("opening working tree %r", basedir)
         if deprecated_passed(branch):
             if not _internal:
-                warnings.warn("WorkingTree(..., branch=XXX) is deprecated as of bzr 0.8."
+                warn("WorkingTree(..., branch=XXX) is deprecated as of bzr 0.8."
                      " Please use bzrdir.open_workingtree() or"
                      " WorkingTree.open().",
                      DeprecationWarning,
@@ -264,6 +260,8 @@
             self._branch = branch
         else:
             self._branch = self.bzrdir.open_branch()
+        assert isinstance(self.branch, Branch), \
+            "branch %r is not a Branch" % self.branch
         self.basedir = realpath(basedir)
         # if branch is at our basedir and is a format 6 or less
         if isinstance(self._format, WorkingTreeFormat2):
@@ -419,7 +417,7 @@
         XXX: When BzrDir is present, these should be created through that 
         interface instead.
         """
-        warnings.warn('delete WorkingTree.create', stacklevel=3)
+        warn('delete WorkingTree.create', stacklevel=3)
         transport = get_transport(directory)
         if branch.bzrdir.root_transport.base == transport.base:
             # same dir 
@@ -611,7 +609,7 @@
         inv = self.read_working_inventory()
         for f,file_id in zip(files, ids):
             if self.is_control_filename(f):
-                raise errors.ForbiddenControlFileError(filename=f)
+                raise BzrError("cannot add control file %s" % quotefn(f))
 
             fp = splitpath(f)
 
@@ -619,13 +617,19 @@
                 raise BzrError("cannot add top-level %r" % f)
 
             fullpath = normpath(self.abspath(f))
+
             try:
                 kind = file_kind(fullpath)
             except OSError, e:
                 if e.errno == errno.ENOENT:
                     raise NoSuchFile(fullpath)
+                # maybe something better?
+                raise BzrError('cannot add: not a regular file, symlink or directory: %s' % quotefn(f))
+
             if not InventoryEntry.versionable_kind(kind):
-                raise errors.BadFileKindError(filename=f, kind=kind)
+                raise BzrError('cannot add: not a versionable file ('
+                               'i.e. regular file, symlink or directory): %s' % quotefn(f))
+
             if file_id is None:
                 inv.add_path(f, kind=kind)
             else:
@@ -928,6 +932,19 @@
 
         These are files in the working directory that are not versioned or
         control files or ignored.
+        
+        >>> from bzrlib.bzrdir import ScratchDir
+        >>> d = ScratchDir(files=['foo', 'foo~'])
+        >>> b = d.open_branch()
+        >>> tree = d.open_workingtree()
+        >>> map(str, tree.unknowns())
+        ['foo']
+        >>> tree.add('foo')
+        >>> list(b.unknowns())
+        []
+        >>> tree.remove('foo')
+        >>> list(b.unknowns())
+        [u'foo']
         """
         for subp in self.extras():
             if not self.is_ignored(subp):
@@ -1268,13 +1285,14 @@
                 # TODO: Perhaps make this just a warning, and continue?
                 # This tends to happen when 
                 raise NotVersionedError(path=f)
+            mutter("remove inventory entry %s {%s}", quotefn(f), fid)
             if verbose:
                 # having remove it, it must be either ignored or unknown
                 if self.is_ignored(f):
                     new_status = 'I'
                 else:
                     new_status = '?'
-                show_status(new_status, inv[fid].kind, f, to_file=to_file)
+                show_status(new_status, inv[fid].kind, quotefn(f), to_file=to_file)
             del inv[fid]
 
         self._write_inventory(inv)
@@ -1568,7 +1586,7 @@
         except NoSuchFile:
             raise errors.NoWorkingTree(base=transport.base)
         except KeyError:
-            raise errors.UnknownFormatError(format=format_string)
+            raise errors.UnknownFormatError(format_string)
 
     @classmethod
     def get_default_format(klass):

=== modified file 'bzrlib/xml5.py'
--- bzrlib/xml5.py	2006-06-20 03:57:11 +0000
+++ bzrlib/xml5.py	2006-05-24 08:26:20 +0000
@@ -1,5 +1,3 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
-#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
@@ -15,10 +13,10 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-from bzrlib.xml_serializer import SubElement, Element, Serializer
+from bzrlib.xml_serializer import ElementTree, SubElement, Element, Serializer
 from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 import bzrlib.inventory as inventory
-from bzrlib.revision import Revision
+from bzrlib.revision import Revision        
 from bzrlib.errors import BzrError
 
 
@@ -199,11 +197,11 @@
             return
         for prop_elt in props_elt:
             assert prop_elt.tag == 'property', \
-                "bad tag under properties list: %r" % prop_elt.tag
+                "bad tag under properties list: %r" % p.tag
             name = prop_elt.get('name')
             value = prop_elt.text
             assert name not in rev.properties, \
-                "repeated property %r" % name
+                "repeated property %r" % p.name
             rev.properties[name] = value
 
 

=== modified file 'profile_imports.py'
--- profile_imports.py	2006-06-19 14:40:19 +0000
+++ profile_imports.py	2006-06-18 02:05:12 +0000
@@ -1,5 +1,4 @@
 # Copyright (C) 2006 by Canonical Ltd
-# Written by John Arbash Meinel <john@arbash-meinel.com>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,86 +14,23 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""A custom importer and regex compiler which logs time spent."""
+"""A custom importer and regex compiler which logs time."""
 
-import sre
+import os
 import sys
 import time
-
-
-_parent_stack = []
-_total_stack = {}
-_info = {}
-_cur_id = 0
-
-
-def stack_add(name, frame_name, frame_lineno, scope_name=None):
-    """Start a new record on the stack"""
-    global _cur_id
-    _cur_id += 1
-    this_stack = (_cur_id, name)
-
-    if _parent_stack:
-        _total_stack[_parent_stack[-1]].append(this_stack)
-    _total_stack[this_stack] = []
-    _parent_stack.append(this_stack)
-    _info[this_stack] = [len(_parent_stack)-1, frame_name, frame_lineno, scope_name]
-
-    return this_stack
-
-
-def stack_finish(this, cost):
-    """Finish a given entry, and record its cost in time"""
-    global _parent_stack
-
-    assert _parent_stack[-1] == this, \
-        'import stack does not end with this %s: %s' % (this, _parent_stack)
-    _parent_stack.pop()
-    _info[this].append(cost)
-
-
-def log_stack_info(out_file, sorted=True, hide_fast=True):
-    # Find all of the roots with import = 0
-    out_file.write(' cum  inline name\t\t\t\t\t\tframe\n')
-    todo = [(value[-1], key) for key,value in _info.iteritems() if value[0] == 0]
-
-    if sorted:
-        todo.sort()
-
-    while todo:
-        cum_time, cur = todo.pop()
-        children = _total_stack[cur]
-
-        c_times = []
-
-        info = _info[cur]
-        if hide_fast and info[-1] < 0.0001:
-            continue
-
-        # Compute the module time by removing the children times
-        mod_time = info[-1]
-        for child in children:
-            c_info = _info[child]
-            mod_time -= c_info[-1]
-            c_times.append((c_info[-1], child))
-
-        # indent, cum_time, mod_time, name,
-        # scope_name, frame_name, frame_lineno
-        out_file.write('%5.1f %5.1f %s %-35s\t@ %s:%d\n'
-            % (info[-1]*1000., mod_time*1000., '+'*info[0], 
-               cur[1][:40], info[1], info[2]))
-
-        if sorted:
-            c_times.sort()
-        else:
-            c_times.reverse()
-        todo.extend(c_times)
-
+import sre
+
+
+_import_logfile = sys.stderr
+_compile_logfile = sys.stderr
 
 _real_import = __import__
 
-def timed_import(name, globals, locals, fromlist):
+def _custom_import(name, globals, locals, fromlist):
     """Wrap around standard importer to log import time"""
+    if _import_logfile is None:
+        return _real_import(name, globals, locals, fromlist)
 
     scope_name = globals.get('__name__', None)
     if scope_name is None:
@@ -110,6 +46,11 @@
         loc = scope_name.find('python2.4')
         if loc != -1:
             scope_name = scope_name[loc:]
+                
+    # Do the import
+    tstart = time.time()
+    mod = _real_import(name, globals, locals, fromlist)
+    tload = time.time()-tstart
 
     # Figure out the frame that is doing the importing
     frame = sys._getframe(1)
@@ -124,50 +65,48 @@
         frame_name = frame.f_globals.get('__name__', '<unknown>')
     frame_lineno = frame.f_lineno
 
-    this = stack_add(name+extra, frame_name, frame_lineno, scope_name)
-
-    tstart = time.time()
-    try:
-        # Do the import
-        mod = _real_import(name, globals, locals, fromlist)
-    finally:
-        tload = time.time()-tstart
-        stack_finish(this, tload)
-
+    # Log the import
+    _import_logfile.write('%3.0fms %-24s\tfor %-24s\t@ %s:%d%s\n' 
+        % ((time.time()-tstart)*1000, name, scope_name,
+            frame_name, frame_lineno, extra))
+
+    # If the import took a long time, log the stack that generated
+    # this import. Especially necessary for demandloaded code
+    if tload > 0.01:
+        stack = []
+        for fnum in range(cur_frame+1, cur_frame+10):
+            try:
+                f = sys._getframe(fnum)
+            except ValueError:
+                break
+            stack.append('%s:%i' 
+                    % (f.f_globals.get('__name__', '<unknown>'),
+                        f.f_lineno)
+                    )
+        if stack:
+            _import_logfile.write('\t' + ' '.join(stack) + '\n')
     return mod
 
 
 _real_compile = sre._compile
 
-def timed_compile(*args, **kwargs):
+def _custom_compile(*args, **kwargs):
     """Log how long it takes to compile a regex"""
+    if _compile_logfile is None:
+        return _real_compile(*args, **kwargs)
 
+    # Measure the compile time
+    tstart = time.time()
+    comp = _real_compile(*args, **kwargs)
+    
     # And who is requesting this?
     frame = sys._getframe(2)
     frame_name = frame.f_globals.get('__name__', '<unknown>')
     frame_lineno = frame.f_lineno
-
-    this = stack_add(repr(args[0]), frame_name, frame_lineno)
-
-    tstart = time.time()
-    try:
-        # Measure the compile time
-        comp = _real_compile(*args, **kwargs)
-    finally:
-        tcompile = time.time() - tstart
-        stack_finish(this, tcompile)
-
+    _compile_logfile.write('%3.0fms %-40r\t@ %s:%d\n'
+        % ((time.time()-tstart)*1000, args[0][:40], 
+            frame_name, frame_lineno))
     return comp
 
-
-def install():
-    """Install the hooks for measuring import and regex compile time."""
-    __builtins__['__import__'] = timed_import
-    sre._compile = timed_compile
-
-
-def uninstall():
-    """Remove the import and regex compile timing hooks."""
-    __builtins__['__import__'] = _real_import
-    sre._compile = _real_compile
-
+__builtins__.__import__ = _custom_import
+sre._compile = _custom_compile

